; Script-Fu 8_motifs.scm
; Download : 
;
;	Copyright (C) 2013 samj ( http://aljacom.com/~gmic/ )
;
;	Licence GPL
;		Ce fichier est le Script-Fu "8_motifs.scm" pour Gimp. 
;		Ce Script-Fu "8_motifs.scm" est un logiciel libre ; vous pouvez le redistribuer ou le modifier suivant les termes de la GNU General Public License
;		telle que publie par la Free Software Foundation ; soit la version 3 de la licence, soit ( votre gr) toute version ultrieure.
;		Ce Script-Fu "8_motifs.scm" est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; 
;		pas mme la garantie implicite de COMMERCIABILISABILIT ni d'ADQUATION  UN OBJECTIF PARTICULIER.
;		Consultez la GNU General Public License pour plus de dtails.
;		Vous devez avoir reu une copie de la GNU General Public License en mme temps que GIMP ; si ce n'est pas le cas, consultez <http://www.gnu.org/licenses>
;
;	Ce fichier 8_motifs.scm est dit avec Notepad++    http://notepad-plus-plus.org/
;
;
;	Version 20130404  ( faire : fonction si script intressant)
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;
;	Accs sur l'image par :
;
;	Filtres > Mappage > 8 Motifs-Patterns ...
;	Filters > Map > 8 Motifs-Patterns ...
;
;
;
;
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;

		
(define	
	(
		huit_motifs_samj
		image
		drawable
		Soften
		Motif_Pattern_1
		Motif_Pattern_2
		Motif_Pattern_3
		Motif_Pattern_4
		Motif_Pattern_5
		Motif_Pattern_6
		Motif_Pattern_7
		Motif_Pattern_8
		Back_Ground_Color
		Use_Back_Ground_Color
		Pattern_From_Image
		flatten

		
	)
	(let* 
		(

			(message (car (gimp-message-get-handler)))
			(old_context_transform_direction (car (gimp-context-get-transform-direction)))
			(old_context_interpolation (car (gimp-context-get-interpolation)))
			(old_context_recursion (car (gimp-context-get-transform-recursion)))
			(old_context_transform_resize (car (gimp-context-get-transform-resize)))
			(old-fg (car (gimp-context-get-foreground)))
			(old-bg (car (gimp-context-get-background)))

			(old_context-antialias (car (gimp-context-get-antialias)))
			(old_context-feather (car (gimp-context-get-feather)))
			(old_context-feather-radiusx (car (gimp-context-get-feather-radius)))
			(old_context-feather-radiusy (cadr (gimp-context-get-feather-radius)))
			(old_context-sample-merged (car (gimp-context-get-sample-merged)))
			(old_ontext-sample-criterion (car (gimp-context-get-sample-criterion)))
			(old_context-sample-threshold (car (gimp-context-get-sample-threshold)))
			(old_context-sample-transparent (car (gimp-context-get-sample-transparent)))

			(old-brush-size (car (gimp-context-get-brush-size)))
			(old-brush-aspect-ratio (car (gimp-context-get-brush-aspect-ratio)))
			(old-brush-angle (car (gimp-context-get-brush-angle)))
			(old-brush-name (car (gimp-context-get-brush)))
			
			(old-pattern (car (gimp-context-get-pattern)))

			(width (car (gimp-image-width image)))
			(height (car (gimp-image-height image)))

			(transparence (car (gimp-drawable-has-alpha drawable)))

			(selection_en_cours)
			(nouvelle_image)
			(calque_copie)
			(copier_visible)
			(buffer-name "copier_visible")
			(rvb 0)
			(selection_bounds 0)
			(select_exist 0)
			(select_offset_x 0)
			(select_offset_y 0)
			(select_width 0)
			(select_height 0)

			(sortie_boucle 0)

			(calque_fond)
			
			(calque_8_motifs)

			(image_motif_temporaire)
			(calque_motif_temporaire)
			(dim_motif_temporaire (+ 4 (truncate (/ (+ width height) 100) ) ) )


			(Nb_couleurs_trouvees 0)
			
			(largeur_motif_image (truncate (/ width 8) ) )
			(hauteur_motif_image (truncate (/ height 8) ) )

		)


		(gimp-context-set-antialias FALSE)
		(gimp-context-set-feather FALSE)
		(gimp-context-set-feather-radius 0 0)
		(gimp-context-set-sample-merged FALSE)
		(gimp-context-set-sample-criterion 0)
		(gimp-context-set-sample-threshold 0)
		(gimp-context-set-sample-transparent FALSE)

		(gimp-context-set-transform-direction TRANSFORM-FORWARD)
		(gimp-context-set-interpolation 2)
		(gimp-context-set-transform-recursion 3)
		(gimp-context-set-transform-resize TRANSFORM-RESIZE-ADJUST)
		
		(gimp-context-set-paint-mode 0) ;

		
		(gimp-undo-push-group-start image)

		(gimp-selection-none image)





;******************************************************************************************************
; 
;******************************************************************************************************


		(set! copier_visible (car (gimp-edit-named-copy-visible image buffer-name)))

		; crer une nouvelle image rgb
		(set! nouvelle_image (car (gimp-image-new width height 0)))

		(gimp-undo-push-group-start nouvelle_image)

		; crer le premier calque
		(set! calque_copie (car (gimp-layer-new nouvelle_image width height 0 "calque_copie" 100 0)))

		(gimp-image-insert-layer nouvelle_image calque_copie -1 0)

		(gimp-image-select-rectangle nouvelle_image 0  width height 0 0 )

		(set! selection_en_cours (car (gimp-edit-named-paste calque_copie copier_visible 0)))

		(gimp-floating-sel-anchor selection_en_cours)

		(gimp-selection-none nouvelle_image)

		(gimp-layer-add-alpha calque_copie)

		(gimp-levels-stretch calque_copie)

		(gimp-equalize calque_copie TRUE)

		; ajuster taille image  la taille des calques
		(gimp-image-resize-to-layers nouvelle_image)

		(set! calque_copie (car (gimp-image-get-active-layer nouvelle_image)))

		(gimp-desaturate-full calque_copie 1)

		(gimp-posterize calque_copie 6)

		(plug-in-gauss 1 nouvelle_image calque_copie 4 4 1)

		(if (= Use_Back_Ground_Color 0)
			(gimp-convert-indexed nouvelle_image 0 0 8 1 1 "")
			;else
			(begin
				(gimp-convert-indexed nouvelle_image 0 0 9 1 1 "")
				(set! Nb_couleurs_trouvees -1)
			)
		)

		(gimp-image-convert-grayscale nouvelle_image)

		(gimp-image-convert-rgb nouvelle_image)

		(gimp-context-set-background Back_Ground_Color)

		; ajouter un calque  la couleur du fond
		(set! calque_fond (car (gimp-layer-new nouvelle_image width height 0 "calque_fond" 100 0)))

		(gimp-image-insert-layer nouvelle_image calque_fond -1 0)

		(gimp-drawable-fill calque_fond 1)

		(gimp-item-set-visible calque_fond TRUE)

		; ajouter le calque 8 couleurs
		(set! calque_8_motifs (car (gimp-layer-new nouvelle_image width height 0 "calque_8_motifs" 100 0)))

		(gimp-image-insert-layer nouvelle_image calque_8_motifs -1 0)

		(gimp-item-set-visible calque_8_motifs TRUE)

		(gimp-layer-add-alpha calque_8_motifs)

		(gimp-drawable-fill calque_8_motifs 3)




		; boucle pour trouver les couleurs et faire une slection par couleur , un chemin
		(while
			(= sortie_boucle 0)
				(begin

					(gimp-image-select-color nouvelle_image 0 calque_copie (list rvb rvb rvb))
					(gimp-selection-feather nouvelle_image 0)

					(set! selection_bounds (gimp-selection-bounds nouvelle_image))
					(set! select_exist (car selection_bounds))
					;(set! select_offset_x (cadr selection_bounds))
					;(set! select_offset_y (caddr selection_bounds))
					;(set! select_width (- (cadr (cddr selection_bounds)) select_offset_x))
					;(set! select_height (- (caddr (cddr selection_bounds)) select_offset_y))
					;(gimp-message (number->string select_exist))

					(if (= select_exist 1)
						(begin

							(if (> Soften 0)
								(begin
									(gimp-selection-grow nouvelle_image Soften)
									(gimp-selection-shrink nouvelle_image Soften)
								)
							)

							(set! Nb_couleurs_trouvees (+ Nb_couleurs_trouvees 1) )
							;(gimp-message (number->string Nb_couleurs_trouvees))

							(if (= Nb_couleurs_trouvees 1)
								(begin
									(if (= Pattern_From_Image 0)
										(begin
											(gimp-context-set-pattern Motif_Pattern_1)
										)
										;else
										(begin
											(gimp-selection-none image)
											(gimp-image-select-rectangle image 0 (* largeur_motif_image (- Nb_couleurs_trouvees 1) ) (* hauteur_motif_image (- Nb_couleurs_trouvees 1) ) largeur_motif_image hauteur_motif_image)
											(gimp-edit-copy-visible image)
											(set! image_motif_temporaire (car (gimp-image-new largeur_motif_image hauteur_motif_image 0)))
											(set! calque_motif_temporaire (car (gimp-layer-new image_motif_temporaire largeur_motif_image hauteur_motif_image 0 "calque_motif_temporaire" 100 0)))
											(gimp-image-insert-layer image_motif_temporaire calque_motif_temporaire -1 0)
											(gimp-item-set-visible calque_motif_temporaire TRUE)
											(gimp-image-select-rectangle image_motif_temporaire 0  largeur_motif_image hauteur_motif_image 0 0 )
											(gimp-floating-sel-anchor (car (gimp-edit-paste calque_motif_temporaire 1) ) )
											(gimp-image-resize image_motif_temporaire dim_motif_temporaire dim_motif_temporaire 0 0)
											(set! calque_motif_temporaire (car (gimp-image-get-active-layer image_motif_temporaire)))
											(gimp-layer-resize-to-image-size calque_motif_temporaire)
											(gimp-levels-stretch calque_motif_temporaire)
											(if (= Pattern_From_Image 2)
												(begin
													(plug-in-gauss 1 image_motif_temporaire calque_motif_temporaire 16 16 1)
													(gimp-invert calque_motif_temporaire)
												)
											)
											(plug-in-make-seamless 1 image_motif_temporaire calque_motif_temporaire)
											(gimp-edit-copy-visible image_motif_temporaire)
											; astuce de RobA  http://www.gimpchat.com/viewtopic.php?f=8&t=1221&start=40 pour que le presse-papiers devienne le motif sans avoir  choisir le nom qui varie selon les langues de Gimp
											(gimp-context-set-pattern (list-ref (cadr (gimp-patterns-get-list "")) 0)) ; set patten to clipboard (first in list)
											(gimp-selection-none image)
										)
									)
								)
							)

							(if (= Nb_couleurs_trouvees 2)
								(begin
									(if (= Pattern_From_Image 0)
										(begin
											(gimp-context-set-pattern Motif_Pattern_2)
										)
										;else
										(begin
											(gimp-selection-none image)
											(gimp-image-select-rectangle image 0 (* largeur_motif_image (- Nb_couleurs_trouvees 1) ) (* hauteur_motif_image (- Nb_couleurs_trouvees 1) ) largeur_motif_image hauteur_motif_image)
											(gimp-edit-copy-visible image)
											(set! image_motif_temporaire (car (gimp-image-new largeur_motif_image hauteur_motif_image 0)))
											(set! calque_motif_temporaire (car (gimp-layer-new image_motif_temporaire largeur_motif_image hauteur_motif_image 0 "calque_motif_temporaire" 100 0)))
											(gimp-image-insert-layer image_motif_temporaire calque_motif_temporaire -1 0)
											(gimp-item-set-visible calque_motif_temporaire TRUE)
											(gimp-image-select-rectangle image_motif_temporaire 0  largeur_motif_image hauteur_motif_image 0 0 )
											(gimp-floating-sel-anchor (car (gimp-edit-paste calque_motif_temporaire 1) ) )
											(gimp-image-resize image_motif_temporaire dim_motif_temporaire dim_motif_temporaire 0 0)
											(set! calque_motif_temporaire (car (gimp-image-get-active-layer image_motif_temporaire)))
											(gimp-layer-resize-to-image-size calque_motif_temporaire)
											(gimp-levels-stretch calque_motif_temporaire)
											(if (= Pattern_From_Image 2)
												(begin
													(plug-in-gauss 1 image_motif_temporaire calque_motif_temporaire 16 16 1)
													(gimp-invert calque_motif_temporaire)
												)
											)
											(plug-in-make-seamless 1 image_motif_temporaire calque_motif_temporaire)
											(gimp-edit-copy-visible image_motif_temporaire)
											; astuce de RobA  http://www.gimpchat.com/viewtopic.php?f=8&t=1221&start=40 pour que le presse-papiers devienne le motif sans avoir  choisir le nom qui varie selon les langues de Gimp
											(gimp-context-set-pattern (list-ref (cadr (gimp-patterns-get-list "")) 0)) ; set patten to clipboard (first in list)
											(gimp-selection-none image)
											(gimp-image-delete image_motif_temporaire)
										)
									)
								)
							)

							(if (= Nb_couleurs_trouvees 3)
								(begin
									(if (= Pattern_From_Image 0)
										(begin
											(gimp-context-set-pattern Motif_Pattern_3)
										)
										;else
										(begin
											(gimp-selection-none image)
											(gimp-image-select-rectangle image 0 (* largeur_motif_image (- Nb_couleurs_trouvees 1) ) (* hauteur_motif_image (- Nb_couleurs_trouvees 1) ) largeur_motif_image hauteur_motif_image)
											(gimp-edit-copy-visible image)
											(set! image_motif_temporaire (car (gimp-image-new largeur_motif_image hauteur_motif_image 0)))
											(set! calque_motif_temporaire (car (gimp-layer-new image_motif_temporaire largeur_motif_image hauteur_motif_image 0 "calque_motif_temporaire" 100 0)))
											(gimp-image-insert-layer image_motif_temporaire calque_motif_temporaire -1 0)
											(gimp-item-set-visible calque_motif_temporaire TRUE)
											(gimp-image-select-rectangle image_motif_temporaire 0  largeur_motif_image hauteur_motif_image 0 0 )
											(gimp-floating-sel-anchor (car (gimp-edit-paste calque_motif_temporaire 1) ) )
											(gimp-image-resize image_motif_temporaire dim_motif_temporaire dim_motif_temporaire 0 0)
											(set! calque_motif_temporaire (car (gimp-image-get-active-layer image_motif_temporaire)))
											(gimp-layer-resize-to-image-size calque_motif_temporaire)
											(gimp-levels-stretch calque_motif_temporaire)
											(if (= Pattern_From_Image 2)
												(begin
													(plug-in-gauss 1 image_motif_temporaire calque_motif_temporaire 16 16 1)
													(gimp-invert calque_motif_temporaire)
												)
											)
											(plug-in-make-seamless 1 image_motif_temporaire calque_motif_temporaire)
											(gimp-edit-copy-visible image_motif_temporaire)
											; astuce de RobA  http://www.gimpchat.com/viewtopic.php?f=8&t=1221&start=40 pour que le presse-papiers devienne le motif sans avoir  choisir le nom qui varie selon les langues de Gimp
											(gimp-context-set-pattern (list-ref (cadr (gimp-patterns-get-list "")) 0)) ; set patten to clipboard (first in list)
											(gimp-selection-none image)
											(gimp-image-delete image_motif_temporaire)
										)
									)
								)
							)

							(if (= Nb_couleurs_trouvees 4)
								(begin
									(if (= Pattern_From_Image 0)
										(begin
											(gimp-context-set-pattern Motif_Pattern_4)
										)
										;else
										(begin
											(gimp-selection-none image)
											(gimp-image-select-rectangle image 0 (* largeur_motif_image (- Nb_couleurs_trouvees 1) ) (* hauteur_motif_image (- Nb_couleurs_trouvees 1) ) largeur_motif_image hauteur_motif_image)
											(gimp-edit-copy-visible image)
											(set! image_motif_temporaire (car (gimp-image-new largeur_motif_image hauteur_motif_image 0)))
											(set! calque_motif_temporaire (car (gimp-layer-new image_motif_temporaire largeur_motif_image hauteur_motif_image 0 "calque_motif_temporaire" 100 0)))
											(gimp-image-insert-layer image_motif_temporaire calque_motif_temporaire -1 0)
											(gimp-item-set-visible calque_motif_temporaire TRUE)
											(gimp-image-select-rectangle image_motif_temporaire 0  largeur_motif_image hauteur_motif_image 0 0 )
											(gimp-floating-sel-anchor (car (gimp-edit-paste calque_motif_temporaire 1) ) )
											(gimp-image-resize image_motif_temporaire dim_motif_temporaire dim_motif_temporaire 0 0)
											(set! calque_motif_temporaire (car (gimp-image-get-active-layer image_motif_temporaire)))
											(gimp-layer-resize-to-image-size calque_motif_temporaire)
											(gimp-levels-stretch calque_motif_temporaire)
											(if (= Pattern_From_Image 2)
												(begin
													(plug-in-gauss 1 image_motif_temporaire calque_motif_temporaire 16 16 1)
													(gimp-invert calque_motif_temporaire)
												)
											)
											(plug-in-make-seamless 1 image_motif_temporaire calque_motif_temporaire)
											(gimp-edit-copy-visible image_motif_temporaire)
											; astuce de RobA  http://www.gimpchat.com/viewtopic.php?f=8&t=1221&start=40 pour que le presse-papiers devienne le motif sans avoir  choisir le nom qui varie selon les langues de Gimp
											(gimp-context-set-pattern (list-ref (cadr (gimp-patterns-get-list "")) 0)) ; set patten to clipboard (first in list)
											(gimp-selection-none image)
											(gimp-image-delete image_motif_temporaire)
										)
									)
								)
							)

							(if (= Nb_couleurs_trouvees 5)
								(begin
									(if (= Pattern_From_Image 0)
										(begin
											(gimp-context-set-pattern Motif_Pattern_5)
										)
										;else
										(begin
											(gimp-selection-none image)
											(gimp-image-select-rectangle image 0 (* largeur_motif_image (- Nb_couleurs_trouvees 1) ) (* hauteur_motif_image (- Nb_couleurs_trouvees 1) ) largeur_motif_image hauteur_motif_image)
											(gimp-edit-copy-visible image)
											(set! image_motif_temporaire (car (gimp-image-new largeur_motif_image hauteur_motif_image 0)))
											(set! calque_motif_temporaire (car (gimp-layer-new image_motif_temporaire largeur_motif_image hauteur_motif_image 0 "calque_motif_temporaire" 100 0)))
											(gimp-image-insert-layer image_motif_temporaire calque_motif_temporaire -1 0)
											(gimp-item-set-visible calque_motif_temporaire TRUE)
											(gimp-image-select-rectangle image_motif_temporaire 0  largeur_motif_image hauteur_motif_image 0 0 )
											(gimp-floating-sel-anchor (car (gimp-edit-paste calque_motif_temporaire 1) ) )
											(gimp-image-resize image_motif_temporaire dim_motif_temporaire dim_motif_temporaire 0 0)
											(set! calque_motif_temporaire (car (gimp-image-get-active-layer image_motif_temporaire)))
											(gimp-layer-resize-to-image-size calque_motif_temporaire)
											(gimp-levels-stretch calque_motif_temporaire)
											(if (= Pattern_From_Image 2)
												(begin
													(plug-in-gauss 1 image_motif_temporaire calque_motif_temporaire 16 16 1)
													(gimp-invert calque_motif_temporaire)
												)
											)
											(plug-in-make-seamless 1 image_motif_temporaire calque_motif_temporaire)
											(gimp-edit-copy-visible image_motif_temporaire)
											; astuce de RobA  http://www.gimpchat.com/viewtopic.php?f=8&t=1221&start=40 pour que le presse-papiers devienne le motif sans avoir  choisir le nom qui varie selon les langues de Gimp
											(gimp-context-set-pattern (list-ref (cadr (gimp-patterns-get-list "")) 0)) ; set patten to clipboard (first in list)
											(gimp-selection-none image)
											(gimp-image-delete image_motif_temporaire)
										)
									)
								)
							)

							(if (= Nb_couleurs_trouvees 6)
								(begin
									(if (= Pattern_From_Image 0)
										(begin
											(gimp-context-set-pattern Motif_Pattern_6)
										)
										;else
										(begin
											(gimp-selection-none image)
											(gimp-image-select-rectangle image 0 (* largeur_motif_image (- Nb_couleurs_trouvees 1) ) (* hauteur_motif_image (- Nb_couleurs_trouvees 1) ) largeur_motif_image hauteur_motif_image)
											(gimp-edit-copy-visible image)
											(set! image_motif_temporaire (car (gimp-image-new largeur_motif_image hauteur_motif_image 0)))
											(set! calque_motif_temporaire (car (gimp-layer-new image_motif_temporaire largeur_motif_image hauteur_motif_image 0 "calque_motif_temporaire" 100 0)))
											(gimp-image-insert-layer image_motif_temporaire calque_motif_temporaire -1 0)
											(gimp-item-set-visible calque_motif_temporaire TRUE)
											(gimp-image-select-rectangle image_motif_temporaire 0  largeur_motif_image hauteur_motif_image 0 0 )
											(gimp-floating-sel-anchor (car (gimp-edit-paste calque_motif_temporaire 1) ) )
											(gimp-image-resize image_motif_temporaire dim_motif_temporaire dim_motif_temporaire 0 0)
											(set! calque_motif_temporaire (car (gimp-image-get-active-layer image_motif_temporaire)))
											(gimp-layer-resize-to-image-size calque_motif_temporaire)
											(gimp-levels-stretch calque_motif_temporaire)
											(if (= Pattern_From_Image 2)
												(begin
													(plug-in-gauss 1 image_motif_temporaire calque_motif_temporaire 16 16 1)
													(gimp-invert calque_motif_temporaire)
												)
											)
											(plug-in-make-seamless 1 image_motif_temporaire calque_motif_temporaire)
											(gimp-edit-copy-visible image_motif_temporaire)
											; astuce de RobA  http://www.gimpchat.com/viewtopic.php?f=8&t=1221&start=40 pour que le presse-papiers devienne le motif sans avoir  choisir le nom qui varie selon les langues de Gimp
											(gimp-context-set-pattern (list-ref (cadr (gimp-patterns-get-list "")) 0)) ; set patten to clipboard (first in list)
											(gimp-selection-none image)
											(gimp-image-delete image_motif_temporaire)
										)
									)
								)
							)

							(if (= Nb_couleurs_trouvees 7)
								(begin
									(if (= Pattern_From_Image 0)
										(begin
											(gimp-context-set-pattern Motif_Pattern_7)
										)
										;else
										(begin
											(gimp-selection-none image)
											(gimp-image-select-rectangle image 0 (* largeur_motif_image (- Nb_couleurs_trouvees 1) ) (* hauteur_motif_image (- Nb_couleurs_trouvees 1) ) largeur_motif_image hauteur_motif_image)
											(gimp-edit-copy-visible image)
											(set! image_motif_temporaire (car (gimp-image-new largeur_motif_image hauteur_motif_image 0)))
											(set! calque_motif_temporaire (car (gimp-layer-new image_motif_temporaire largeur_motif_image hauteur_motif_image 0 "calque_motif_temporaire" 100 0)))
											(gimp-image-insert-layer image_motif_temporaire calque_motif_temporaire -1 0)
											(gimp-item-set-visible calque_motif_temporaire TRUE)
											(gimp-image-select-rectangle image_motif_temporaire 0  largeur_motif_image hauteur_motif_image 0 0 )
											(gimp-floating-sel-anchor (car (gimp-edit-paste calque_motif_temporaire 1) ) )
											(gimp-image-resize image_motif_temporaire dim_motif_temporaire dim_motif_temporaire 0 0)
											(set! calque_motif_temporaire (car (gimp-image-get-active-layer image_motif_temporaire)))
											(gimp-layer-resize-to-image-size calque_motif_temporaire)
											(gimp-levels-stretch calque_motif_temporaire)
											(if (= Pattern_From_Image 2)
												(begin
													(plug-in-gauss 1 image_motif_temporaire calque_motif_temporaire 16 16 1)
													(gimp-invert calque_motif_temporaire)
												)
											)
											(plug-in-make-seamless 1 image_motif_temporaire calque_motif_temporaire)
											(gimp-edit-copy-visible image_motif_temporaire)
											; astuce de RobA  http://www.gimpchat.com/viewtopic.php?f=8&t=1221&start=40 pour que le presse-papiers devienne le motif sans avoir  choisir le nom qui varie selon les langues de Gimp
											(gimp-context-set-pattern (list-ref (cadr (gimp-patterns-get-list "")) 0)) ; set patten to clipboard (first in list)
											(gimp-selection-none image)
											(gimp-image-delete image_motif_temporaire)
										)
									)
								)
							)

							(if (= Nb_couleurs_trouvees 8)
								(begin
									(if (= Pattern_From_Image 0)
										(begin
											(gimp-context-set-pattern Motif_Pattern_8)
										)
										;else
										(begin
											(gimp-selection-none image)
											(gimp-image-select-rectangle image 0 (* largeur_motif_image (- Nb_couleurs_trouvees 1) ) (* hauteur_motif_image (- Nb_couleurs_trouvees 1) ) largeur_motif_image hauteur_motif_image)
											(gimp-edit-copy-visible image)
											(set! image_motif_temporaire (car (gimp-image-new largeur_motif_image hauteur_motif_image 0)))
											(set! calque_motif_temporaire (car (gimp-layer-new image_motif_temporaire largeur_motif_image hauteur_motif_image 0 "calque_motif_temporaire" 100 0)))
											(gimp-image-insert-layer image_motif_temporaire calque_motif_temporaire -1 0)
											(gimp-item-set-visible calque_motif_temporaire TRUE)
											(gimp-image-select-rectangle image_motif_temporaire 0  largeur_motif_image hauteur_motif_image 0 0 )
											(gimp-floating-sel-anchor (car (gimp-edit-paste calque_motif_temporaire 1) ) )
											(gimp-image-resize image_motif_temporaire dim_motif_temporaire dim_motif_temporaire 0 0)
											(set! calque_motif_temporaire (car (gimp-image-get-active-layer image_motif_temporaire)))
											(gimp-layer-resize-to-image-size calque_motif_temporaire)
											(gimp-levels-stretch calque_motif_temporaire)
											(if (= Pattern_From_Image 2)
												(begin
													(plug-in-gauss 1 image_motif_temporaire calque_motif_temporaire 16 16 1)
													(gimp-invert calque_motif_temporaire)
												)
											)
											(plug-in-make-seamless 1 image_motif_temporaire calque_motif_temporaire)
											(gimp-edit-copy-visible image_motif_temporaire)
											; astuce de RobA  http://www.gimpchat.com/viewtopic.php?f=8&t=1221&start=40 pour que le presse-papiers devienne le motif sans avoir  choisir le nom qui varie selon les langues de Gimp
											(gimp-context-set-pattern (list-ref (cadr (gimp-patterns-get-list "")) 0)) ; set patten to clipboard (first in list)
											(gimp-selection-none image)
											(gimp-image-delete image_motif_temporaire)
										)
									)
								)
							)


							(if (> Nb_couleurs_trouvees 0)
								(begin
									; (gimp-edit-bucket-fill drawable fill-mode paint-mode opacity threshold sample-merged x y)
									(gimp-edit-bucket-fill calque_8_motifs 2 0 100 0 FALSE 0 0)

								)
							)



						)
					)

					(gimp-selection-none nouvelle_image)

					(set! rvb (+ rvb 1) )
					(if (or (= rvb 256) (= Nb_couleurs_trouvees 8) )
						(begin

							(set! sortie_boucle 1 )							
						)
					)





				)
		)



		(set! selection_en_cours (car (gimp-edit-named-paste calque_copie copier_visible 0)))

		(gimp-floating-sel-anchor selection_en_cours)

		(gimp-selection-none nouvelle_image)









		(gimp-undo-push-group-end nouvelle_image)
		(gimp-display-new nouvelle_image)



;******************************************************************************************************
; 
;******************************************************************************************************


		; aplatir l'image
		(if
			(= flatten TRUE)
				(gimp-image-flatten nouvelle_image)
				;else
				(gimp-image-set-active-layer nouvelle_image calque_8_motifs)
		)	







;******************************************************************************************************

		;; rtablir le mode message
		(gimp-message-set-handler message)

		(gimp-context-set-transform-direction old_context_transform_direction )
		(gimp-context-set-interpolation old_context_interpolation)
		(gimp-context-set-transform-recursion old_context_recursion)
		(gimp-context-set-transform-resize old_context_transform_resize)
		(gimp-context-set-background old-bg)
		(gimp-context-set-foreground old-fg)


		(gimp-context-set-antialias old_context-antialias)
		(gimp-context-set-feather old_context-feather)
		(gimp-context-set-feather-radius old_context-feather-radiusx old_context-feather-radiusy)
		(gimp-context-set-sample-merged old_context-sample-merged)
		(gimp-context-set-sample-criterion old_ontext-sample-criterion)
		(gimp-context-set-sample-threshold old_context-sample-threshold)
		(gimp-context-set-sample-transparent old_context-sample-transparent)

		(gimp-context-set-brush-default-size)
		(gimp-context-set-brush-size old-brush-size)
		(gimp-context-set-brush-aspect-ratio old-brush-aspect-ratio)
		(gimp-context-set-brush-angle old-brush-angle)		
		(gimp-context-set-brush old-brush-name)

		(gimp-context-set-pattern old-pattern)

		(gimp-undo-push-group-end image)
		(gimp-displays-flush)


	)
)





(script-fu-register "huit_motifs_samj"
                    _"<Image>/Filters/Map/8 Motifs-Patterns ..."
                    "8 Motifs-Patterns ..."
                    "samj"
                    "samj"
                    "20130404"
                    "RGB*"
                    SF-IMAGE    "Image"     0
                    SF-DRAWABLE "Drawable"  0
					SF-ADJUSTMENT "Soften " '(2 0 60 1 5 0 1)
					SF-PATTERN "Pattern 1 " "Leather"
					SF-PATTERN "Pattern 2 " "Chocolate Swirl"
					SF-PATTERN "Pattern 3 " "Parque #3"
					SF-PATTERN "Pattern 4 " "Walnut"
					SF-PATTERN "Pattern 5 " "Wood #2"
					SF-PATTERN "Pattern 6 " "Wood #1"
					SF-PATTERN "Pattern 7 " "Wood of some sort"
					SF-PATTERN "Pattern 8 " "Wood"
					SF-COLOR "Back Ground Color " '(0 0 0)
					SF-TOGGLE "Use Back Ground Color " FALSE
					SF-OPTION "Pattern From Image " '("No" "Mode 1" "Mode 2")
					SF-TOGGLE "Flatten" FALSE

)

;; FIN





