; Script-Fu 8_selections_to_paths.scm
; Download : 
;
;	Copyright (C) 2013 samj ( http://aljacom.com/~gmic/ )
;
;	Licence GPL
;		Ce fichier est le Script-Fu "8_selections_to_paths.scm" pour Gimp. 
;		Ce Script-Fu "8_selections_to_paths.scm" est un logiciel libre ; vous pouvez le redistribuer ou le modifier suivant les termes de la GNU General Public License
;		telle que publie par la Free Software Foundation ; soit la version 3 de la licence, soit ( votre gr) toute version ultrieure.
;		Ce Script-Fu "8_selections_to_paths.scm" est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; 
;		pas mme la garantie implicite de COMMERCIABILISABILIT ni d'ADQUATION  UN OBJECTIF PARTICULIER.
;		Consultez la GNU General Public License pour plus de dtails.
;		Vous devez avoir reu une copie de la GNU General Public License en mme temps que GIMP ; si ce n'est pas le cas, consultez <http://www.gnu.org/licenses>
;
;	Ce fichier 8_selections_to_paths.scm est dit avec Notepad++    http://notepad-plus-plus.org/
;
;
;	Version 20130406
;		Modifications :
;			- origine des images en niveaux de gris, rvb, couleurs indexes.
;			- Mmoriser les slections brutes dans un canal (masque) ainsi que les chemins.
;			- Choisir pous chaque chemin une option "Soften".
;			- Paramtrer les pr-traitements.
;			- choisir le nombre de slections (entre 2 et 8).
;
;			- Store the "raw" selections and paths.
;			- Choose an option "Soften"  for each path.
;			- Set the pre-treatments.
;			- Choose the number of selections (2 to 8).
;
;	Version 20130405 Origine.  voir si intressant
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;
;	Accs sur l'image par :
;
;	Selectionner > 8 Selections To Paths ...
;	Select > 8 Selections To Paths ...
;
;
;
;
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;

		
(define	
	(
		huit_selections_vers_chemins_samj
		image
		drawable
		Pre_Treatment_1_levels_stretch
		Pre_Treatment_2_equalize
		Pretreatment_3
		Pretreatment_4_blur
		Number_of_selections_to_make
		Soften_Path_1
		Soften_Path_2
		Soften_Path_3
		Soften_Path_4
		Soften_Path_5
		Soften_Path_6
		Soften_Path_7
		Soften_Path_8


		
	)
	(let* 
		(

			(message (car (gimp-message-get-handler)))
			(old_context_transform_direction (car (gimp-context-get-transform-direction)))
			(old_context_interpolation (car (gimp-context-get-interpolation)))
			(old_context_recursion (car (gimp-context-get-transform-recursion)))
			(old_context_transform_resize (car (gimp-context-get-transform-resize)))
			(old-fg (car (gimp-context-get-foreground)))
			(old-bg (car (gimp-context-get-background)))

			(old_context-antialias (car (gimp-context-get-antialias)))
			(old_context-feather (car (gimp-context-get-feather)))
			(old_context-feather-radiusx (car (gimp-context-get-feather-radius)))
			(old_context-feather-radiusy (cadr (gimp-context-get-feather-radius)))
			(old_context-sample-merged (car (gimp-context-get-sample-merged)))
			(old_ontext-sample-criterion (car (gimp-context-get-sample-criterion)))
			(old_context-sample-threshold (car (gimp-context-get-sample-threshold)))
			(old_context-sample-transparent (car (gimp-context-get-sample-transparent)))

			(old-brush-size (car (gimp-context-get-brush-size)))
			(old-brush-aspect-ratio (car (gimp-context-get-brush-aspect-ratio)))
			(old-brush-angle (car (gimp-context-get-brush-angle)))
			(old-brush-name (car (gimp-context-get-brush)))
			
			(old-pattern (car (gimp-context-get-pattern)))

			(width (car (gimp-image-width image)))
			(height (car (gimp-image-height image)))

			(transparence (car (gimp-drawable-has-alpha drawable)))

			(selection_en_cours)
			(nouvelle_image)
			(calque_copie)
			(copier_visible)
			(buffer-name "copier_visible")
			(rvb 0)
			(selection_bounds 0)
			(select_exist 0)
			(select_offset_x 0)
			(select_offset_y 0)
			(select_width 0)
			(select_height 0)

			(sortie_boucle 0)

			(calque_8_selections)

			(image_motif_temporaire)
			(calque_motif_temporaire)
			(dim_motif_temporaire (+ 4 (truncate (/ (+ width height) 100) ) ) )


			(Nb_couleurs_trouvees 0)
			(Nom_du_chemin "")

			(matrix 0)
			(matrix-list 0)
			(channels 0)

		)


		(gimp-context-set-antialias FALSE)
		(gimp-context-set-feather FALSE)
		(gimp-context-set-feather-radius 0 0)
		(gimp-context-set-sample-merged FALSE)
		(gimp-context-set-sample-criterion 0)
		(gimp-context-set-sample-threshold 0)
		(gimp-context-set-sample-transparent FALSE)

		(gimp-context-set-transform-direction TRANSFORM-FORWARD)
		(gimp-context-set-interpolation 2)
		(gimp-context-set-transform-recursion 3)
		(gimp-context-set-transform-resize TRANSFORM-RESIZE-ADJUST)
		
		(gimp-context-set-paint-mode 0) ;

		
		(gimp-undo-push-group-start image)

		(gimp-selection-none image)





;******************************************************************************************************
; 
;******************************************************************************************************


		(set! copier_visible (car (gimp-edit-named-copy-visible image buffer-name)))

		; crer une nouvelle image rgb
		(set! nouvelle_image (car (gimp-image-new width height 0)))

		(gimp-undo-push-group-start nouvelle_image)

		; crer le premier calque
		(set! calque_copie (car (gimp-layer-new nouvelle_image width height 0 "calque_copie" 100 0)))

		(gimp-image-insert-layer nouvelle_image calque_copie -1 0)

		(gimp-image-select-rectangle nouvelle_image 0  width height 0 0 )

		(set! selection_en_cours (car (gimp-edit-named-paste calque_copie copier_visible 0)))

		(gimp-floating-sel-anchor selection_en_cours)

		(gimp-selection-none nouvelle_image)

		(gimp-layer-add-alpha calque_copie)

		(if (= Pre_Treatment_1_levels_stretch 1)  (gimp-levels-stretch calque_copie)  )

		(if (= Pre_Treatment_2_equalize 1)  (gimp-equalize calque_copie TRUE)  )

		; ajuster taille image  la taille des calques
		(gimp-image-resize-to-layers nouvelle_image)

		(set! calque_copie (car (gimp-image-get-active-layer nouvelle_image)))




		(if (or (= Pretreatment_3 1) (= Pretreatment_3 3) ) ; "B For dark images"
			(begin

				(set! matrix-list
					'(
						0		0		0		0		0
						0		1		0		0		0
						0		0		1		0		0
						0		0		0		0		0
						0		0		0		0		0
					 )
				)

				(set! channels (make-vector 5 'long ))

				(vector-set! channels 0 1 )
				(vector-set! channels 1 1 )
				(vector-set! channels 2 1 )
				(vector-set! channels 3 1 )
				(vector-set! channels 4 1 )

				; Convert maxtrix list (25) into matrix array (5x5)
				(define (get-matrix matrix-list)
				  (let* (
						(n 0)
						)
				  (set! n 25 )
				  (define (list-ref l n) (nth n l))
					(let* ((count 0)
						   (matrix (cons-array 25 'double)))
					  (while (< count 25 )
					  (aset matrix count (list-ref matrix-list count))
					  (set! count (+ count 1)))
					  matrix ; Return the matrix array
					)
				  )
				)

				; (plug-in-convmatrix run-mode image drawable argc-matrix matrix alpha-alg divisor offset argc-channels channels bmode)
				(plug-in-convmatrix 1 nouvelle_image calque_copie 25 (set! matrix (get-matrix matrix-list)) 1 1 0 5 channels 0)


			)
		)


		(if (or (= Pretreatment_3 2) (= Pretreatment_3 3) ) ; "C Low contrast picture"
			(begin


				(set! matrix-list
					'(
						-1		0		0		0		0
						0		1		0		0		0
						0		0		1		0		0
						0		0		0		0		0
						0		0		0		0		0
					 )
				)

				(set! channels (make-vector 5 'long ))

				(vector-set! channels 0 1 )
				(vector-set! channels 1 1 )
				(vector-set! channels 2 1 )
				(vector-set! channels 3 1 )
				(vector-set! channels 4 1 )

				; Convert maxtrix list (25) into matrix array (5x5)
				(define (get-matrix matrix-list)
				  (let* (
						(n 0)
						)
				  (set! n 25 )
				  (define (list-ref l n) (nth n l))
					(let* ((count 0)
						   (matrix (cons-array 25 'double)))
					  (while (< count 25 )
					  (aset matrix count (list-ref matrix-list count))
					  (set! count (+ count 1)))
					  matrix ; Return the matrix array
					)
				  )
				)

				; (plug-in-convmatrix run-mode image drawable argc-matrix matrix alpha-alg divisor offset argc-channels channels bmode)
				(plug-in-convmatrix 1 nouvelle_image calque_copie 25 (set! matrix (get-matrix matrix-list)) 1 1 0 5 channels 0)



			
			)
		)



		(gimp-desaturate-full calque_copie 1)

		(gimp-posterize calque_copie 6)

		(if (> Pretreatment_4_blur 0) 
			;;;;;(plug-in-gauss 1 nouvelle_image calque_copie (round (+ 1 (/ width 40)))  (round (+ 1 (/ height 40)))   1)
			(plug-in-gauss 1 nouvelle_image calque_copie Pretreatment_4_blur  Pretreatment_4_blur   1)
		)

		(gimp-convert-indexed nouvelle_image 0 0 Number_of_selections_to_make 1 1 "")

		(gimp-image-convert-grayscale nouvelle_image)

		(gimp-image-convert-rgb nouvelle_image)






		; boucle pour trouver les couleurs et faire une slection par couleur , un chemin
		(while
			(= sortie_boucle 0)
				(begin

					(gimp-image-select-color nouvelle_image 0 calque_copie (list rvb rvb rvb))
					(gimp-selection-feather nouvelle_image 0)

					(set! selection_bounds (gimp-selection-bounds nouvelle_image))
					(set! select_exist (car selection_bounds))
					;(set! select_offset_x (cadr selection_bounds))
					;(set! select_offset_y (caddr selection_bounds))
					;(set! select_width (- (cadr (cddr selection_bounds)) select_offset_x))
					;(set! select_height (- (caddr (cddr selection_bounds)) select_offset_y))
					;(gimp-message (number->string select_exist))

					(if (= select_exist 1)
						(begin


							(set! Nb_couleurs_trouvees (+ Nb_couleurs_trouvees 1) )
							;(gimp-message (number->string Nb_couleurs_trouvees))

							(gimp-selection-save nouvelle_image)


							(if (= Nb_couleurs_trouvees 1)
								(begin
									(if (> Soften_Path_1 0)
										(begin
											(gimp-selection-grow nouvelle_image Soften_Path_1)
											(gimp-selection-shrink nouvelle_image Soften_Path_1)
										)
									)
								)
							)

							(if (= Nb_couleurs_trouvees 2)
								(begin
									(if (> Soften_Path_2 0)
										(begin
											(gimp-selection-grow nouvelle_image Soften_Path_2)
											(gimp-selection-shrink nouvelle_image Soften_Path_2)
										)
									)
								)
							)

							(if (= Nb_couleurs_trouvees 3)
								(begin
									(if (> Soften_Path_3 0)
										(begin
											(gimp-selection-grow nouvelle_image Soften_Path_3)
											(gimp-selection-shrink nouvelle_image Soften_Path_3)
										)
									)
								)
							)

							(if (= Nb_couleurs_trouvees 4)
								(begin
									(if (> Soften_Path_4 0)
										(begin
											(gimp-selection-grow nouvelle_image Soften_Path_4)
											(gimp-selection-shrink nouvelle_image Soften_Path_4)
										)
									)
								)
							)

							(if (= Nb_couleurs_trouvees 5)
								(begin
									(if (> Soften_Path_5 0)
										(begin
											(gimp-selection-grow nouvelle_image Soften_Path_5)
											(gimp-selection-shrink nouvelle_image Soften_Path_5)
										)
									)
								)
							)

							(if (= Nb_couleurs_trouvees 6)
								(begin
									(if (> Soften_Path_6 0)
										(begin
											(gimp-selection-grow nouvelle_image Soften_Path_6)
											(gimp-selection-shrink nouvelle_image Soften_Path_6)
										)
									)
								)
							)

							(if (= Nb_couleurs_trouvees 7)
								(begin
									(if (> Soften_Path_7 0)
										(begin
											(gimp-selection-grow nouvelle_image Soften_Path_7)
											(gimp-selection-shrink nouvelle_image Soften_Path_7)
										)
									)
								)
							)

							(if (= Nb_couleurs_trouvees 8)
								(begin
									(if (> Soften_Path_8 0)
										(begin
											(gimp-selection-grow nouvelle_image Soften_Path_8)
											(gimp-selection-shrink nouvelle_image Soften_Path_8)
										)
									)
								)
							)

							(set! Nom_du_chemin (string-append "Chemin_"  (number->string Nb_couleurs_trouvees) ) )

							; sauvegarde slection vers chemin
							(plug-in-sel2path 1 nouvelle_image calque_copie)

							; donner un nom au chemin
							(gimp-item-set-name (car (gimp-image-get-active-vectors nouvelle_image)) Nom_du_chemin )
							
							(if (= Nb_couleurs_trouvees 1)
								(begin
									(gimp-item-set-visible (car (gimp-image-get-active-vectors nouvelle_image)) TRUE)
								)
							)
							


							(gimp-selection-none nouvelle_image)

						)
					)

					(gimp-selection-none nouvelle_image)

					(set! rvb (+ rvb 1) )
					(if (or (= rvb 256) (= Nb_couleurs_trouvees Number_of_selections_to_make) )
						(begin

							(set! sortie_boucle 1 )							
						)
					)


				)
		)


		(set! selection_en_cours (car (gimp-edit-named-paste calque_copie copier_visible 0)))

		(gimp-floating-sel-anchor selection_en_cours)


		; ajouter le calque calque_8_selections
		(set! calque_8_selections (car (gimp-layer-new nouvelle_image width height 0 "calque_8_selections" 100 0)))

		(gimp-image-insert-layer nouvelle_image calque_8_selections -1 0)

		(gimp-item-set-visible calque_8_selections TRUE)

		(gimp-layer-add-alpha calque_8_selections)

		(gimp-drawable-fill calque_8_selections 3)



		(gimp-selection-none nouvelle_image)

		(gimp-undo-push-group-end nouvelle_image)
		(gimp-display-new nouvelle_image)



;******************************************************************************************************
; 
;******************************************************************************************************







;******************************************************************************************************

		;; rtablir le mode message
		(gimp-message-set-handler message)

		(gimp-context-set-transform-direction old_context_transform_direction )
		(gimp-context-set-interpolation old_context_interpolation)
		(gimp-context-set-transform-recursion old_context_recursion)
		(gimp-context-set-transform-resize old_context_transform_resize)
		(gimp-context-set-background old-bg)
		(gimp-context-set-foreground old-fg)


		(gimp-context-set-antialias old_context-antialias)
		(gimp-context-set-feather old_context-feather)
		(gimp-context-set-feather-radius old_context-feather-radiusx old_context-feather-radiusy)
		(gimp-context-set-sample-merged old_context-sample-merged)
		(gimp-context-set-sample-criterion old_ontext-sample-criterion)
		(gimp-context-set-sample-threshold old_context-sample-threshold)
		(gimp-context-set-sample-transparent old_context-sample-transparent)

		(gimp-context-set-brush-default-size)
		(gimp-context-set-brush-size old-brush-size)
		(gimp-context-set-brush-aspect-ratio old-brush-aspect-ratio)
		(gimp-context-set-brush-angle old-brush-angle)		
		(gimp-context-set-brush old-brush-name)

		(gimp-context-set-pattern old-pattern)

		(gimp-undo-push-group-end image)
		(gimp-displays-flush)


	)
)





(script-fu-register "huit_selections_vers_chemins_samj"
                    _"<Image>/Select/8 Selections To Paths ..."
                    "8 Selections To Paths ..."
                    "samj"
                    "samj"
                    "20130406"
                    "*"
                    SF-IMAGE    "Image"     0
                    SF-DRAWABLE "Drawable"  0
					SF-TOGGLE "Pre-Treatment 1 (levels-stretch) " TRUE
					SF-TOGGLE "Pre-Treatment 2 (equalize) " TRUE
					SF-OPTION "Pretreatments 3 " '("A  Without" "B  For dark images" "C  Low contrast picture" "  B + C  ")
					SF-ADJUSTMENT "Pretreatment 4 (blur) " '(4 0 20 1 5 0 1)
					SF-ADJUSTMENT "Number of selections to make " '(8 2 8 1 2 0 1)
					SF-ADJUSTMENT "Soften Path 1 (Chemin_1) " '(2 0 60 1 5 0 1)
					SF-ADJUSTMENT "Soften Path 2 (Chemin_2) " '(2 0 60 1 5 0 1)
					SF-ADJUSTMENT "Soften Path 3 (Chemin_3) " '(2 0 60 1 5 0 1)
					SF-ADJUSTMENT "Soften Path 4 (Chemin_4) " '(2 0 60 1 5 0 1)
					SF-ADJUSTMENT "Soften Path 5 (Chemin_5) " '(2 0 60 1 5 0 1)
					SF-ADJUSTMENT "Soften Path 6 (Chemin_6) " '(2 0 60 1 5 0 1)
					SF-ADJUSTMENT "Soften Path 7 (Chemin_7) " '(2 0 60 1 5 0 1)
					SF-ADJUSTMENT "Soften Path 8 (Chemin_8) " '(2 0 60 1 5 0 1)


)

;; FIN





