; Epicycloid_for_beginners.scm
; Download : 
;
;	Copyright (C) 2013 samj ( http://aljacom.com/ )
;
;	Licence GPL
;		Ce fichier est le Script-Fu "Epicycloid_for_beginners.scm" pour Gimp. 
;		Ce Script-Fu "Epicycloid_for_beginners.scm" est un logiciel libre ; vous pouvez le redistribuer ou le modifier suivant les termes de la GNU General Public License
;		telle que publie par la Free Software Foundation ; soit la version 3 de la licence, soit ( votre gr) toute version ultrieure.
;		Ce Script-Fu "Epicycloid_for_beginners.scm" est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; 
;		pas mme la garantie implicite de COMMERCIABILISABILIT ni d'ADQUATION  UN OBJECTIF PARTICULIER.
;		Consultez la GNU General Public License pour plus de dtails.
;		Vous devez avoir reu une copie de la GNU General Public License en mme temps que GIMP ; si ce n'est pas le cas, consultez <http://www.gnu.org/licenses>
;
;	Ce fichier Epicycloid_for_beginners.scm est dit avec Notepad++    http://notepad-plus-plus.org/
;
;
;	Version 1 du 20130518
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;
;	Accs par :
;
;	Fichier > Crer > Motifs > Epicycloid for beginners ...
;	File > Create > Patterns > Epicycloid for beginners ...
;
;
;
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;
; http://en.wikipedia.org/wiki/Epicycloid
;
;
;
;

		
(define	
	(
		Epicycloid_for_beginners_samj
		Coefficient_Dimension
		Frequence_1
		Angle_1
		Frequence_2
		Angle_2
		Color_Pencil_1
		Pencil_1_Line_Thickness
		Color_intensity
		Autocrop_Image
		Save_Path_As_SVG
		
	)
	(let* 
		(

			(message (car (gimp-message-get-handler)))
			(old_context_transform_direction (car (gimp-context-get-transform-direction)))
			(old_context_interpolation (car (gimp-context-get-interpolation)))
			(old_context_recursion (car (gimp-context-get-transform-recursion)))
			(old_context_transform_resize (car (gimp-context-get-transform-resize)))
			(old-fg (car (gimp-context-get-foreground)))
			(old-bg (car (gimp-context-get-background)))

			(old_context-antialias (car (gimp-context-get-antialias)))
			(old_context-feather (car (gimp-context-get-feather)))
			(old_context-feather-radiusx (car (gimp-context-get-feather-radius)))
			(old_context-feather-radiusy (cadr (gimp-context-get-feather-radius)))
			(old_context-sample-merged (car (gimp-context-get-sample-merged)))
			(old_ontext-sample-criterion (car (gimp-context-get-sample-criterion)))
			(old_context-sample-threshold (car (gimp-context-get-sample-threshold)))
			(old_context-sample-transparent (car (gimp-context-get-sample-transparent)))

			(old-brush-size (car (gimp-context-get-brush-size)))
			(old-brush-aspect-ratio (car (gimp-context-get-brush-aspect-ratio)))
			(old-brush-angle (car (gimp-context-get-brush-angle)))
			(old-brush-name (car (gimp-context-get-brush)))
			
			(old-pattern (car (gimp-context-get-pattern)))

			(width 0)
			(width 0)
			(height 0)
			(image)
			
			;calque_fond
			(calque_fond)
			(angle_origine 0)
			(angle_fin_boucle 0)
			(2pi (* 2 3.14159265358979323846))

			(decalage_X 0)
			(decalage_Y 0)
			(temps_origine 0)
			(increment_temps 0)
			(temps_fin 0)
			(X_1 0)
			(Y_1 0)
			(X_2 0)
			(Y_2 0)
			(X_total 0)
			(Y_total 0)

			(epaisseur_ligne Pencil_1_Line_Thickness)


			(Chemin_Epicycloid_for_beginners_samj)

			(sortie_boucle_tracer 0)
			(Nom_de_la_brosse "Ma_Brosse_Spirale_samj")
			(The_shape_of_the_generated_brush 0) ; "Circle" "Square" "Diamond"
			(rayon_brosse (/ Pencil_1_Line_Thickness 2) )

			(Nombre_Points_Chemin 0)
			(Points_Chemin)
			(Ajout_Points_Chemin)

			(filename "qwerty")

			(sortie_boucle 0)
	
			(Rayon_1 0)
			(Rayon_2 0)


		)


		(gimp-context-set-antialias FALSE)
		(gimp-context-set-feather FALSE)
		(gimp-context-set-feather-radius 0 0)
		(gimp-context-set-sample-merged FALSE)
		(gimp-context-set-sample-criterion 0)
		(gimp-context-set-sample-threshold 0.15)
		(gimp-context-set-sample-transparent FALSE)

		(gimp-context-set-transform-direction TRANSFORM-FORWARD)
		(gimp-context-set-interpolation 2)
		(gimp-context-set-transform-recursion 3)
		(gimp-context-set-transform-resize TRANSFORM-RESIZE-ADJUST)
		
		(gimp-context-set-paint-mode 0) ;


;******************************************************************************************************
; 
;******************************************************************************************************


	(if (> ( + (* Coefficient_Dimension Frequence_1) (* Coefficient_Dimension Frequence_2) ) 2000 )
		(begin
			(set! Coefficient_Dimension (+ 1 (round (/ 2000 (+  Frequence_1 Frequence_2 ) ) ) ) )
		)	
	)

	
	
	(set! Rayon_1 (* Coefficient_Dimension Frequence_2) )
	(set! Rayon_2 (* Coefficient_Dimension Frequence_1) )

	
	(set! width (* 2 (+  Rayon_1 Rayon_2 (* 2 epaisseur_ligne) ) ) )
	(set! height width )


	; crer une nouvelle image rgb
	(set! image (car (gimp-image-new width height 0)))

	;; Start undo group.
	(gimp-image-undo-group-start image)

	;; slectionner la console erreurs pour envoyer un message
	(gimp-message-set-handler 2)

	; crer calque_fond
	(set! calque_fond (car (gimp-layer-new image width height 1 "calque_fond" 100 0)))	
	
	; ajouter le calque calque_fond
	(gimp-image-insert-layer image calque_fond 0 -1)

	(gimp-drawable-fill calque_fond 3)

;******************************************************************************************************
; 
;******************************************************************************************************

	;transformation degrs radians
	(set! Angle_1 (* (/ 2pi 360) Angle_1) )
	(set! Angle_2 (* (/ 2pi 360) Angle_2) )



	(set! temps_fin 1)	
	(set! increment_temps (/ temps_fin (* 180 (+ Frequence_1 Frequence_2) ) ) )

	(if (> (/ temps_fin increment_temps) 8280)
		(begin
			(set! increment_temps (/ temps_fin 8280) )
		)
	)	

	; (gimp-message (number->string (/ temps_fin increment_temps) ) )

	(set! temps_origine 0 )
	
	
	(set! decalage_X (/ width 2) )
	(set! decalage_Y (/ height 2) )

	; inversion de la rotation angulaire de f2 pour transformer une picyclode en hypocyclode 
	; (set! Frequence_2 (* Frequence_2 -1) )

	(set! X_1 (* Rayon_1 (cos (+ (* (* 2pi Frequence_1) temps_origine ) Angle_1 ) ) ) )
	(set! Y_1 (* Rayon_1 (sin (+ (* (* 2pi Frequence_1) temps_origine ) Angle_1 ) ) ) )
	(set! X_2 (* Rayon_2 (cos (+ (* (* 2pi Frequence_2) temps_origine ) Angle_2 ) ) ) )
	(set! Y_2 (* Rayon_2 (sin (+ (* (* 2pi Frequence_2) temps_origine ) Angle_2 ) ) ) )


	(set! X_total (+ decalage_X X_1 X_2) )
	(set! Y_total (+ decalage_Y Y_1 Y_2) )


	(set! Points_Chemin (list X_total Y_total X_total Y_total X_total Y_total ) )

	(set! Nombre_Points_Chemin 6 )

	(set! Chemin_Epicycloid_for_beginners_samj (car (gimp-vectors-new image "Epicycloid") ) )
	(gimp-image-add-vectors image Chemin_Epicycloid_for_beginners_samj 0)

	(while (= 0 sortie_boucle)
		(begin



			(set! temps_origine (+ temps_origine increment_temps) )


			; bon
			(if (< temps_origine temps_fin) 
				(begin
					; (set! sortie_boucle 0 )
				)
				;else
				(begin
					(set! sortie_boucle 1 )
				)
			)


			(set! X_1 (* Rayon_1 (cos (+ (* (* 2pi Frequence_1) temps_origine ) Angle_1 ) ) ) )
			(set! Y_1 (* Rayon_1 (sin (+ (* (* 2pi Frequence_1) temps_origine ) Angle_1 ) ) ) )
			(set! X_2 (* Rayon_2 (cos (+ (* (* 2pi Frequence_2) temps_origine ) Angle_2 ) ) ) )
			(set! Y_2 (* Rayon_2 (sin (+ (* (* 2pi Frequence_2) temps_origine ) Angle_2 ) ) ) )


			(set! X_total (+ decalage_X X_1 X_2) )
			(set! Y_total (+ decalage_Y Y_1 Y_2) )

			(set! Nombre_Points_Chemin (+ 6 Nombre_Points_Chemin ) )

			(set! Ajout_Points_Chemin (list X_total Y_total X_total Y_total X_total Y_total ) )

			(set! Points_Chemin (append Points_Chemin Ajout_Points_Chemin) )

		)
	)





;******************************************************************************************************
; 
;******************************************************************************************************

	; crer le chemin
	(gimp-vectors-stroke-new-from-points
		Chemin_Epicycloid_for_beginners_samj
		0
		Nombre_Points_Chemin
		(list->vector Points_Chemin )
		TRUE
	)
	
	(gimp-context-set-foreground Color_Pencil_1)

	; crer une brosse
	(gimp-brush-new Nom_de_la_brosse)				

	(gimp-context-set-brush-size rayon_brosse )
	;;;(gimp-context-set-brush-default-size)
	(gimp-context-set-brush-aspect-ratio 1)
	(gimp-context-set-brush-angle 0)
	
	(gimp-context-set-brush Nom_de_la_brosse)

	(gimp-brush-set-shape Nom_de_la_brosse The_shape_of_the_generated_brush) ; forme

	(gimp-brush-set-radius Nom_de_la_brosse rayon_brosse ) ; rayon

	(gimp-brush-set-spikes Nom_de_la_brosse 2) ; pointes
	(gimp-brush-set-hardness Nom_de_la_brosse 1.0) ; duret 
	(gimp-brush-set-aspect-ratio Nom_de_la_brosse 1 ) ; proportions
	(gimp-brush-set-angle Nom_de_la_brosse 0) ; angle
	(gimp-brush-set-spacing Nom_de_la_brosse 1.0 ) ; espacement

	; slectionner brosse
	(gimp-context-set-brush Nom_de_la_brosse)

	(set! sortie_boucle_tracer Color_intensity)
	(while (> sortie_boucle_tracer 0)
		(begin
			(gimp-edit-stroke-vectors calque_fond (car (gimp-image-get-active-vectors image) ) )
			(set! sortie_boucle_tracer (- sortie_boucle_tracer 1) )
		)
	)

	(gimp-brush-delete Nom_de_la_brosse)

	(if (= 1 Autocrop_Image) (plug-in-autocrop-layer 1 image calque_fond) )

	
	; ajuster taille image  la taille des calques
	(gimp-image-resize-to-layers image)

	(if (= 1 Save_Path_As_SVG) 
		(begin
			(set! width (car (gimp-image-width image) ) )
			(set! height (car (gimp-image-height image) ) )
			(set! filename (string-append gimp-directory "/" (strcat "Epicycloid_for_beginners_samj_" (number->string width ) "_" (number->string height )   ".svg") ) )
			(gimp-vectors-export-to-file image filename Chemin_Epicycloid_for_beginners_samj)
			(gimp-message (strcat "Save Path As :" filename ) )
		)
	)

;******************************************************************************************************
; 
;******************************************************************************************************

		;; rtablir le mode message
		(gimp-message-set-handler message)

		(gimp-context-set-transform-direction old_context_transform_direction )
		(gimp-context-set-interpolation old_context_interpolation)
		(gimp-context-set-transform-recursion old_context_recursion)
		(gimp-context-set-transform-resize old_context_transform_resize)
		(gimp-context-set-background old-bg)
		(gimp-context-set-foreground old-fg)


		(gimp-context-set-antialias old_context-antialias)
		(gimp-context-set-feather old_context-feather)
		(gimp-context-set-feather-radius old_context-feather-radiusx old_context-feather-radiusy)
		(gimp-context-set-sample-merged old_context-sample-merged)
		(gimp-context-set-sample-criterion old_ontext-sample-criterion)
		(gimp-context-set-sample-threshold old_context-sample-threshold)
		(gimp-context-set-sample-transparent old_context-sample-transparent)

		(gimp-context-set-brush-default-size)
		(gimp-context-set-brush-size old-brush-size)
		(gimp-context-set-brush-aspect-ratio old-brush-aspect-ratio)
		(gimp-context-set-brush-angle old-brush-angle)		
		(gimp-context-set-brush old-brush-name)

		(gimp-context-set-pattern old-pattern)



;******************************************************************************************************
; 
;******************************************************************************************************


		; afficher l'image
		(gimp-display-new image)

		; End undo group.
		(gimp-image-undo-group-end image)	





	)
)





(script-fu-register "Epicycloid_for_beginners_samj"
                    _"<Image>/File/Create/Patterns/Epicycloid for beginners ..."
                    "Epicycloid for beginners ..."
                    "samj"
                    "samj"
                    "20130518"
                    ""
					SF-ADJUSTMENT "Coefficient Dimension" '(20 5 50 1 5 0 1)
					SF-ADJUSTMENT "Frequency 1" '(3 1 19 1 5 0 1)
					SF-ADJUSTMENT "Angle 1" '(0 0 360 1 5 4 1)
					SF-ADJUSTMENT "Frequency 2" '(7 1 100 1 5 0 1)
					SF-ADJUSTMENT "Angle 2" '(0 0 360 1 5 4 1)
					SF-COLOR "Color Pencil 1 " '(0 0 0)
					SF-ADJUSTMENT "Pencil 1 - Line Thickness " '(10 2 40 1 5 0 1)
					SF-ADJUSTMENT "Color intensity " '(3 1 10 1 5 0 1)
					SF-TOGGLE "Autocrop " FALSE
					SF-TOGGLE "Save Path As SVG " FALSE
					


)

;; FIN





