; Script-Fu Les_chemins_colores.scm
; Download : 
;
;	Copyright (C) 2013 samj ( http://aljacom.com/~gmic/ )
;
;	Licence GPL
;		Ce fichier est le Script-Fu "Les_chemins_colores.scm" pour Gimp. 
;		Ce Script-Fu "Les_chemins_colores.scm" est un logiciel libre ; vous pouvez le redistribuer ou le modifier suivant les termes de la GNU General Public License
;		telle que publie par la Free Software Foundation ; soit la version 3 de la licence, soit ( votre gr) toute version ultrieure.
;		Ce Script-Fu "Les_chemins_colores.scm" est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; 
;		pas mme la garantie implicite de COMMERCIABILISABILIT ni d'ADQUATION  UN OBJECTIF PARTICULIER.
;		Consultez la GNU General Public License pour plus de dtails.
;		Vous devez avoir reu une copie de la GNU General Public License en mme temps que GIMP ; si ce n'est pas le cas, consultez <http://www.gnu.org/licenses>
;
;	Ce fichier Les_chemins_colores.scm est dit avec Notepad++    http://notepad-plus-plus.org/
;
;
;	Version 20130401 (origine) Poisson d'Avril :o)
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;
;	Accs sur l'image par :
;
;	Filtres > Les Chemins Colores ...
;	Filters > Les Chemins Colores ...
;
;
;
;
;	Origine :
;				- Ce script-fu est une adaptation d'un autre script utilis pour crer des images  crayonner pour les enfants.
;				- Il est adapt pour d'autres utilisations ... Graffitis, etc.
;
;	Principes :
;				- L'utilisation des images  couleurs indexes permet d'obtenir des zones uniformes de couleurs.
;				- La transformation en niveaux de gris permet de slectionner rapidement ces zones uniformes, de les transformer en chemins et d'appliquer une brosse sur ces chemins.
;				- Cette brosse est cre pendant l'excution du script-fu. Une brosse est cre pour chaque couleur de Pencil "Color Pencil x" avec une dimension correspondant  "Pencil x - Line Thickness" et une forme selon "The shape of the generated brush".
;				- Au sujet des crayons : Pencil 1 correspond au contour des couleurs les plus fonces ... jusqu' ... Pencil 5 qui correspond au contour des couleurs les plus claires.
;
;	Utilisation
;				- Utiliser des images bien contrastes, ventuellement augmenter les contrastes avec Gimp.
;				- Si l'image a un fond uni, une image de jouet par exemple, ajouter un canal alpha et enlever le fond uni.
;				- L'option "Rounded Lines (blur)" permet d'avoir des contours arrondis.
;				- L'option "Soften" permet d'arrondir les pointes.
;				- L'option "How to use colored pencils" permet de faire le contour de la zone la plus fonce (Pencil 1) jusqu'aux zones les plus claires (Pencils 1 2 3 4 5).
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;

		
(define	
	(
		Les_chemins_colores_samj
		image
		drawable
		Pretreatments
		Rounded_Lines
		Soften
		How_to_use_colored_pencils ;  '("Pencils 1 2 3 4 5" "Pencils 1 2 3 4" "Pencils 1 2 3" "Pencils 1 2" "Pencil 1")
		Color_Pencil_1 ; '(0 0 0)
		Pencil_1_Line_Thickness ; '(2 1 20 1 5 0 1)
		Color_Pencil_2 ; '(127 127 127)
		Pencil_2_Line_Thickness ; '(2 1 20 1 5 0 1)
		Color_Pencil_3 ; '(22 222 222)
		Pencil_3_Line_Thickness ; '(2 1 20 1 5 0 1)
		Color_Pencil_4 ; '(222 22 222)
		Pencil_4_Line_Thickness ; '(2 1 20 1 5 0 1)
		Color_Pencil_5 ; '(222 222 22)
		Pencil_5_Line_Thickness ; '(2 1 20 1 5 0 1)
		Back_Ground_Color
		The_shape_of_the_generated_brush
		Color_intensity
		Use_a_custom_brush
		Custom_brush
		flatten

		
	)
	(let* 
		(

			(message (car (gimp-message-get-handler)))
			(old_context_transform_direction (car (gimp-context-get-transform-direction)))
			(old_context_interpolation (car (gimp-context-get-interpolation)))
			(old_context_recursion (car (gimp-context-get-transform-recursion)))
			(old_context_transform_resize (car (gimp-context-get-transform-resize)))
			(old-fg (car (gimp-context-get-foreground)))
			(old-bg (car (gimp-context-get-background)))

			(old_context-antialias (car (gimp-context-get-antialias)))
			(old_context-feather (car (gimp-context-get-feather)))
			(old_context-feather-radiusx (car (gimp-context-get-feather-radius)))
			(old_context-feather-radiusy (cadr (gimp-context-get-feather-radius)))
			(old_context-sample-merged (car (gimp-context-get-sample-merged)))
			(old_ontext-sample-criterion (car (gimp-context-get-sample-criterion)))
			(old_context-sample-threshold (car (gimp-context-get-sample-threshold)))
			(old_context-sample-transparent (car (gimp-context-get-sample-transparent)))

			(old-brush-size (car (gimp-context-get-brush-size)))
			(old-brush-aspect-ratio (car (gimp-context-get-brush-aspect-ratio)))
			(old-brush-angle (car (gimp-context-get-brush-angle)))
			(old-brush-name (car (gimp-context-get-brush)))

			(width (car (gimp-image-width image)))
			(height (car (gimp-image-height image)))

			(transparence (car (gimp-drawable-has-alpha drawable)))

			(selection_en_cours)
			(nouvelle_image)
			(calque_copie)
			(copier_visible)
			(buffer-name "copier_visible")
			(rvb 0)
			(selection_bounds 0)
			(select_exist 0)
			(select_offset_x 0)
			(select_offset_y 0)
			(select_width 0)
			(select_height 0)
			(Nb_chemins 0)
			(Nom_du_chemin "")
			(sortie_boucle 0)
			(rayon_brosse 0)
			(calque_fond)
			(calque_chemin_1)
			(calque_chemin_2)
			(calque_chemin_3)
			(calque_chemin_4)
			(calque_chemin_5)
			(matrix 0)
			(matrix-list 0)
			(channels 0)
			(sortie_boucle_tracer)

		)


		(gimp-context-set-antialias FALSE)
		(gimp-context-set-feather FALSE)
		(gimp-context-set-feather-radius 0 0)
		(gimp-context-set-sample-merged FALSE)
		(gimp-context-set-sample-criterion 0)
		(gimp-context-set-sample-threshold 0)
		(gimp-context-set-sample-transparent FALSE)

		(gimp-context-set-transform-direction TRANSFORM-FORWARD)
		(gimp-context-set-interpolation 2)
		(gimp-context-set-transform-recursion 3)
		(gimp-context-set-transform-resize TRANSFORM-RESIZE-ADJUST)
		
		(gimp-context-set-paint-mode 0) ;

		
		(gimp-undo-push-group-start image)

		(gimp-selection-none image)





;******************************************************************************************************
; 
;******************************************************************************************************


		(set! copier_visible (car (gimp-edit-named-copy-visible image buffer-name)))

		; crer une nouvelle image rgb
		(set! nouvelle_image (car (gimp-image-new width height 0)))

		(gimp-undo-push-group-start nouvelle_image)

		; crer le premier calque
		(set! calque_copie (car (gimp-layer-new nouvelle_image width height 0 "calque_gris" 100 0)))

		(gimp-image-insert-layer nouvelle_image calque_copie -1 0)

		(gimp-image-select-rectangle nouvelle_image 0  width height 0 0 )

		(set! selection_en_cours (car (gimp-edit-named-paste calque_copie copier_visible 0)))

		(gimp-floating-sel-anchor selection_en_cours)

		(gimp-selection-none nouvelle_image)

		(gimp-layer-add-alpha calque_copie)

		(gimp-levels-stretch calque_copie)
		(gimp-equalize calque_copie TRUE)

		; ajuster taille image  la taille des calques
		(gimp-image-resize-to-layers nouvelle_image)

		(set! calque_copie (car (gimp-image-get-active-layer nouvelle_image)))


		(if (or (= Pretreatments 1) (= Pretreatments 3) ) ; "B For dark images"
			(begin

				(set! matrix-list
					'(
						0		0		0		0		0
						0		1		0		0		0
						0		0		1		0		0
						0		0		0		0		0
						0		0		0		0		0
					 )
				)

				(set! channels (make-vector 5 'long ))

				(vector-set! channels 0 1 )
				(vector-set! channels 1 1 )
				(vector-set! channels 2 1 )
				(vector-set! channels 3 1 )
				(vector-set! channels 4 1 )

				; Convert maxtrix list (25) into matrix array (5x5)
				(define (get-matrix matrix-list)
				  (let* (
						(n 0)
						)
				  (set! n 25 )
				  (define (list-ref l n) (nth n l))
					(let* ((count 0)
						   (matrix (cons-array 25 'double)))
					  (while (< count 25 )
					  (aset matrix count (list-ref matrix-list count))
					  (set! count (+ count 1)))
					  matrix ; Return the matrix array
					)
				  )
				)

				; (plug-in-convmatrix run-mode image drawable argc-matrix matrix alpha-alg divisor offset argc-channels channels bmode)
				(plug-in-convmatrix 1 nouvelle_image calque_copie 25 (set! matrix (get-matrix matrix-list)) 1 1 0 5 channels 0)


			)
		)


		(if (or (= Pretreatments 2) (= Pretreatments 3) ) ; "C Low contrast picture"
			(begin


				(set! matrix-list
					'(
						-1		0		0		0		0
						0		1		0		0		0
						0		0		1		0		0
						0		0		0		0		0
						0		0		0		0		0
					 )
				)

				(set! channels (make-vector 5 'long ))

				(vector-set! channels 0 1 )
				(vector-set! channels 1 1 )
				(vector-set! channels 2 1 )
				(vector-set! channels 3 1 )
				(vector-set! channels 4 1 )

				; Convert maxtrix list (25) into matrix array (5x5)
				(define (get-matrix matrix-list)
				  (let* (
						(n 0)
						)
				  (set! n 25 )
				  (define (list-ref l n) (nth n l))
					(let* ((count 0)
						   (matrix (cons-array 25 'double)))
					  (while (< count 25 )
					  (aset matrix count (list-ref matrix-list count))
					  (set! count (+ count 1)))
					  matrix ; Return the matrix array
					)
				  )
				)

				; (plug-in-convmatrix run-mode image drawable argc-matrix matrix alpha-alg divisor offset argc-channels channels bmode)
				(plug-in-convmatrix 1 nouvelle_image calque_copie 25 (set! matrix (get-matrix matrix-list)) 1 1 0 5 channels 0)



			
			)
		)





		(gimp-desaturate-full calque_copie 1)

		(gimp-posterize calque_copie 6)

		(if (> Rounded_Lines 0) 
			;;;;;(plug-in-gauss 1 nouvelle_image calque_copie (round (+ 1 (/ width 40)))  (round (+ 1 (/ height 40)))   1)
			(plug-in-gauss 1 nouvelle_image calque_copie Rounded_Lines  Rounded_Lines   1)
		)

		(gimp-convert-indexed nouvelle_image 0 0 (+ 2 How_to_use_colored_pencils) 1 1 "")

		(gimp-image-convert-grayscale nouvelle_image)

		(gimp-image-convert-rgb nouvelle_image)

		(gimp-context-set-background Back_Ground_Color)

		; ajouter un calque  la couleur du fond
		(set! calque_fond (car (gimp-layer-new nouvelle_image width height 0 "calque_fond" 100 0)))

		(gimp-image-insert-layer nouvelle_image calque_fond -1 0)

		(gimp-drawable-fill calque_fond 1)

		(gimp-drawable-fill calque_fond 1)

		(gimp-item-set-visible calque_fond TRUE)










		; boucle pour trouver les couleurs et faire une slection par couleur , un chemin
		(while
			(= sortie_boucle 0)
				(begin

					(gimp-image-select-color nouvelle_image 0 calque_copie (list rvb rvb rvb))
					(gimp-selection-feather nouvelle_image 0)

					(set! selection_bounds (gimp-selection-bounds nouvelle_image))
					(set! select_exist (car selection_bounds))
					;(set! select_offset_x (cadr selection_bounds))
					;(set! select_offset_y (caddr selection_bounds))
					;(set! select_width (- (cadr (cddr selection_bounds)) select_offset_x))
					;(set! select_height (- (caddr (cddr selection_bounds)) select_offset_y))
					;(gimp-message (number->string select_exist))

					(if (= select_exist 1)
						(begin
							(set! Nb_chemins (+ Nb_chemins 1) )

							(set! Nom_du_chemin (string-append "Chemin_"  (number->string Nb_chemins) ) )

							;  voir si ncessaire de supprimer la brosse (gimp-brush-delete Nom_du_chemin) avec une condition de test si existe

							(if (= Nb_chemins 1)
								(begin
									; ajouter un calque pour crer le trac du chemin
									(set! calque_chemin_1 (car (gimp-layer-new nouvelle_image width height 0 "calque_chemin_1" 100 0)))
									(gimp-image-insert-layer nouvelle_image calque_chemin_1 -1 0)
									(gimp-item-set-visible calque_chemin_1 TRUE)
									(gimp-layer-add-alpha calque_chemin_1)
									(gimp-drawable-fill calque_chemin_1 3)

									(set! rayon_brosse Pencil_1_Line_Thickness )
									(gimp-context-set-foreground Color_Pencil_1)
								)
							)

							(if (= Nb_chemins 2)
								(begin
									; ajouter un calque pour crer le trac du chemin
									(set! calque_chemin_2 (car (gimp-layer-new nouvelle_image width height 0 "calque_chemin_2" 100 0)))
									(gimp-image-insert-layer nouvelle_image calque_chemin_2 -1 0)
									(gimp-item-set-visible calque_chemin_2 TRUE)
									(gimp-layer-add-alpha calque_chemin_2)
									(gimp-drawable-fill calque_chemin_2 3)

									(set! rayon_brosse Pencil_2_Line_Thickness )
									(gimp-context-set-foreground Color_Pencil_2)
								)
							)

							(if (= Nb_chemins 3)
								(begin
									; ajouter un calque pour crer le trac du chemin
									(set! calque_chemin_3 (car (gimp-layer-new nouvelle_image width height 0 "calque_chemin_3" 100 0)))
									(gimp-image-insert-layer nouvelle_image calque_chemin_3 -1 0)
									(gimp-item-set-visible calque_chemin_3 TRUE)
									(gimp-layer-add-alpha calque_chemin_3)
									(gimp-drawable-fill calque_chemin_3 3)

									(set! rayon_brosse Pencil_3_Line_Thickness )
									(gimp-context-set-foreground Color_Pencil_3)
								)
							)

							(if (= Nb_chemins 4)
								(begin
									; ajouter un calque pour crer le trac du chemin
									(set! calque_chemin_4 (car (gimp-layer-new nouvelle_image width height 0 "calque_chemin_4" 100 0)))
									(gimp-image-insert-layer nouvelle_image calque_chemin_4 -1 0)
									(gimp-item-set-visible calque_chemin_4 TRUE)
									(gimp-layer-add-alpha calque_chemin_4)
									(gimp-drawable-fill calque_chemin_4 3)

									(set! rayon_brosse Pencil_4_Line_Thickness )
									(gimp-context-set-foreground Color_Pencil_4)
								)
							)

							(if (= Nb_chemins 5)
								(begin
									; ajouter un calque pour crer le trac du chemin
									(set! calque_chemin_5 (car (gimp-layer-new nouvelle_image width height 0 "calque_chemin_5" 100 0)))
									(gimp-image-insert-layer nouvelle_image calque_chemin_5 -1 0)
									(gimp-item-set-visible calque_chemin_5 TRUE)
									(gimp-layer-add-alpha calque_chemin_5)
									(gimp-drawable-fill calque_chemin_5 3)

									(set! rayon_brosse Pencil_5_Line_Thickness )
									(gimp-context-set-foreground Color_Pencil_5)
								)
							)

							(if (> Soften 0)
								(begin
									(gimp-selection-grow nouvelle_image Soften)
									(gimp-selection-shrink nouvelle_image Soften)
								)
							)

							; sauvegarde slection vers chemin
							(plug-in-sel2path 1 nouvelle_image calque_copie)

							; donner un nom au chemin
							(gimp-item-set-name (car (gimp-image-get-active-vectors nouvelle_image)) Nom_du_chemin )

							(if (= Use_a_custom_brush 0)
								(begin

									; crer une brosse
									(gimp-brush-new Nom_du_chemin)				

									(gimp-context-set-brush-size (/ rayon_brosse 2))
									;;;(gimp-context-set-brush-default-size)
									(gimp-context-set-brush-aspect-ratio 1)
									(gimp-context-set-brush-angle 0)
									
									(gimp-context-set-brush Nom_du_chemin)

									(gimp-brush-set-shape Nom_du_chemin The_shape_of_the_generated_brush) ; forme

									(gimp-brush-set-radius Nom_du_chemin (/ rayon_brosse 2) ) ; rayon

									(gimp-brush-set-spikes Nom_du_chemin 2) ; pointes
									(gimp-brush-set-hardness Nom_du_chemin 1.0) ; duret 
									(gimp-brush-set-aspect-ratio Nom_du_chemin 1 ) ; proportions
									(gimp-brush-set-angle Nom_du_chemin 0) ; angle
									(gimp-brush-set-spacing Nom_du_chemin 1.0 ) ; espacement

									; slectionner brosse
									(gimp-context-set-brush Nom_du_chemin)
								)
								;else
								(begin
									;;;(gimp-context-set-brush-size (/ rayon_brosse 2))
									;;;(gimp-context-set-brush-default-size)
									(gimp-context-set-brush-aspect-ratio 1)
									(gimp-context-set-brush-angle 0)

									; slectionner brosse
									(gimp-context-set-brush (car Custom_brush))

								)
							)

							; tracer la slection
							;(gimp-edit-stroke calque_chemin_1)
							
							(gimp-selection-none nouvelle_image)

							(if (= Nb_chemins 1)
								(begin
									(set! sortie_boucle_tracer Color_intensity)
									(while (> sortie_boucle_tracer 0)
										(begin
											; tracer le chemin : les rsultats sont plus beaux qu'avec la slection
											(gimp-edit-stroke-vectors calque_chemin_1 (car (gimp-image-get-active-vectors nouvelle_image) ) )
											(set! sortie_boucle_tracer (- sortie_boucle_tracer 1) )
										)
									)
								)
							)

							(if (= Nb_chemins 2)
								(begin
									(set! sortie_boucle_tracer Color_intensity)
									(while (> sortie_boucle_tracer 0)
										(begin
											; tracer le chemin : les rsultats sont plus beaux qu'avec la slection
											(gimp-edit-stroke-vectors calque_chemin_2 (car (gimp-image-get-active-vectors nouvelle_image) ) )
											(set! sortie_boucle_tracer (- sortie_boucle_tracer 1) )
										)
									)
								)
							)

							(if (= Nb_chemins 3)
								(begin
									(set! sortie_boucle_tracer Color_intensity)
									(while (> sortie_boucle_tracer 0)
										(begin
											; tracer le chemin : les rsultats sont plus beaux qu'avec la slection
											(gimp-edit-stroke-vectors calque_chemin_3 (car (gimp-image-get-active-vectors nouvelle_image) ) )
											(set! sortie_boucle_tracer (- sortie_boucle_tracer 1) )
										)
									)
								)
							)

							(if (= Nb_chemins 4)
								(begin
									(set! sortie_boucle_tracer Color_intensity)
									(while (> sortie_boucle_tracer 0)
										(begin
											; tracer le chemin : les rsultats sont plus beaux qu'avec la slection
											(gimp-edit-stroke-vectors calque_chemin_4 (car (gimp-image-get-active-vectors nouvelle_image) ) )
											(set! sortie_boucle_tracer (- sortie_boucle_tracer 1) )
										)
									)
								)
							)

							(if (= Nb_chemins 5)
								(begin
									(set! sortie_boucle_tracer Color_intensity)
									(while (> sortie_boucle_tracer 0)
										(begin
											; tracer le chemin : les rsultats sont plus beaux qu'avec la slection
											(gimp-edit-stroke-vectors calque_chemin_5 (car (gimp-image-get-active-vectors nouvelle_image) ) )
											(set! sortie_boucle_tracer (- sortie_boucle_tracer 1) )
										)
									)
								)
							)

							(if (= Use_a_custom_brush 0)
								; supprimer la brosse cre
								(gimp-brush-delete Nom_du_chemin)
							)



						)
					)

					(set! rvb (+ rvb 1) )
					(if (or (= rvb 256) (= Nb_chemins 5) (= Nb_chemins (+ How_to_use_colored_pencils 1) )  )
						(begin

							(set! sortie_boucle 1 )							
						)
					)





				)
		)



		(set! selection_en_cours (car (gimp-edit-named-paste calque_copie copier_visible 0)))

		(gimp-floating-sel-anchor selection_en_cours)

		(gimp-selection-none nouvelle_image)

		(gimp-image-set-active-layer nouvelle_image calque_chemin_1)







		(gimp-undo-push-group-end nouvelle_image)
		(gimp-display-new nouvelle_image)



;******************************************************************************************************
; 
;******************************************************************************************************


		; aplatir l'image
		(if
			(= flatten TRUE)
				(gimp-image-flatten nouvelle_image)
		)	







;******************************************************************************************************

		;; rtablir le mode message
		(gimp-message-set-handler message)

		(gimp-context-set-transform-direction old_context_transform_direction )
		(gimp-context-set-interpolation old_context_interpolation)
		(gimp-context-set-transform-recursion old_context_recursion)
		(gimp-context-set-transform-resize old_context_transform_resize)
		(gimp-context-set-background old-bg)
		(gimp-context-set-foreground old-fg)


		(gimp-context-set-antialias old_context-antialias)
		(gimp-context-set-feather old_context-feather)
		(gimp-context-set-feather-radius old_context-feather-radiusx old_context-feather-radiusy)
		(gimp-context-set-sample-merged old_context-sample-merged)
		(gimp-context-set-sample-criterion old_ontext-sample-criterion)
		(gimp-context-set-sample-threshold old_context-sample-threshold)
		(gimp-context-set-sample-transparent old_context-sample-transparent)

		(gimp-context-set-brush-default-size)
		(gimp-context-set-brush-size old-brush-size)
		(gimp-context-set-brush-aspect-ratio old-brush-aspect-ratio)
		(gimp-context-set-brush-angle old-brush-angle)		
		(gimp-context-set-brush old-brush-name)



		(gimp-undo-push-group-end image)
		(gimp-displays-flush)


	)
)





(script-fu-register "Les_chemins_colores_samj"
                    _"<Image>/Temp/Les Chemins Colores ..."
                    "Graffitis, Dessins pour les enfants, etc."
                    "samj"
                    "samj"
                    "20130401"
                    "RGB*"
                    SF-IMAGE    "Image"     0
                    SF-DRAWABLE "Drawable"  0
					SF-OPTION "Pretreatments " '("A  Without" "B  For dark images" "C  Low contrast picture" "  B + C  ")
					SF-ADJUSTMENT "Rounded Lines (blur) " '(0 0 60 1 5 0 1)
					SF-ADJUSTMENT "Soften " '(2 0 60 1 5 0 1)
					SF-OPTION "How to use colored pencils " '("Pencil 1" "Pencils 1 2" "Pencils 1 2 3" "Pencils 1 2 3 4" "Pencils 1 2 3 4 5")
					SF-COLOR "Color Pencil 1 " '(0 0 0)
					SF-ADJUSTMENT "Pencil 1 - Line Thickness " '(2 2 20 1 5 0 1)
					SF-COLOR "Color Pencil 2 " '(255 0 0)
					SF-ADJUSTMENT "Pencil 2 - Line Thickness " '(2 2 20 1 5 0 1)
					SF-COLOR "Color Pencil 3 " '(0 255 0)
					SF-ADJUSTMENT "Pencil 3 - Line Thickness " '(2 2 20 1 5 0 1)
					SF-COLOR "Color Pencil 4 " '(0 0 255)
					SF-ADJUSTMENT "Pencil 4 - Line Thickness " '(2 2 20 1 5 0 1)
					SF-COLOR "Color Pencil 5 " '(255 255 0)
					SF-ADJUSTMENT "Pencil 5 - Line Thickness " '(2 2 20 1 5 0 1)
					SF-COLOR "Back Ground Color " '(255 255 255)
					SF-OPTION "The shape of the generated brush " '("Circle" "Square" "Diamond" )
					SF-ADJUSTMENT "Color intensity " '(3 1 10 1 5 0 1)
					SF-TOGGLE "Use a custom brush " FALSE
					SF-BRUSH "Choice of custom brush " '("Pencil Scratch" 100 -1 0)
					SF-TOGGLE "Flatten" FALSE

)

;; FIN





