; Script-Fu Motif_Geometrique_1.scm
; Download : 
;
;	Copyright (C) 2013 samj ( http://aljacom.com/~gmic/ )
;
;	Licence GPL
;		Ce fichier est le Script-Fu "Motif_Geometrique_1.scm" pour Gimp. 
;		Ce Script-Fu "Motif_Geometrique_1.scm" est un logiciel libre ; vous pouvez le redistribuer ou le modifier suivant les termes de la GNU General Public License
;		telle que publie par la Free Software Foundation ; soit la version 3 de la licence, soit ( votre gr) toute version ultrieure.
;		Ce Script-Fu "Motif_Geometrique_1.scm" est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; 
;		pas mme la garantie implicite de COMMERCIABILISABILIT ni d'ADQUATION  UN OBJECTIF PARTICULIER.
;		Consultez la GNU General Public License pour plus de dtails.
;		Vous devez avoir reu une copie de la GNU General Public License en mme temps que GIMP ; si ce n'est pas le cas, consultez <http://www.gnu.org/licenses>
;
;	Ce fichier Motif_Geometrique_1.scm est dit avec Notepad++    http://notepad-plus-plus.org/
;
;
;	Version 20130402
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;
;	Accs sur l'image par :
;
;	Fichier > Crer > Motifs > 3D Motif Geometrique 1 ...
;	File > Create > Patterns > 3D Motif Geometrique 1 ...
;
;
;
;
;	Principe :
;				     H1  H2
;				     ___ ___
;				V1  |       |
;				V2  |       |
;				V3  |       |
;				V4  |___ ___|
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;

		
(define	
	(
		Motif_Geometrique_1_3D_samj
		H1
		H2
		V1
		V2
		V3
		V4
		Color_1
		Color_2
		Color_3
		Save_Pattern
		Object_Name


		
	)
	(let* 
		(

			(message (car (gimp-message-get-handler)))
			(old_context_transform_direction (car (gimp-context-get-transform-direction)))
			(old_context_interpolation (car (gimp-context-get-interpolation)))
			(old_context_recursion (car (gimp-context-get-transform-recursion)))
			(old_context_transform_resize (car (gimp-context-get-transform-resize)))
			(old-fg (car (gimp-context-get-foreground)))
			(old-bg (car (gimp-context-get-background)))

			(old_context-antialias (car (gimp-context-get-antialias)))
			(old_context-feather (car (gimp-context-get-feather)))
			(old_context-feather-radiusx (car (gimp-context-get-feather-radius)))
			(old_context-feather-radiusy (cadr (gimp-context-get-feather-radius)))
			(old_context-sample-merged (car (gimp-context-get-sample-merged)))
			(old_ontext-sample-criterion (car (gimp-context-get-sample-criterion)))
			(old_context-sample-threshold (car (gimp-context-get-sample-threshold)))
			(old_context-sample-transparent (car (gimp-context-get-sample-transparent)))

			(old-brush-size (car (gimp-context-get-brush-size)))
			(old-brush-aspect-ratio (car (gimp-context-get-brush-aspect-ratio)))
			(old-brush-angle (car (gimp-context-get-brush-angle)))
			(old-brush-name (car (gimp-context-get-brush)))

			; crer une image pour le motif
			(image (car (gimp-image-new (+ H1 H2) (+ V1 V2 V3 V4) 0)))

			; crer le calque calque_motif
			(calque_motif (car (gimp-layer-new image (+ H1 H2) (+ V1 V2 V3 V4) 1 "calque_motif" 100 0)))

			; array
			(*points*)

			(path)




		)

		(gimp-undo-push-group-start image)

		(gimp-image-insert-layer image calque_motif -1 0)

		(gimp-layer-add-alpha calque_motif)







;******************************************************************************************************
; 
;******************************************************************************************************


	; triangle haut gauche
		
		(set! *points* (cons-array 6 'double))

		; dterminer les coordonnes des 3 points
		(vector-set! *points* 0 0 )					; x0
		(vector-set! *points* 1 0 )					; y0
		(vector-set! *points* 2 H1 )				; x1
		(vector-set! *points* 3 0 )					; y1
		(vector-set! *points* 4 0 )					; x2
		(vector-set! *points* 5 V1 )				; y2


		(gimp-image-select-polygon 
			image					; image 
			2						; operation 
			6						; num-segs 
			*points*				; segs
		)

		(gimp-context-set-foreground Color_3)

		(gimp-edit-bucket-fill calque_motif 0 0 100 0 FALSE 0 0)

		(gimp-selection-none image)







	; losange haut gauche

		(set! *points* (cons-array 8 'double))

		; dterminer les coordonnes des 4 points
		(vector-set! *points* 0 0 )					; x0
		(vector-set! *points* 1 V1 )				; y0
		(vector-set! *points* 2 H1 )				; x1
		(vector-set! *points* 3 0 )					; y1
		(vector-set! *points* 4 H1 )				; x2
		(vector-set! *points* 5 V1 )				; y2
		(vector-set! *points* 6 0  )				; x3
		(vector-set! *points* 7 (+ V1 V2) )			; y3

		(gimp-image-select-polygon 
			image					; image 
			2						; operation 
			8						; num-segs 
			*points*				; segs
		)

		(gimp-context-set-foreground Color_1)

		(gimp-edit-bucket-fill calque_motif 0 0 100 0 FALSE 0 0)

		(gimp-selection-none image)


	; losange milieu

		(set! *points* (cons-array 8 'double))

		; dterminer les coordonnes des 4 points
		(vector-set! *points* 0 0 )					; x0
		(vector-set! *points* 1 (+ V1 V2) )			; y0
		(vector-set! *points* 2 H1 )				; x1
		(vector-set! *points* 3 V1 )				; y1
		(vector-set! *points* 4 (+ H1 H2) )			; x2
		(vector-set! *points* 5 (+ V1 V2) )			; y2
		(vector-set! *points* 6 H1  )				; x3
		(vector-set! *points* 7 (+ V1 V2 V3) )		; y3

		(gimp-image-select-polygon 
			image					; image 
			2						; operation 
			8						; num-segs 
			*points*				; segs
		)

		(gimp-context-set-foreground Color_3)

		(gimp-edit-bucket-fill calque_motif 0 0 100 0 FALSE 0 0)

		(gimp-selection-none image)


	; losange bas gauche

		(set! *points* (cons-array 8 'double))

		; dterminer les coordonnes des 4 points
		(vector-set! *points* 0 0 )					; x0
		(vector-set! *points* 1 (+ V1 V2) )			; y0
		(vector-set! *points* 2 H1 )				; x1
		(vector-set! *points* 3 (+ V1 V2 V3) )		; y1
		(vector-set! *points* 4 H1 )				; x2
		(vector-set! *points* 5 (+ V1 V2 V3 V4) )	; y2
		(vector-set! *points* 6 0 )					; x3
		(vector-set! *points* 7 (+ V1 V2 V3) )		; y3

		(gimp-image-select-polygon 
			image					; image 
			2						; operation 
			8						; num-segs 
			*points*				; segs
		)

		(gimp-context-set-foreground Color_2)

		(gimp-edit-bucket-fill calque_motif 0 0 100 0 FALSE 0 0)

		(gimp-selection-none image)


	; triangle bas gauche
		
		(set! *points* (cons-array 6 'double))

		; dterminer les coordonnes des 3 points
		(vector-set! *points* 0 0 )					; x0
		(vector-set! *points* 1 (+ V1 V2 V3) )		; y0
		(vector-set! *points* 2 H1 )				; x1
		(vector-set! *points* 3 (+ V1 V2 V3 V4) )	; y1
		(vector-set! *points* 4 0 )					; x2
		(vector-set! *points* 5 (+ V1 V2 V3 V4) )	; y2


		(gimp-image-select-polygon 
			image					; image 
			2						; operation 
			6						; num-segs 
			*points*				; segs
		)

		(gimp-context-set-foreground Color_3)

		(gimp-edit-bucket-fill calque_motif 0 0 100 0 FALSE 0 0)

		(gimp-selection-none image)




	; triangle haut droite
		
		(set! *points* (cons-array 6 'double))

		; dterminer les coordonnes des 3 points
		(vector-set! *points* 0 H1 )				; x0
		(vector-set! *points* 1 0 )					; y0
		(vector-set! *points* 2 (+ H1 H2) )			; x1
		(vector-set! *points* 3 0 )					; y1
		(vector-set! *points* 4 (+ H1 H2) )			; x2
		(vector-set! *points* 5 V1 )				; y2


		(gimp-image-select-polygon 
			image					; image 
			2						; operation 
			6						; num-segs 
			*points*				; segs
		)

		(gimp-context-set-foreground Color_3)

		(gimp-edit-bucket-fill calque_motif 0 0 100 0 FALSE 0 0)

		(gimp-selection-none image)




	; losange haut droite

		(set! *points* (cons-array 8 'double))

		; dterminer les coordonnes des 4 points
		(vector-set! *points* 0 H1 )			; x0
		(vector-set! *points* 1 0 )				; y0
		(vector-set! *points* 2 (+ H1 H2) )		; x1
		(vector-set! *points* 3 V1 )			; y1
		(vector-set! *points* 4 (+ H1 H2) )		; x2
		(vector-set! *points* 5 (+ V1 V2) )		; y2
		(vector-set! *points* 6 H1  )			; x3
		(vector-set! *points* 7 V1 )			; y3

		(gimp-image-select-polygon 
			image					; image 
			2						; operation 
			8						; num-segs 
			*points*				; segs
		)

		(gimp-context-set-foreground Color_2)

		(gimp-edit-bucket-fill calque_motif 0 0 100 0 FALSE 0 0)

		(gimp-selection-none image)


	; losange bas droite

		(set! *points* (cons-array 8 'double))

		; dterminer les coordonnes des 4 points
		(vector-set! *points* 0 (+ H1 H2) )			; x0
		(vector-set! *points* 1 (+ V1 V2) )			; y0
		(vector-set! *points* 2 (+ H1 H2) )			; x1
		(vector-set! *points* 3 (+ V1 V2 V3) )		; y1
		(vector-set! *points* 4 H1 )				; x2
		(vector-set! *points* 5 (+ V1 V2 V3 V4) )	; y2
		(vector-set! *points* 6 H1  )				; x3
		(vector-set! *points* 7 (+ V1 V2 V3) )		; y3

		(gimp-image-select-polygon 
			image					; image 
			2						; operation 
			8						; num-segs 
			*points*				; segs
		)

		(gimp-context-set-foreground Color_1)

		(gimp-edit-bucket-fill calque_motif 0 0 100 0 FALSE 0 0)

		(gimp-selection-none image)




	; triangle bas droite
		
		(set! *points* (cons-array 6 'double))

		; dterminer les coordonnes des 3 points
		(vector-set! *points* 0 (+ H1 H2) )			; x0
		(vector-set! *points* 1 (+ V1 V2 V3) )		; y0
		(vector-set! *points* 2 (+ H1 H2) )			; x1
		(vector-set! *points* 3 (+ V1 V2 V3 V4) )	; y1
		(vector-set! *points* 4 H1 )				; x2
		(vector-set! *points* 5 (+ V1 V2 V3 V4) )	; y2


		(gimp-image-select-polygon 
			image					; image 
			2						; operation 
			6						; num-segs 
			*points*				; segs
		)

		(gimp-context-set-foreground Color_3)

		(gimp-edit-bucket-fill calque_motif 0 0 100 0 FALSE 0 0)

		(gimp-selection-none image)



		(if (= Save_Pattern 1)
			(begin
				; dterminer le chemin complet du motif  sauvegarder
				(set! path (string-append gimp-directory "/patterns/Ready_4_More/" (strcat Object_Name "_" (number->string (+ H1 H2) ) "_" (number->string (+ V1 V2 V3 V4) )   ".pat") ) )

				; sauvegarder le motif sous :  "Object_Name"_"Selection_Size".pat
				(file-pat-save 1 image (car (gimp-image-get-active-layer image)) path path (strcat Object_Name "_" (number->string (+ H1 H2) ) "_" (number->string (+ V1 V2 V3 V4) ) ) )

				; mettre  jour les motifs dans Gimp
				(gimp-patterns-refresh)

				; choisir le motif comme motif actif
				(gimp-context-set-pattern (strcat Object_Name "_" (number->string (+ H1 H2) ) "_" (number->string (+ V1 V2 V3 V4) ) ) )

				(gimp-image-delete image)

				(gimp-message (string-append "Pattern Path :\n" path "\nPattern Name:\n" Object_Name "_" (number->string (+ H1 H2) ) "_" (number->string (+ V1 V2 V3 V4) ) ) )
			)
			;else
			(begin

				(gimp-item-set-visible calque_motif TRUE)

				; afficher l'image
				(gimp-display-new image)

				(gimp-undo-push-group-end image)
				(gimp-displays-flush)

			)
		)









;******************************************************************************************************
; 
;******************************************************************************************************







;******************************************************************************************************

		;; rtablir le mode message
		(gimp-message-set-handler message)

		(gimp-context-set-transform-direction old_context_transform_direction )
		(gimp-context-set-interpolation old_context_interpolation)
		(gimp-context-set-transform-recursion old_context_recursion)
		(gimp-context-set-transform-resize old_context_transform_resize)
		(gimp-context-set-background old-bg)
		(gimp-context-set-foreground old-fg)


		(gimp-context-set-antialias old_context-antialias)
		(gimp-context-set-feather old_context-feather)
		(gimp-context-set-feather-radius old_context-feather-radiusx old_context-feather-radiusy)
		(gimp-context-set-sample-merged old_context-sample-merged)
		(gimp-context-set-sample-criterion old_ontext-sample-criterion)
		(gimp-context-set-sample-threshold old_context-sample-threshold)
		(gimp-context-set-sample-transparent old_context-sample-transparent)

		(gimp-context-set-brush-default-size)
		(gimp-context-set-brush-size old-brush-size)
		(gimp-context-set-brush-aspect-ratio old-brush-aspect-ratio)
		(gimp-context-set-brush-angle old-brush-angle)		
		(gimp-context-set-brush old-brush-name)






	)
)





(script-fu-register "Motif_Geometrique_1_3D_samj"
                    _"<Image>/File/Create/Patterns/3D Motif Geometrique 1 ..."
                    "Motif aspect 3D"
                    "samj"
                    "samj"
                    "20130402"
                    ""
					SF-ADJUSTMENT "X 1 " '(16 1 128 1 5 0 1)
					SF-ADJUSTMENT "X 2 " '(16 1 128 1 5 0 1)
					SF-ADJUSTMENT "V 1 " '(16 1 64 1 5 0 1)
					SF-ADJUSTMENT "V 2 " '(16 1 64 1 5 0 1)
					SF-ADJUSTMENT "V 3 " '(16 1 64 1 5 0 1)
					SF-ADJUSTMENT "V 4 " '(16 1 64 1 5 0 1)
					SF-COLOR "Color 1 " '(0 0 255)
					SF-COLOR "Color 2 " '(255 0 0)
					SF-COLOR "Color 3 " '(255 255 255)
					SF-TOGGLE "Save Pattern" FALSE
					SF-STRING "Pattern Name to save (DO NOT PUT SPACES) "    "3d_Motif_Geometrique_1"


)

;; FIN





