(define	
	(   script-fu-polygon-from-selection
		image
		drawable
		Nombre_de_sommets
		Angle_de_depart)
		
	(let* 
		(	(2pi (* 2 3.14159265358979323846) )

			(Nom_de_la_brosse "Ma_Brosse_Spirale_samj")
			(The_shape_of_the_generated_brush 0) ; "Circle" "Square" "Diamond"
			(sortie_boucle_tracer 0)
            (width (car (gimp-image-width image)))
			(height (car (gimp-image-height image)))
            (transparence (car (gimp-drawable-has-alpha drawable)))

			(Carateristiques_Selection (gimp-selection-bounds image))
			(Selection_Existe (car Carateristiques_Selection))
			(Selection_X1 (cadr Carateristiques_Selection))
			(Selection_Y1 (caddr Carateristiques_Selection))
			(Selection_X2 (cadr (cddr Carateristiques_Selection)))
			(Selection_Y2 (caddr (cddr Carateristiques_Selection)))

			(Centre_Ellipse_X (/ (+ Selection_X1 Selection_X2) 2) )
			(Centre_Ellipse_Y (/ (+ Selection_Y1 Selection_Y2) 2) )
			(a_Ellipse  (/ (- Selection_X2 Selection_X1) 2) )
			(b_Ellipse  (/ (- Selection_Y2 Selection_Y1) 2) )

			(Angle_polygone (/ 2pi Nombre_de_sommets) )
			(Angle_etoile (/ 3.14159265358979323846 Nombre_de_sommets) )

			(sortie_boucle 0)
			(nombre_de_boucle 0)
			(angle_en_cours 0)

			(Sommet_X 0)
			(Sommet_Y 0)

			(chemin_selection)
			(Points_chemin_selection)
			(Ajout_Points_chemin_selection)
			(Nombre_Points_chemin_selection 0)

			(filename "qwerty")

			(chemin_reduit)
			(Points_chemin_reduit)
			(Ajout_Points_chemin_reduit)

			(Sommet_X_chemin_reduit 0)
			(Sommet_Y_chemin_reduit 0)



		)


	


		
		(gimp-undo-push-group-start image) 
		
		(gimp-context-push)

		
;******************************************************************************************************
; 
;******************************************************************************************************

		

		
			



				;transformation degrs radians
				(set! Angle_de_depart (* (/ 2pi 360) Angle_de_depart) )


				(set! sortie_boucle 0)
				(set! nombre_de_boucle -1)

				;******************************************************************************************************
				; Polygon
				;******************************************************************************************************


				

						(while (= sortie_boucle 0)
							(begin

								(set! nombre_de_boucle (+ nombre_de_boucle 1) )

								;condition de sortie
								(if (> nombre_de_boucle Nombre_de_sommets)
									(begin
										(set! sortie_boucle 1)
									)
									;else
									(begin

										(set! angle_en_cours (+ Angle_de_depart (* nombre_de_boucle Angle_polygone) ) )

										(set! Sommet_X (+ Centre_Ellipse_X (* a_Ellipse (cos angle_en_cours) ) )  )
										(set! Sommet_Y (+ Centre_Ellipse_Y (* b_Ellipse (sin angle_en_cours) ) )  )
										; (gimp-message (string-append " X-Y : " (number->string Sommet_X)   "-"   (number->string Sommet_Y) ) )
										
										; chemin rduit
										(set! Sommet_X_chemin_reduit (+ Centre_Ellipse_X (/ (* a_Ellipse (cos angle_en_cours) ) 10) )  )
										(set! Sommet_Y_chemin_reduit (+ Centre_Ellipse_Y (/ (* b_Ellipse (sin angle_en_cours) ) 10) )  )

										(if (= nombre_de_boucle 0)
											(begin
												(set! Points_chemin_selection (list Sommet_X Sommet_Y Sommet_X Sommet_Y Sommet_X Sommet_Y ) )
												(set! Nombre_Points_chemin_selection 6 )

												

											)
											;else
											(begin
												(set! Ajout_Points_chemin_selection (list Sommet_X Sommet_Y Sommet_X Sommet_Y Sommet_X Sommet_Y ) )
												(set! Points_chemin_selection (append Points_chemin_selection Ajout_Points_chemin_selection) )
												(set! Nombre_Points_chemin_selection (+ 6 Nombre_Points_chemin_selection ) )

												

											)
										)

									)
								)


							)
						)

						; sauvegarder la slection en cours comme chemin
						(plug-in-sel2path 1 image drawable)
						(gimp-item-set-name (car (gimp-image-get-active-vectors image) ) "Origine" )
						(gimp-selection-none image)


						


						; crer le nouveau chemin
						(set! chemin_selection (car (gimp-vectors-new image (strcat "Polygon_" (number->string Nombre_de_sommets) "_"  (number->string a_Ellipse) "_"  (number->string b_Ellipse)    )   ) )  ) 
						(gimp-image-insert-vectors image chemin_selection 0 -1)

						(gimp-vectors-stroke-new-from-points
							chemin_selection
							0
							Nombre_Points_chemin_selection
							(list->vector Points_chemin_selection )
							1
						)

						

						; transformer le chemin en slection
						(gimp-image-select-item image 0 (car (gimp-image-get-active-vectors image)))

;******************************************************************************************************
; 
;******************************************************************************************************

		

		; restituer l'ancien contexte.  Recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		(gimp-context-pop)

		; End undo. Recommand par Saulgoode pour nouvelle image http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		;(gimp-image-undo-enable image)

		; pour image existante
		(gimp-undo-push-group-end image)

		(gimp-displays-flush)

	)
)





; Nouvelle mthode recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
(script-fu-register "script-fu-polygon-from-selection"
                    "Polygon from Selection ..."
					"Instrucyions"
                    "samj"
                    "samj"
                    "20130609"
                    "RGB*"
                    SF-IMAGE    "Image"     0
                    SF-DRAWABLE "Drawable"  0
					SF-ADJUSTMENT "Number of vertices / Nombre de sommets " '(4 3 90 1 5 0 1)
					SF-ADJUSTMENT "Departure Angle / Angle de depart " '(0 0 360 1 5 4 1)
)

; Nouvelle mthode recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
(script-fu-menu-register "script-fu-polygon-from-selection"
					_"<Image>/Temp"
)
