; Dbut du script-fu Round_Web_2_0_Button_with_a_Metal_Ring_gimp_2_8.scm
;
; Un bouton style Web 2.0 avec anneau mtallique
;
; Accs par :   Fichier > Crer > Boutons > Round Web 2.0 Button with a Metal Ring...
;
; Script cr en utilisant le didacticiel   :  "October 24th, 2008, in Web Design by yay"
;                                  Site     :  http://mygimptutorial.com/round-web-20-button-with-a-metal-ring
; 
;
;
; Licence GNU/GPL
;
; --------------------------------------------------------------------
; version 1.0 par samj (www.aljacom.com/~gimp) 2010/12/06
; version 1.01 par samj (www.aljacom.com/~gimp) 2010/12/06 correction c2
; version 1.1 par samj (www.aljacom.com/~gimp) 2010/12/09 modifications pour Gimp 2.7.2 
; version 1.2 par samj (www.aljacom.com/~gimp) 2011/05/16 modifications pour Gimp 2.7.3 
; --------------------------------------------------------------------
;
;

(define (
							Round_Web_2_0_Button_with_a_Metal_Ring 
							Diametre_Bouton_x
							Diametre_Bouton_y
							Pourcentage_Anneau
							Couleur_Bouton
							Couleur_Degrade ; plus claire que Couleur_Bouton
							coeff_adapt_gloss
		)

	; vrification diamitres
	(if 
		(< Diametre_Bouton_x 10) 
			(begin
				(set! Diametre_Bouton_x 160)
				(gimp-message "ERROR Round_Web_2_0_Button_with_a_Metal_Ring : Diameter x<10")
			)
	)
	
	(if 
		(< Diametre_Bouton_y 10) 
			(begin
				(set! Diametre_Bouton_y 160)
				(gimp-message "ERROR Round_Web_2_0_Button_with_a_Metal_Ring : Diameter y<10")
			)
	)	

	; vrification Pourcentage_Anneau
	(if 
		(> Pourcentage_Anneau 70) 
			(begin
				(set! Pourcentage_Anneau 10)
				(gimp-message "ERROR Round_Web_2_0_Button_with_a_Metal_Ring : Pourcentage_Anneau>70")
			)
	)

	(if 
		(< Pourcentage_Anneau 3) 
			(begin
				(set! Pourcentage_Anneau 10)
				(gimp-message "ERROR Round_Web_2_0_Button_with_a_Metal_Ring : Pourcentage_Anneau<3")
			)
	)	
	
	
	
		
	(let*
		(
			; affectation des variables			
			
			(width (* 1.5 Diametre_Bouton_x))
			
			(height ( * 1.5 Diametre_Bouton_y))
			
			
			; mmoriser les couleurs PP et AP
			(old-fg (car (gimp-context-get-foreground)))
			(old-bg (car (gimp-context-get-background)))
			
			; crer une nouvelle image rgb
			(img (car (gimp-image-new width height 0)))
			
			; crer le premier calque
			(calque_1 (car (gimp-layer-new img width height 1 "Background" 100 0)))	
			
			; crer calque 2
			(calque_2 (car (gimp-layer-new img width height 1 "ring" 100 0)))	
			
			; crer calque 3
			(calque_3 (car (gimp-layer-new img width height 1 "sphere" 100 0)))				
			

			; crer calque 4
			(calque_4 (car (gimp-layer-new img width height 1 "inner shadow" 100 0)))	


			; crer calque 5
			(calque_5 (car (gimp-layer-new img width height 1 "inner shadow bis" 100 0)))


			; crer calque 6
			(calque_6 (car (gimp-layer-new img width height 1 "gloss" 75 0)))			
			

			; crer calque 7
			(calque_7 (car (gimp-layer-new img width height 1 "text logo" 100 0)))
			
			(calque_8)
			
			(calque_9)

			(calque_10)
			
			
			(shrink)
			(shrink2)
			(rayon_ellipse_x)
			(rayon_ellipse_y)
			(hauteur_bulle)
			(c1)
			(c2)

			

		)
		
	;; Start undo group.
	(gimp-image-undo-group-start img)		



	

; calque 1 *******************************************************************************		
		
	; ajouter le premier calque
	(gimp-image-insert-layer img calque_1 0 0 )
	
	; appliquer blanc sur PP
	(gimp-context-set-foreground '(255 255 255))


	; remplir de PP	
	(gimp-drawable-fill calque_1 0)
	

	
	
		
; calque 2 *******************************************************************************		
		
	; ajouter le calque
	(gimp-image-insert-layer img calque_2 -1 0)
	
	; crer une slection ronde centre sur l'image
	;(gimp-ellipse-select 
	;					img 
	;					(/ (- width Diametre_Bouton_x) 2) ; x 
	;					(/ (- height Diametre_Bouton_y) 2) ; y 
	;					Diametre_Bouton_x ; width 
	;					Diametre_Bouton_y ; height 
	;					0 ; operation 
	;					TRUE ; antialias 
	;					FALSE ; feather 
	;					0 ; feather-radius
	;)
	; modifications gimp 2.7.3
	(gimp-context-set-antialias TRUE)
	(gimp-context-set-feather FALSE)
	; (gimp-context-set-feather-radius feather-radius-x feather-radius-y)
	(gimp-context-set-feather-radius 0 0)
	;(gimp-ellipse-select image x y width height operation antialias feather feather-radius)
	;(gimp-image-select-ellipse image operation x y width height)
	(gimp-image-select-ellipse 
						img ; image 
						0 ; operation 
						(/ (- width Diametre_Bouton_x) 2) ; x 
						(/ (- height Diametre_Bouton_y) 2) ; y 
						Diametre_Bouton_x ; width 
						Diametre_Bouton_y ; height 
	)
	
	
		
	; slection vers chemin
	(plug-in-sel2path 1 img calque_2)


	; couleur de PP 333333
	(gimp-context-set-foreground '(51 51 51))	
	
	; couleur de AP ffffff
	(gimp-context-set-background '(255 255 255))

	
	
	;(gimp-message  (number->string            (/ (- height Diametre_Bouton_y) 2)       ) )	
	
	;(gimp-message  (number->string            (+  Diametre_Bouton_y  (/ (- height Diametre_Bouton_y) 2)  )              ) )	
	
	
	; appliquer un dgrad sur calque_2
	(gimp-edit-blend 
					calque_2 ; drawable
					1 ; blend-mode		FG-BG-RGB-MODE
					0 ; paint-mode
					2 ; gradient-type		 GRADIENT-RADIAL
					100 ; opacity
					0 ; offset
					0 ; repeat
					TRUE ; reverse
					TRUE ; supersample
					3 ; max-depth
					0.2 ; threshold
					TRUE ; dither
					(/ width 2) ; x1 
					(/ (- height Diametre_Bouton_y) 2) ; y1 
					(/ width 2) ; x2
					(+  Diametre_Bouton_y  (/ (- height Diametre_Bouton_y) 2)  ) ; y2
	)


	; calcul taux diminution slection
	(if 
		(> Diametre_Bouton_x Diametre_Bouton_y) 
			(set! shrink (round (/ Diametre_Bouton_y Pourcentage_Anneau )))
			; else
			(set! shrink (round (/ Diametre_Bouton_x Pourcentage_Anneau )))

	)	
	

	; diminuer la slection
	(gimp-selection-shrink img shrink)

	; slection vers chemin
	(plug-in-sel2path 1 img calque_2)

	;(gimp-message  (number->string            (+ (/ (- height Diametre_Bouton_y) 2) shrink 2)              ) )	

	;(gimp-message  (number->string            (- (+  Diametre_Bouton_y  (/ (- height Diametre_Bouton_y) 2)  ) shrink )              ) )		
	
	; appliquer un dgrad sur calque_2
	(gimp-edit-blend 
					calque_2 ; drawable
					1 ; blend-mode		FG-BG-RGB-MODE
					0 ; paint-mode
					2 ; gradient-type		 GRADIENT-RADIAL
					100 ; opacity
					0 ; offset
					0 ; repeat
					FALSE ; reverse
					TRUE ; supersample
					3 ; max-depth
					0.2 ; threshold
					TRUE ; dither
					(/ width 2) ; x1 
					(+ (/ (- height Diametre_Bouton_y) 2) shrink 2) ; y1 
					(/ width 2) ; x2
					(- (+  Diametre_Bouton_y  (/ (- height Diametre_Bouton_y) 2)  ) shrink ) ; y2
	)


; calque 3 *******************************************************************************		
		
	; ajouter le calque
	(gimp-image-insert-layer img calque_3 -1 0 )

	; calcul taux diminution slection
	(if 
		(> Diametre_Bouton_x Diametre_Bouton_y) 
			(set! shrink2 (round (/ shrink 5 )))
			; else
			(set! shrink2 (round (/ shrink 5 )))

	)

	; diminuer la slection
	(gimp-selection-shrink img shrink2)

	; slection vers chemin
	(plug-in-sel2path 1 img calque_3)

	; appliquer couleur PP
	(gimp-context-set-foreground Couleur_Bouton)


	; remplir la slection de la couleur
	(gimp-edit-bucket-fill calque_3 0 0 100 0 TRUE 0 0)

	; appliquer couleur PP
	(gimp-context-set-foreground Couleur_Degrade)

	;(gimp-message  (number->string            (+ (+ (/ (- height Diametre_Bouton_y) 2) shrink 2) (round (/ Diametre_Bouton_y 1.44)))             ) )	

	;(gimp-message  (number->string              (+ (+ (/ (- height Diametre_Bouton_y) 2) shrink 2) (round (/ Diametre_Bouton_y 4.38)))                 ) )		
	
	; appliquer un dgrad sur calque_3
	(gimp-edit-blend 
					calque_3 ; drawable
					2 ; blend-mode		FG-TRANSPARENT-MODE
					0 ; paint-mode
					2 ; gradient-type		 GRADIENT-RADIAL
					100 ; opacity
					20 ; offset
					0 ; repeat
					FALSE ; reverse
					FALSE ; supersample
					0 ; max-depth
					0 ; threshold
					TRUE ; dither
					(/ width 2) ; x1 
					(+ (+ (/ (- height Diametre_Bouton_y) 2) shrink 2) (round (/ Diametre_Bouton_y 1.44)))   ; y1 
					(/ width 2) ; x2
					(+ (+ (/ (- height Diametre_Bouton_y) 2) shrink 2) (round (/ Diametre_Bouton_y 4.38)))   ; y2
	)


; calque 4 *******************************************************************************		
		
	; ajouter le calque
	(gimp-image-insert-layer img calque_4 -1 0)
	
	; augmenter la slection
	(gimp-selection-grow img 1)	
	
	; slection vers chemin
	(plug-in-sel2path 1 img calque_4)

	; appliquer couleur PP
	(gimp-context-set-foreground '(0 0 0))


	; remplir la slection de la couleur
	(gimp-edit-bucket-fill calque_4 0 0 100 0 TRUE 0 0)	
	
	; feather la slection flou 20
	(gimp-selection-feather img 20)
	
	; clear
	(gimp-edit-clear calque_4)


; calque 5 *******************************************************************************		
		
	; ajouter le calque
	(gimp-image-insert-layer img calque_5 -1 0)
	
	; appliquer couleur PP
	(gimp-context-set-foreground '(0 0 0))


	; remplir la slection de la couleur
	(gimp-edit-bucket-fill calque_5 0 0 100 0 TRUE 0 0)	
	
	; feather la slection flou 20
	(gimp-selection-feather img 20)
	
	; clear
	(gimp-edit-clear calque_5)

	
	; ne rien slectionner
	(gimp-selection-none img)	
	
	
; calque 6 *******************************************************************************		
		
	; ajouter le calque
	(gimp-image-insert-layer img calque_6 -1 0)
	
	; appliquer couleur PP
	(gimp-context-set-foreground '(255 255 255))	
	
	(set! rayon_ellipse_x (round (/ (- Diametre_Bouton_x (* 2 (+ shrink shrink2))) 2 )))
	;(gimp-message  (number->string            rayon_ellipse_x             ) )	  ; rayon_ellipse_x	

	(set! rayon_ellipse_y (round (/ (- Diametre_Bouton_y (* 2 (+ shrink shrink2))) 2 )))
	;(gimp-message  (number->string            rayon_ellipse_y             ) )	  ; rayon_ellipse_y	

	(set! hauteur_bulle (round (* (- (- Diametre_Bouton_y shrink) shrink2) 0.25)))
	;(gimp-message  (number->string            hauteur_bulle             ) )	  ; hauteur bulle
	
	(set! c1 (round (- rayon_ellipse_y (/ hauteur_bulle 2))))
	;(gimp-message  (number->string            c1             ) )	  ; c1
	
	(set! c2  (round (abs (- (sqrt (- (* rayon_ellipse_y rayon_ellipse_y) (* c1 c1)))      (* (* 0.01 coeff_adapt_gloss)  rayon_ellipse_y)      )  )  )  )
	;(gimp-message  (number->string            c2             ) )	  ; c2	
				
	; crer une slection ronde centre sur l'image
	;(gimp-ellipse-select 
	;					img 
	;					(round (- (/ width 2) c2)) ; x 
	;					(round (+ shrink2 (+ shrink (/ (- height Diametre_Bouton_y) 2)))) ; y 
	;					(* c2 2) ; width 
	;					hauteur_bulle ; height 
	;					0 ; operation 
	;					TRUE ; antialias 
	;					FALSE ; feather 
	;					0 ; feather-radius
	;)
	; modifications gimp 2.7.3
	(gimp-context-set-antialias TRUE)
	(gimp-context-set-feather FALSE)
	; (gimp-context-set-feather-radius feather-radius-x feather-radius-y)
	(gimp-context-set-feather-radius 0 0)
	;(gimp-ellipse-select image x y width height operation antialias feather feather-radius)
	;(gimp-image-select-ellipse image operation x y width height)
	(gimp-image-select-ellipse 
						img ; image 
						0 ; operation 
						(round (- (/ width 2) c2)) ; x 
						(round (+ shrink2 (+ shrink (/ (- height Diametre_Bouton_y) 2)))) ; y 
						(* c2 2) ; width 
						hauteur_bulle ; height 
	)
	

	
	; appliquer un dgrad sur calque_6
	(gimp-edit-blend 
					calque_6 ; drawable
					2 ; blend-mode		FG-TRANSPARENT-MODE
					0 ; paint-mode
					0 ; gradient-type		 GRADIENT-LINEAR
					100 ; opacity
					0 ; offset
					0 ; repeat
					FALSE ; reverse
					FALSE ; supersample
					0 ; max-depth
					0 ; threshold
					TRUE ; dither
					(/ width 2) ; x1 
					(+ shrink2 (+ shrink (/ (- height Diametre_Bouton_y) 2)))   ; y1 
					(/ width 2) ; x2
					(round (+ (+ shrink2 (+ shrink (/ (- height Diametre_Bouton_y) 2)))  (* (- (- Diametre_Bouton_y shrink) shrink2) 0.25)))   ; y2
	)
		
	; slection vers chemin
	(plug-in-sel2path 1 img calque_6)				

	; ne rien slectionner
	(gimp-selection-none img)
	
	

; calque 7 *******************************************************************************	
	
	; ajouter le calque
	(gimp-image-insert-layer img calque_7 -1 0)	
	
	
	
	
	
	
	
	
; calque 8 *******************************************************************************		

	; rendre le fond invisible du  calque_1
	(gimp-item-set-visible calque_1 FALSE)

	
	; nouveau calque copie visible
	(set! calque_8 (car (gimp-layer-new-from-visible img img "Button copy visible 2_3_4_4_5_6")))	
	
	; ajouter le calque
	(gimp-image-insert-layer img calque_8 -1 0)
	
	
	
	
	
; calque 9 *******************************************************************************		
		
	(gimp-item-set-visible calque_1 FALSE)	
	(gimp-item-set-visible calque_2 FALSE)
	(gimp-item-set-visible calque_3 FALSE)
	(gimp-item-set-visible calque_5 FALSE)
	(gimp-item-set-visible calque_6 FALSE)
	(gimp-item-set-visible calque_7 FALSE)
	(gimp-item-set-visible calque_8 FALSE)

	; nouveau calque copie visible
	(set! calque_9 (car (gimp-layer-new-from-visible img img "inner shadow ter")))
	
	; ajouter le calque
	(gimp-image-insert-layer img calque_9 -1 0)


; calque 10 *******************************************************************************

	(gimp-item-set-visible calque_8 TRUE)
	
	
	; nouveau calque copie visible
	(set! calque_10 (car (gimp-layer-new-from-visible img img "Button down copy visible 8_9")))	

	; ajouter le calque
	(gimp-image-insert-layer img calque_10 -1 0)
	
	
	(gimp-item-set-visible calque_9 FALSE)

	
		
;******************************************************************************************

	; positionnement visibilit
	(gimp-item-set-visible calque_1 FALSE)	
	(gimp-item-set-visible calque_2 TRUE)
	(gimp-item-set-visible calque_3 TRUE)
	(gimp-item-set-visible calque_4 TRUE)
	(gimp-item-set-visible calque_5 TRUE)
	(gimp-item-set-visible calque_6 TRUE)
	(gimp-item-set-visible calque_7 TRUE)
	(gimp-item-set-visible calque_8 TRUE)
	(gimp-item-set-visible calque_9 FALSE)	
	(gimp-item-set-visible calque_10 TRUE)
	

	
	; restaurer PP et AP
	(gimp-context-set-foreground  old-fg)
	(gimp-context-set-background old-bg)
    
	; ne rien slectionner
	(gimp-selection-none img)
	
	; afficher l'image
	(gimp-display-new img)

	;; End undo group.
	(gimp-image-undo-group-end img)	

	)
		
)

(script-fu-register
	"Round_Web_2_0_Button_with_a_Metal_Ring"
	"<Image>/File/Create/Buttons/Round Web 2.0 Button with a Metal Ring..."
	"Un bouton style Web 2.0 avec anneau metallique / A round web 2.0 button/icon with a metal ring around it"
	"samj"
	"samj"
	"2010-12-06"
	""
	SF-VALUE "Diametre x / Diameter x" "250"
	SF-VALUE "Diametre y / Diameter y" "250"
	SF-VALUE "anneau / ring [button/value] [3>=value<=70]" "10"
	SF-COLOR "Couleur bouton / Color button" '(33 110 218) ; 216eda
	SF-COLOR "Couleur degrade (plus claire) / Color gradient" '(79 238 255) ; 4feeff
	SF-VALUE "Coefficient pour ajuster calque gloss / Coefficient to adjust layer gloss" "20"


)

; FIN du script