; Script-Fu oeuf.scm
; Download : 
;
;	Copyright (C) 2013 samj ( http://aljacom.com/~gmic/ )
;
;	Licence GPL
;		Ce fichier est le Script-Fu "oeuf.scm" pour Gimp. 
;		Ce Script-Fu "oeuf.scm" est un logiciel libre ; vous pouvez le redistribuer ou le modifier suivant les termes de la GNU General Public License
;		telle que publie par la Free Software Foundation ; soit la version 3 de la licence, soit ( votre gr) toute version ultrieure.
;		Ce Script-Fu "oeuf.scm" est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; 
;		pas mme la garantie implicite de COMMERCIABILISABILIT ni d'ADQUATION  UN OBJECTIF PARTICULIER.
;		Consultez la GNU General Public License pour plus de dtails.
;		Vous devez avoir reu une copie de la GNU General Public License en mme temps que GIMP ; si ce n'est pas le cas, consultez <http://www.gnu.org/licenses>
;
;	Ce fichier oeuf.scm est dit avec Notepad++    http://notepad-plus-plus.org/
;
;
;	Version 2 du 20130421 ajout Guy Marion Logo
;	Version 20130421
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;
;	Accs par :
;
;	Fichier > Crer > Motifs > Oeuf - Egg ...
;	File > Create > Patterns > Oeuf - Egg ...
;
;
;
;
;	Exemples :
;		http://www.mathcurve.com
;		http://www.mathematische-basteleien.de/eggcurves.htm
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;

		
(define	
	(
		oeuf_samj
		dimension
		Type_Oeuf
		Color_Pencil_1
		Pencil_1_Line_Thickness
		Color_intensity
		Autocrop_Image

		
	)
	(let* 
		(

			(message (car (gimp-message-get-handler)))
			(old_context_transform_direction (car (gimp-context-get-transform-direction)))
			(old_context_interpolation (car (gimp-context-get-interpolation)))
			(old_context_recursion (car (gimp-context-get-transform-recursion)))
			(old_context_transform_resize (car (gimp-context-get-transform-resize)))
			(old-fg (car (gimp-context-get-foreground)))
			(old-bg (car (gimp-context-get-background)))

			(old_context-antialias (car (gimp-context-get-antialias)))
			(old_context-feather (car (gimp-context-get-feather)))
			(old_context-feather-radiusx (car (gimp-context-get-feather-radius)))
			(old_context-feather-radiusy (cadr (gimp-context-get-feather-radius)))
			(old_context-sample-merged (car (gimp-context-get-sample-merged)))
			(old_ontext-sample-criterion (car (gimp-context-get-sample-criterion)))
			(old_context-sample-threshold (car (gimp-context-get-sample-threshold)))
			(old_context-sample-transparent (car (gimp-context-get-sample-transparent)))

			(old-brush-size (car (gimp-context-get-brush-size)))
			(old-brush-aspect-ratio (car (gimp-context-get-brush-aspect-ratio)))
			(old-brush-angle (car (gimp-context-get-brush-angle)))
			(old-brush-name (car (gimp-context-get-brush)))
			
			(old-pattern (car (gimp-context-get-pattern)))

			(width 0)
			(height 0)
			(image)
			
			;calque_fond
			(calque_fond)
			(angle_origine 0)
			(angle_fin_boucle 0)
			(2pi (* 2 3.14159265358979323846))
			(increment_angle 0)
			(X_debut 0)
			(Y_debut 0)
			(X_fin 0)
			(Y_fin 0)
			(Valeur_a 0)
			(Valeur_b 0)
			(Valeur_c 0)
			(Valeur_d 0)
			(Valeur_r 0)
			(decalage_X 0)
			(decalage_Y 0)
			(epaisseur_ligne Pencil_1_Line_Thickness)


			(chemin_oeuf)

			(sortie_boucle_tracer 0)
			(Nom_de_la_brosse "Ma_Brosse_Spirale_samj")
			(The_shape_of_the_generated_brush 0) ; "Circle" "Square" "Diamond"
			(rayon_brosse (/ Pencil_1_Line_Thickness 2) )

		)


		(gimp-context-set-antialias FALSE)
		(gimp-context-set-feather FALSE)
		(gimp-context-set-feather-radius 0 0)
		(gimp-context-set-sample-merged FALSE)
		(gimp-context-set-sample-criterion 0)
		(gimp-context-set-sample-threshold 0.15)
		(gimp-context-set-sample-transparent FALSE)

		(gimp-context-set-transform-direction TRANSFORM-FORWARD)
		(gimp-context-set-interpolation 2)
		(gimp-context-set-transform-recursion 3)
		(gimp-context-set-transform-resize TRANSFORM-RESIZE-ADJUST)
		
		(gimp-context-set-paint-mode 0) ;


;******************************************************************************************************
; 
;******************************************************************************************************

	; conserver les mmes dimensions d'image pour tous les types d'oeufs
	(set! width (* 2 (+ dimension (* 2 epaisseur_ligne) ) ) )
	(set! height (* 2 (+ dimension (* 2 epaisseur_ligne) ) ) )


	; crer une nouvelle image rgb
	(set! image (car (gimp-image-new width height 0)))

	;; Start undo group.
	(gimp-image-undo-group-start image)

	;; slectionner la console erreurs pour envoyer un message
	(gimp-message-set-handler 2)

	; crer calque_fond
	(set! calque_fond (car (gimp-layer-new image width height 1 "calque_fond" 100 0)))	
	
	; ajouter le calque calque_fond
	(gimp-image-insert-layer image calque_fond 0 -1)

	(gimp-drawable-fill calque_fond 3)

;******************************************************************************************************
; Granville
;******************************************************************************************************


	(if (= Type_Oeuf 0) ; Granville    http://www.mathcurve.com/courbes2d/oeuf/oeufgranville.shtml 
		(begin
			
			(if (< dimension 360) 
				(set! increment_angle (/ 2pi 360 ) )
				;else
				(set! increment_angle (/ 2pi dimension ) )
			)

			(set! angle_origine 0 )
			(set! Valeur_r dimension)
			(set! Valeur_a (* 4 Valeur_r) )
			(set! Valeur_b (* 5 Valeur_r) )
			(set! decalage_X (- (* epaisseur_ligne 1.5) Valeur_a) )
			(set! decalage_Y (+ epaisseur_ligne Valeur_r) )
			(set! X_debut (+ decalage_X (+ Valeur_b (* Valeur_r (cos angle_origine) ) )          ) )
			(set! Y_debut (+ decalage_Y    (/  (* (* Valeur_r Valeur_a) (sin angle_origine) )  (+ Valeur_b (* Valeur_r (cos angle_origine) ) )    )     ) )
			(set! angle_origine (+ angle_origine increment_angle) )
			(set! X_fin (+ decalage_X (+ Valeur_b (* Valeur_r (cos angle_origine) ) )          ) )
			(set! Y_fin (+ decalage_Y    (/  (* (* Valeur_r Valeur_a) (sin angle_origine) )  (+ Valeur_b (* Valeur_r (cos angle_origine) ) )    )     ) )
			(set! angle_fin_boucle (+ angle_origine 2pi) )

			(set! chemin_oeuf (car (gimp-vectors-new image "chemin_oeuf") ) )
			(gimp-image-add-vectors image chemin_oeuf 0)

			(while (< angle_origine angle_fin_boucle)
				(begin

					; (gimp-message (string-append "Xd=" (number->string X_debut) " Yd" (number->string Y_debut) " Xf" (number->string X_fin) " Yf" (number->string Y_fin) "\n" ) )

					(gimp-vectors-stroke-new-from-points
						chemin_oeuf
						0
						12
						(vector X_debut Y_debut X_debut Y_debut X_debut Y_debut X_fin Y_fin X_fin Y_fin X_fin Y_fin )
						TRUE
					)

					(set! X_debut X_fin)
					(set! Y_debut Y_fin)
					(set! angle_origine (+ angle_origine increment_angle) )
					(set! X_fin (+ decalage_X (+ Valeur_b (* Valeur_r (cos angle_origine) ) )          ) )
					(set! Y_fin (+ decalage_Y    (/  (* (* Valeur_r Valeur_a) (sin angle_origine) )  (+ Valeur_b (* Valeur_r (cos angle_origine) ) )    )     ) )

				)
			)

		)
	)

;******************************************************************************************************
; Massimo Vaglieco
;******************************************************************************************************



	(if (= Type_Oeuf 1) ; Oeuf propos par Massimo Vaglieco    http://www.mathcurve.com/courbes2d/oeuf/oeufgranville.shtml 
		(begin
			
			(if (< dimension 360) 
				(set! increment_angle (/ 2pi 360 ) )
				;else
				(set! increment_angle (/ 2pi dimension ) )
			)

			(set! angle_origine 0 )
			(set! Valeur_r (/ dimension 3.2) )
			(set! Valeur_a (* 3 Valeur_r) )
			(set! Valeur_b (* 2 Valeur_r) )
			(set! Valeur_c (* 0.25 Valeur_r) )
			(set! decalage_X (- (/ width 2) (/ dimension 12) ) )
			(set! decalage_Y (/ height 2) )
			(set! X_debut (+ decalage_X (+  (* Valeur_a (cos angle_origine) ) (* Valeur_c (cos (* 2 angle_origine) ) ) )          ) )
			(set! Y_debut (+ decalage_Y  (* Valeur_b (sin angle_origine) )       ) )
			(set! angle_origine (+ angle_origine increment_angle) )
			(set! X_fin (+ decalage_X  (+  (* Valeur_a (cos angle_origine) ) (* Valeur_c (cos (* 2 angle_origine) ) ) )          ) )
			(set! Y_fin (+ decalage_Y  (* Valeur_b (sin angle_origine) )       ) )
			(set! angle_fin_boucle (+ angle_origine 2pi) )

			(set! chemin_oeuf (car (gimp-vectors-new image "chemin_oeuf") ) )
			(gimp-image-add-vectors image chemin_oeuf 0)

			(while (< angle_origine angle_fin_boucle)
				(begin

					; (gimp-message (string-append "Xd=" (number->string X_debut) " Yd" (number->string Y_debut) " Xf" (number->string X_fin) " Yf" (number->string Y_fin) "\n" ) )

					(gimp-vectors-stroke-new-from-points
						chemin_oeuf
						0
						12
						(vector X_debut Y_debut X_debut Y_debut X_debut Y_debut X_fin Y_fin X_fin Y_fin X_fin Y_fin )
						TRUE
					)

					(set! X_debut X_fin)
					(set! Y_debut Y_fin)
					(set! angle_origine (+ angle_origine increment_angle) )
					(set! X_fin (+ decalage_X (+  (* Valeur_a (cos angle_origine) ) (* Valeur_c (cos (* 2 angle_origine) ) ) )          ) )
					(set! Y_fin (+ decalage_Y  (* Valeur_b (sin angle_origine) )       ) )

				)
			)

		)
	)


;******************************************************************************************************
; Hgelschffer
;******************************************************************************************************


	(if (= Type_Oeuf 2) ; UF DE HGELSCHFFER  http://www.mathcurve.com/courbes2d/oeuf/oeuf.shtml
		(begin
			
			(if (< dimension 360) 
				(set! increment_angle (/ 2pi 360 ) )
				;else
				(set! increment_angle (/ 2pi dimension ) )
			)

			(set! angle_origine 0 )
			(set! Valeur_r (/ dimension 6.5) )
			(set! Valeur_a (* 6 Valeur_r) )
			(set! Valeur_b (* 4 Valeur_r) )
			(set! Valeur_d (* 1 Valeur_r) )
			(set! decalage_X (- (/ width 2) (* Valeur_r 1) ) )
			(set! decalage_Y (/ height 2) )
			(set! X_debut (+ decalage_X     (*    (+    (sqrt  (- (* Valeur_a Valeur_a) (* (*  Valeur_d  Valeur_d)  (* (sin angle_origine) (sin angle_origine) ) ) ) )   (* Valeur_d  (cos angle_origine) )   )      (cos angle_origine)    )                ) )    
			(set! Y_debut (+ decalage_Y  (* Valeur_b (sin angle_origine) )       ) )
			(set! angle_origine (+ angle_origine increment_angle) )
			(set! X_fin (+ decalage_X     (*    (+    (sqrt  (- (* Valeur_a Valeur_a) (* (*  Valeur_d  Valeur_d)  (* (sin angle_origine) (sin angle_origine) ) ) ) )   (* Valeur_d  (cos angle_origine) )   )      (cos angle_origine)    )                ) )    
			(set! Y_fin (+ decalage_Y  (* Valeur_b (sin angle_origine) )       ) )
			(set! angle_fin_boucle (+ angle_origine 2pi) )

			(set! chemin_oeuf (car (gimp-vectors-new image "chemin_oeuf") ) )
			(gimp-image-add-vectors image chemin_oeuf 0)

			(while (< angle_origine angle_fin_boucle)
				(begin

					; (gimp-message (string-append "Xd=" (number->string X_debut) " Yd" (number->string Y_debut) " Xf" (number->string X_fin) " Yf" (number->string Y_fin) "\n" ) )

					(gimp-vectors-stroke-new-from-points
						chemin_oeuf
						0
						12
						(vector X_debut Y_debut X_debut Y_debut X_debut Y_debut X_fin Y_fin X_fin Y_fin X_fin Y_fin )
						TRUE
					)

					(set! X_debut X_fin)
					(set! Y_debut Y_fin)
					(set! angle_origine (+ angle_origine increment_angle) )
					(set! X_fin (+ decalage_X     (*    (+    (sqrt  (- (* Valeur_a Valeur_a) (* (*  Valeur_d  Valeur_d)  (* (sin angle_origine) (sin angle_origine) ) ) ) )   (* Valeur_d  (cos angle_origine) )   )      (cos angle_origine)    )                ) )    
					(set! Y_fin (+ decalage_Y  (* Valeur_b (sin angle_origine) )       ) )

				)
			)

		)
	)




;******************************************************************************************************
; Nicolas Rosillo
;******************************************************************************************************


	(if (= Type_Oeuf 3) ; COURBE DE ROSILLO http://www.mathcurve.com/courbes2d/rosillo/rosillo.shtml a=r b=2r c=3r
		(begin
			
			(if (< dimension 360) 
				(set! increment_angle (/ 2pi 360 ) )
				;else
				(set! increment_angle (/ 2pi dimension ) )
			)

			(set! angle_origine 0 )
			(set! Valeur_r (* dimension 0.95) )
			(set! Valeur_a (* 1 Valeur_r) )
			(set! Valeur_b (* 2 Valeur_r) )
			(set! Valeur_c (* 3 Valeur_r) )
			(set! decalage_X (/ width 2) )
			(set! decalage_Y (/ height 2) )
			(set! X_debut (+ decalage_X    (* Valeur_a (cos angle_origine) )         ) )
			(set! Y_debut (+ decalage_Y      (*      (/  (- Valeur_b (* Valeur_a (cos angle_origine) ) )  (- Valeur_c (* Valeur_a (cos angle_origine) ) ) )    (* Valeur_a (sin angle_origine) )  )           ) )   
			(set! angle_origine (+ angle_origine increment_angle) )
			(set! X_fin (+ decalage_X    (* Valeur_a (cos angle_origine) )         ) )
			(set! Y_fin (+ decalage_Y     (*      (/  (- Valeur_b (* Valeur_a (cos angle_origine) ) )  (- Valeur_c (* Valeur_a (cos angle_origine) ) ) )    (* Valeur_a (sin angle_origine) )  )           ) )   
			(set! angle_fin_boucle (+ angle_origine 2pi) )

			(set! chemin_oeuf (car (gimp-vectors-new image "chemin_oeuf") ) )
			(gimp-image-add-vectors image chemin_oeuf 0)

			(while (< angle_origine angle_fin_boucle)
				(begin

					; (gimp-message (string-append "Xd=" (number->string X_debut) " Yd" (number->string Y_debut) " Xf" (number->string X_fin) " Yf" (number->string Y_fin) "\n" ) )

					(gimp-vectors-stroke-new-from-points
						chemin_oeuf
						0
						12
						(vector X_debut Y_debut X_debut Y_debut X_debut Y_debut X_fin Y_fin X_fin Y_fin X_fin Y_fin )
						TRUE
					)

					(set! X_debut X_fin)
					(set! Y_debut Y_fin)
					(set! angle_origine (+ angle_origine increment_angle) )
					(set! X_fin (+ decalage_X    (* Valeur_a (cos angle_origine) )         ) )
					(set! Y_fin (+ decalage_Y     (*      (/  (- Valeur_b (* Valeur_a (cos angle_origine) ) )  (- Valeur_c (* Valeur_a (cos angle_origine) ) ) )    (* Valeur_a (sin angle_origine) )  )           ) )   

				)
			)

		)
	)


;******************************************************************************************************
; Kepler
;******************************************************************************************************


	(if (= Type_Oeuf 4) ; http://www.mathcurve.com/courbes2d/foliumsimple/foliumsimple.shtml
		(begin
			
			(if (< dimension 360) 
				(set! increment_angle (/ 2pi 180 ) )
				;else
				(set! increment_angle (/ 2pi (/ dimension 2) ) )
			)

			(set! angle_origine 0 )
			(set! Valeur_r (* dimension 1.8) )
			(set! Valeur_a (* 1 Valeur_r) )
			(set! decalage_X (/ Valeur_a 20) )
			(set! decalage_Y (/ height 2) )
			(set! X_debut (+ decalage_X       (/ Valeur_a  (* (+ 1 (* angle_origine angle_origine) ) (+ 1 (* angle_origine angle_origine) ) ) )      ) )
			(set! Y_debut (+ decalage_Y       ( *  (/ Valeur_a  (* (+ 1 (* angle_origine angle_origine) ) (+ 1 (* angle_origine angle_origine) ) ) )  angle_origine )       ) )   
			(set! angle_origine (+ angle_origine increment_angle) )
			(set! X_fin (+ decalage_X       (/ Valeur_a  (* (+ 1 (* angle_origine angle_origine) ) (+ 1 (* angle_origine angle_origine) ) ) )      ) )
			(set! Y_fin (+ decalage_Y       ( *  (/ Valeur_a  (* (+ 1 (* angle_origine angle_origine) ) (+ 1 (* angle_origine angle_origine) ) ) )  angle_origine )       ) )   
			(set! angle_fin_boucle (+ increment_angle (+ angle_origine 2pi) ) )

			(set! chemin_oeuf (car (gimp-vectors-new image "chemin_oeuf") ) )
			(gimp-image-add-vectors image chemin_oeuf 0)

			(while (< angle_origine angle_fin_boucle )
				(begin

					; (gimp-message (string-append "Xd=" (number->string X_debut) " Yd" (number->string Y_debut) " Xf" (number->string X_fin) " Yf" (number->string Y_fin) "\n" ) )

					(gimp-vectors-stroke-new-from-points
						chemin_oeuf
						0
						12
						(vector X_debut Y_debut X_debut Y_debut X_debut Y_debut X_fin Y_fin X_fin Y_fin X_fin Y_fin )
						TRUE
					)

					(set! X_debut X_fin)
					(set! Y_debut Y_fin)
					(set! angle_origine (+ angle_origine increment_angle) )
					(set! X_fin (+ decalage_X       (/ Valeur_a  (* (+ 1 (* angle_origine angle_origine) ) (+ 1 (* angle_origine angle_origine) ) ) )      ) )
					(set! Y_fin (+ decalage_Y       ( *  (/ Valeur_a  (* (+ 1 (* angle_origine angle_origine) ) (+ 1 (* angle_origine angle_origine) ) ) )  angle_origine )       ) )   

				)
			)

			; symtrie
			(while (> angle_origine (- 0 increment_angle) )
				(begin

					; (gimp-message (string-append "Xd=" (number->string X_debut) " Yd" (number->string Y_debut) " Xf" (number->string X_fin) " Yf" (number->string Y_fin) "\n" ) )
					
					(set! X_debut X_fin)
					(set! Y_debut Y_fin)
					(set! angle_origine (- angle_origine increment_angle) )
					(set! X_fin (+ decalage_X       (/ Valeur_a  (* (+ 1 (* angle_origine angle_origine) ) (+ 1 (* angle_origine angle_origine) ) ) )      ) )
					(set! Y_fin (- decalage_Y       ( *  (/ Valeur_a  (* (+ 1 (* angle_origine angle_origine) ) (+ 1 (* angle_origine angle_origine) ) ) )  angle_origine )       ) )  
					
					(gimp-vectors-stroke-new-from-points
						chemin_oeuf
						0
						12
						(vector X_debut Y_debut X_debut Y_debut X_debut Y_debut X_fin Y_fin X_fin Y_fin X_fin Y_fin )
						TRUE
					)

 

				)
			)

		)
	)





;******************************************************************************************************
; Cornode
;******************************************************************************************************


	(if (= Type_Oeuf 5) ; http://www.mathcurve.com/courbes2d/cornoid/cornoid.shtml
		(begin
			
			(if (< dimension 360) 
				(set! increment_angle (/ 2pi 360 ) )
				;else
				(set! increment_angle (/ 2pi dimension ) )
			)

			(set! angle_origine 0 )
			(set! Valeur_r (* dimension 0.66) )
			(set! Valeur_a (* 1 Valeur_r) )
			(set! decalage_X (/ width 2) )
			(set! decalage_Y (/ height 2) )
			(set! X_debut (+ decalage_X    (* Valeur_a (* (cos angle_origine) (cos (* 2 angle_origine) ) ) )       ) )
			(set! Y_debut (+ decalage_Y    (* Valeur_a  (* (sin angle_origine)  (+ 2 (cos (* 2 angle_origine) ) ) ) )           ) )
			(set! angle_origine (+ angle_origine increment_angle) )
			(set! X_fin (+ decalage_X    (* Valeur_a (* (cos angle_origine) (cos (* 2 angle_origine) ) ) )       ) )
			(set! Y_fin (+ decalage_Y    (* Valeur_a  (* (sin angle_origine)  (+ 2 (cos (* 2 angle_origine) ) ) ) )           ) )
			(set! angle_fin_boucle (+ angle_origine 2pi) )

			(set! chemin_oeuf (car (gimp-vectors-new image "chemin_oeuf") ) )
			(gimp-image-add-vectors image chemin_oeuf 0)

			(while (< angle_origine angle_fin_boucle)
				(begin

					; (gimp-message (string-append "Xd=" (number->string X_debut) " Yd" (number->string Y_debut) " Xf" (number->string X_fin) " Yf" (number->string Y_fin) "\n" ) )

					(gimp-vectors-stroke-new-from-points
						chemin_oeuf
						0
						12
						(vector X_debut Y_debut X_debut Y_debut X_debut Y_debut X_fin Y_fin X_fin Y_fin X_fin Y_fin )
						TRUE
					)

					(set! X_debut X_fin)
					(set! Y_debut Y_fin)
					(set! angle_origine (+ angle_origine increment_angle) )
					(set! X_fin (+ decalage_X    (* Valeur_a (* (cos angle_origine) (cos (* 2 angle_origine) ) ) )       ) )
					(set! Y_fin (+ decalage_Y    (* Valeur_a  (* (sin angle_origine)  (+ 2 (cos (* 2 angle_origine) ) ) ) )           ) )

				)
			)

		)
	)



;******************************************************************************************************
; Guy Marion Logo  http://abcmathsblog.blogspot.ca/
;******************************************************************************************************


	(if (= Type_Oeuf 6) ; Guy Marion Logo  http://abcmathsblog.blogspot.ca/2009/05/de-descartes-bezier-suite-de-lhistoire.html
		(begin
			
			(if (< dimension 360) 
				(set! increment_angle (/ 2pi 360 ) )
				;else
				(set! increment_angle (/ 2pi dimension ) )
			)

			(set! angle_origine 0 )
			(set! Valeur_r (* dimension 0.14) )
			(set! Valeur_a (* 1 Valeur_r) )
			(set! Valeur_b (* -3 Valeur_r) )
			(set! decalage_X (/ width 2) )
			(set! decalage_Y (/ height 2) )
			(set! X_debut (+ decalage_X    (* Valeur_a   (-  (sin (* 2 angle_origine) )   (* 6 (sin (* 5 angle_origine) ) )  )  )         ) )
			(set! Y_debut (+ decalage_Y    (* Valeur_b   (-  (* (cos (* 4 angle_origine) )  (cos (* 4 angle_origine) ) (cos (* 4 angle_origine) ) (cos (* 4 angle_origine) ) (cos (* 4 angle_origine) )  )     (* 1.1 (cos angle_origine) )   )   )              ) )
			(set! angle_origine (+ angle_origine increment_angle) )
			(set! X_fin (+ decalage_X     (* Valeur_a   (-  (sin (* 2 angle_origine) )   (* 6 (sin (* 5 angle_origine) ) )  )  )         ) )
			(set! Y_fin (+ decalage_Y    (* Valeur_b   (-  (* (cos (* 4 angle_origine) )  (cos (* 4 angle_origine) ) (cos (* 4 angle_origine) ) (cos (* 4 angle_origine) ) (cos (* 4 angle_origine) )  )     (* 1.1 (cos angle_origine) )   )   )              ) )
			(set! angle_fin_boucle (+ angle_origine 2pi) )

			(set! chemin_oeuf (car (gimp-vectors-new image "chemin_oeuf") ) )
			(gimp-image-add-vectors image chemin_oeuf 0)

			(while (< angle_origine angle_fin_boucle)
				(begin

					; (gimp-message (string-append "Xd=" (number->string X_debut) " Yd" (number->string Y_debut) " Xf" (number->string X_fin) " Yf" (number->string Y_fin) "\n" ) )

					(gimp-vectors-stroke-new-from-points
						chemin_oeuf
						0
						12
						(vector X_debut Y_debut X_debut Y_debut X_debut Y_debut X_fin Y_fin X_fin Y_fin X_fin Y_fin )
						TRUE
					)

					(set! X_debut X_fin)
					(set! Y_debut Y_fin)
					(set! angle_origine (+ angle_origine increment_angle) )
					(set! X_fin (+ decalage_X    (* Valeur_a   (-  (sin (* 2 angle_origine) )   (* 6 (sin (* 5 angle_origine) ) )  )  )         ) )
					(set! Y_fin (+ decalage_Y    (* Valeur_b   (-  (* (cos (* 4 angle_origine) )  (cos (* 4 angle_origine) ) (cos (* 4 angle_origine) ) (cos (* 4 angle_origine) ) (cos (* 4 angle_origine) )  )     (* 1.1 (cos angle_origine) )   )   )              ) )

				)
			)

		)
	)




;******************************************************************************************************
; 
;******************************************************************************************************


	; crer une brosse
	(gimp-brush-new Nom_de_la_brosse)				

	(gimp-context-set-brush-size rayon_brosse )
	;;;(gimp-context-set-brush-default-size)
	(gimp-context-set-brush-aspect-ratio 1)
	(gimp-context-set-brush-angle 0)
	
	(gimp-context-set-brush Nom_de_la_brosse)

	(gimp-brush-set-shape Nom_de_la_brosse The_shape_of_the_generated_brush) ; forme

	(gimp-brush-set-radius Nom_de_la_brosse rayon_brosse ) ; rayon

	(gimp-brush-set-spikes Nom_de_la_brosse 2) ; pointes
	(gimp-brush-set-hardness Nom_de_la_brosse 1.0) ; duret 
	(gimp-brush-set-aspect-ratio Nom_de_la_brosse 1 ) ; proportions
	(gimp-brush-set-angle Nom_de_la_brosse 0) ; angle
	(gimp-brush-set-spacing Nom_de_la_brosse 1.0 ) ; espacement

	; slectionner brosse
	(gimp-context-set-brush Nom_de_la_brosse)

	(set! sortie_boucle_tracer Color_intensity)
	(while (> sortie_boucle_tracer 0)
		(begin
			(gimp-edit-stroke-vectors calque_fond (car (gimp-image-get-active-vectors image) ) )
			(set! sortie_boucle_tracer (- sortie_boucle_tracer 1) )
		)
	)

	(gimp-brush-delete Nom_de_la_brosse)

	(if (= 1 Autocrop_Image) (plug-in-autocrop-layer 1 image calque_fond) )

	
	; ajuster taille image  la taille des calques
	(gimp-image-resize-to-layers image)


;******************************************************************************************************
; 
;******************************************************************************************************

		;; rtablir le mode message
		(gimp-message-set-handler message)

		(gimp-context-set-transform-direction old_context_transform_direction )
		(gimp-context-set-interpolation old_context_interpolation)
		(gimp-context-set-transform-recursion old_context_recursion)
		(gimp-context-set-transform-resize old_context_transform_resize)
		(gimp-context-set-background old-bg)
		(gimp-context-set-foreground old-fg)


		(gimp-context-set-antialias old_context-antialias)
		(gimp-context-set-feather old_context-feather)
		(gimp-context-set-feather-radius old_context-feather-radiusx old_context-feather-radiusy)
		(gimp-context-set-sample-merged old_context-sample-merged)
		(gimp-context-set-sample-criterion old_ontext-sample-criterion)
		(gimp-context-set-sample-threshold old_context-sample-threshold)
		(gimp-context-set-sample-transparent old_context-sample-transparent)

		(gimp-context-set-brush-default-size)
		(gimp-context-set-brush-size old-brush-size)
		(gimp-context-set-brush-aspect-ratio old-brush-aspect-ratio)
		(gimp-context-set-brush-angle old-brush-angle)		
		(gimp-context-set-brush old-brush-name)

		(gimp-context-set-pattern old-pattern)



;******************************************************************************************************
; 
;******************************************************************************************************


		; afficher l'image
		(gimp-display-new image)

		; End undo group.
		(gimp-image-undo-group-end image)	





	)
)





(script-fu-register "oeuf_samj"
                    _"<Image>/File/Create/Patterns/Oeuf - Egg ..."
                    "Oeuf - Egg ..."
                    "samj"
                    "samj"
                    "20130421"
                    ""
					SF-ADJUSTMENT "Dimension " '(512 32 2048 1 5 0 1)
					SF-OPTION "Oeuf/Egg " '("Oeuf de Granville / Granville Egg" "Oeuf propose par / Egg proposed by Massimo Vaglieco" "Oeuf de Hugelschaffer / Hugelschaffer Egg" "Oeuf de Rosillo / Rosillo Egg" "Oeuf de Kepler / Kepler Egg" "Cornoid" "Guy Marion Logo") 
					SF-COLOR "Color Pencil 1 " '(0 0 0)
					SF-ADJUSTMENT "Pencil 1 - Line Thickness " '(2 2 40 1 5 0 1)
					SF-ADJUSTMENT "Color intensity " '(3 1 10 1 5 0 1)
					SF-TOGGLE "Autocrop" FALSE
					


)

;; FIN





