; Script-Fu  texture_001.scm
;
;
;	Copyright (C) 2013 samj ( http://www.aljacom.com/ )
;
;	Licence GPL
;		Ce fichier est le Script-Fu "texture_001.scm" pour Gimp. 
;		Ce Script-Fu "texture_001.scm" est un logiciel libre ; vous pouvez le redistribuer ou le modifier suivant les termes de la GNU General Public License
;		telle que publie par la Free Software Foundation ; soit la version 3 de la licence, soit ( votre gr) toute version ultrieure.
;		Ce Script-Fu "texture_001.scm" est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; 
;		pas mme la garantie implicite de COMMERCIABILISABILIT ni d'ADQUATION  UN OBJECTIF PARTICULIER.
;		Consultez la GNU General Public License pour plus de dtails.
;		Vous devez avoir reu une copie de la GNU General Public License en mme temps que GIMP ; si ce n'est pas le cas, consultez <http://www.gnu.org/licenses>
;
;	Ce fichier texture_001.scm est dit avec Notepad++    http://notepad-plus-plus.org/
;
;
;
;
;
;
;
;	Version 1 20131205
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;
;	Accs sur l'image par :
;	Filtres > Texture 001 ...
;
;	Access on the image by :
;	Filters > Texture 001 ...
;
;	http://gimpchat.com/viewtopic.php?f=4&t=9175
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;


(define	
	(
		texture_001_samj
		image
		drawable
		param_a
		param_b
		param_c
		param_d
		Automatic_color_balance


	)
	(let* 
		(
			;; variables utiles
			(message (car (gimp-message-get-handler)))
			(width (car (gimp-image-width image)))
			(height (car (gimp-image-height image)))
			(transparence (car (gimp-drawable-has-alpha drawable)))
			(param_e 0)


		)





		; pour image existante
		(gimp-undo-push-group-start image) 

		; sauvegard le contexte.  Recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		(gimp-context-push)

		;; slectionner la console erreurs pour envoyer un message
		(gimp-message-set-handler 2)		


;******************************************************************************************************
; 
;******************************************************************************************************


	(if Automatic_color_balance TRUE	
		(set! param_e 1)
	)


	(plug-in-gmic 1 image drawable 1
		(string-append
			"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
			
			"--gimp_do_nothing "
			"-gimp_gradient2rgb[-1] " 
			(number->string (round (/ param_a 10) ) ) ",0,"
			(number->string param_b) ",0,0 "
			"{w},{h},1,3 "
			"-fill_color[-1] 255,255,255 "
			"-to_rgb[-1] "
			"-gimp_noise[-1] "
			(number->string param_c) ",0,2,0 "
			"-gimp_blend[-1,-2] 25,1,0 "
			"-gimp_tk_colortemp[-1] "
			(number->string (round (- param_d 20))) ","
			(number->string param_e) " "
			"-gimp_local_orientation[-1] 0,0,100,0,7 "			
			"-gimp_normalize_local[-1] 0,6,5,20,1,2 "
			"-gimp_blend[0,-1] 13,1,0 "	
		

		)
	)












;******************************************************************************************************
; 
;******************************************************************************************************

		;; rtablir le mode message
		(gimp-message-set-handler message)

		; restituer l'ancien contexte.
		(gimp-context-pop)

		; pour image existante
		(gimp-undo-push-group-end image)

		(gimp-displays-flush)

	)
)



(script-fu-register "texture_001_samj"
                    _"<Image>/Filters/Texture 001 ..."
                    "Tests textures with GMIC"
                    "samj"
                    "samj"
                    "20131205"
                    "RGB*"
                    SF-IMAGE    "Image"     0
                    SF-DRAWABLE "Drawable"  0
					SF-ADJUSTMENT "Smoothness Gradient RGB "  '(5 5 20 1 5 2 0) ;
					SF-ADJUSTMENT "Max threshold Gradient RGB "  '(20 10 50 1 10 0 0) ;
					SF-ADJUSTMENT "Amplitude Noise "  '(80 40 200 1 10 0 0) ;
					SF-ADJUSTMENT "Colors "  '(20 0 40 1 10 0 0) ;
					SF-TOGGLE "Automatic color balance " FALSE


)






;; FIN





