; Script-Fu usure.scm
; Download : 
;
;	Copyright (C) 2013 samj ( http://aljacom.com/~gmic/ )
;
;	Licence GPL
;		Ce fichier est le Script-Fu "usure.scm" pour Gimp. 
;		Ce Script-Fu "usure.scm" est un logiciel libre ; vous pouvez le redistribuer ou le modifier suivant les termes de la GNU General Public License
;		telle que publie par la Free Software Foundation ; soit la version 3 de la licence, soit ( votre gr) toute version ultrieure.
;		Ce Script-Fu "usure.scm" est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; 
;		pas mme la garantie implicite de COMMERCIABILISABILIT ni d'ADQUATION  UN OBJECTIF PARTICULIER.
;		Consultez la GNU General Public License pour plus de dtails.
;		Vous devez avoir reu une copie de la GNU General Public License en mme temps que GIMP ; si ce n'est pas le cas, consultez <http://www.gnu.org/licenses>
;
;	Ce fichier usure.scm est dit avec Notepad++    http://notepad-plus-plus.org/
;
;
;	Version 20130419 ajout chemins
;	Version 20130418 (origine)
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;
;	Accs sur l'image par :
;
;	Filtres > Rendu > Usure - Abrasion ...
;	Filters > Render > Usure - Abrasion ...
;
;
;
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;

		
(define	
	(
		usure_samj
		image
		drawable
		Brosse_Brush
		Brosse_A
		Diametre_Brosse_B
		Usure
		Couleur_fond


		
	)
	(let* 
		(

			(message (car (gimp-message-get-handler)))
			(old_context_transform_direction (car (gimp-context-get-transform-direction)))
			(old_context_interpolation (car (gimp-context-get-interpolation)))
			(old_context_recursion (car (gimp-context-get-transform-recursion)))
			(old_context_transform_resize (car (gimp-context-get-transform-resize)))
			(old-fg (car (gimp-context-get-foreground)))
			(old-bg (car (gimp-context-get-background)))

			(old_context-antialias (car (gimp-context-get-antialias)))
			(old_context-feather (car (gimp-context-get-feather)))
			(old_context-feather-radiusx (car (gimp-context-get-feather-radius)))
			(old_context-feather-radiusy (cadr (gimp-context-get-feather-radius)))
			(old_context-sample-merged (car (gimp-context-get-sample-merged)))
			(old_ontext-sample-criterion (car (gimp-context-get-sample-criterion)))
			(old_context-sample-threshold (car (gimp-context-get-sample-threshold)))
			(old_context-sample-transparent (car (gimp-context-get-sample-transparent)))

			(old-brush-size (car (gimp-context-get-brush-size)))
			(old-brush-aspect-ratio (car (gimp-context-get-brush-aspect-ratio)))
			(old-brush-angle (car (gimp-context-get-brush-angle)))
			(old-brush-name (car (gimp-context-get-brush)))

			(width (car (gimp-image-width image)))
			(height (car (gimp-image-height image)))

			(transparence (car (gimp-drawable-has-alpha drawable)))

			(selection_en_cours)
			(nouvelle_image)
			(calque_copie)
			(copier_visible)
			(buffer-name "copier_visible")
			
			(ajout_dimension)
			; o appliquer la brosse
			(*array_points_brosse* (cons-array 4 'double))
			(masque_de_calque)
			; index
			(index 0)
			
			; ajout_dimension
			(ajout_dimension 0)

			(calque_fond)
			(x1)
			(y1)
			(x2)
			(y2)
			(Chemin_Brosse_B)
			(Chemin_Brosse_A)
			
			(calque_blanc)
			(masque_de_calque_2)

		)


		(gimp-context-set-antialias FALSE)
		(gimp-context-set-feather FALSE)
		(gimp-context-set-feather-radius 0 0)
		(gimp-context-set-sample-merged FALSE)
		(gimp-context-set-sample-criterion 0)
		(gimp-context-set-sample-threshold 0)
		(gimp-context-set-sample-transparent FALSE)

		(gimp-context-set-transform-direction TRANSFORM-FORWARD)
		(gimp-context-set-interpolation 2)
		(gimp-context-set-transform-recursion 3)
		(gimp-context-set-transform-resize TRANSFORM-RESIZE-ADJUST)
		
		(gimp-context-set-paint-mode 0) ;

		
		(gimp-undo-push-group-start image)

		(gimp-selection-none image)





;******************************************************************************************************
; 
;******************************************************************************************************


		(set! copier_visible (car (gimp-edit-named-copy-visible image buffer-name)))

		; crer une nouvelle image rgb
		(set! nouvelle_image (car (gimp-image-new width height 0)))

		(gimp-undo-push-group-start nouvelle_image)

		; crer le premier calque
		(set! calque_copie (car (gimp-layer-new nouvelle_image width height 0 "calque_gris" 100 0)))

		(gimp-image-insert-layer nouvelle_image calque_copie -1 0)
		
		(gimp-layer-add-alpha calque_copie)

		(gimp-drawable-fill calque_copie 3)
		

		(gimp-image-select-rectangle nouvelle_image 0  width height 0 0 )

		(set! selection_en_cours (car (gimp-edit-named-paste calque_copie copier_visible 0)))

		(gimp-floating-sel-anchor selection_en_cours)

		(gimp-selection-none nouvelle_image)


		;;;;
		; crer le calque_blanc
		(set! calque_blanc (car (gimp-layer-new nouvelle_image width height 0 "calque_blanc" 100 0)))
		(gimp-image-insert-layer nouvelle_image calque_blanc 0 1)
		(gimp-context-set-foreground '(255 255 255))
		(gimp-drawable-fill calque_blanc 0)
		; ajouter un masque de calque blanc
		(set! masque_de_calque_2 (car (gimp-layer-create-mask calque_blanc 0)))
		(gimp-layer-add-mask calque_blanc masque_de_calque_2)
		;;;;


		; ajouter un masque de calque blanc
		(set! masque_de_calque (car (gimp-layer-create-mask calque_copie 0)))
		(gimp-layer-add-mask calque_copie masque_de_calque)

		; mettre pp = noir
		(gimp-context-set-foreground '(0 0 0))
		
		; mettre ap = blanc
		(gimp-context-set-background '(255 255 255))


		; BROSSE A

		(if (or (= Brosse_Brush 0) (= Brosse_Brush 1) )
			(begin

				(set! Chemin_Brosse_A (car (gimp-vectors-new nouvelle_image "Chemin_Brosse_A") ) )
				(gimp-image-add-vectors nouvelle_image Chemin_Brosse_A 0)

				; slectionner brosse
				(gimp-context-set-brush (car Brosse_A))

				; boucle pour appliquer la brosse avec le pinceau
				(while 
					(< ajout_dimension (+ width height)) 
						
						; incrmentation de l'index
						(set! index (+ 1 index))

						(set! x1 (random width))
						(set! y1 (random height))
						(set! x2 (random width))
						(set! y2 (random height))

						; contenu des 4 valeurs de array
						(vector-set! *array_points_brosse* 0 x1)
						(vector-set! *array_points_brosse* 1 y1)
						(vector-set! *array_points_brosse* 2 x2)
						(vector-set! *array_points_brosse* 3 y2)
				
						; appliquer pinceau
						(gimp-paintbrush 
								masque_de_calque ; drawable
								0 ; fade-out
								4 ; num-strokes 
								*array_points_brosse* ; strokes 
								0 ; method 
								index ; gradient-length
						)

						(gimp-paintbrush 
								masque_de_calque_2 ; drawable
								0 ; fade-out
								4 ; num-strokes 
								*array_points_brosse* ; strokes 
								0 ; method 
								index ; gradient-length
						)

						(if (< Usure 41)
							(gimp-vectors-stroke-new-from-points
								Chemin_Brosse_A
								0
								12
								(vector x1 y1 x1 y1 x1 y1 x2 y2 x2 y2 x2 y2 )
								TRUE
							)
						)


						(set! x1 (random width))
						(set! y1 (random height))
						(set! x2 (random width))
						(set! y2 (random height))

						; contenu des 4 valeurs de array
						(vector-set! *array_points_brosse* 0 x1)
						(vector-set! *array_points_brosse* 1 y1)
						(vector-set! *array_points_brosse* 2 x2)
						(vector-set! *array_points_brosse* 3 y2)

						; appliquer pinceau
						(gimp-paintbrush 
								masque_de_calque ; drawable
								0 ; fade-out
								4 ; num-strokes 
								*array_points_brosse* ; strokes 
								0 ; method 
								(/ index 2) ; gradient-length
						)

						(gimp-paintbrush 
								masque_de_calque_2 ; drawable
								0 ; fade-out
								4 ; num-strokes 
								*array_points_brosse* ; strokes 
								0 ; method 
								(/ index 2) ; gradient-length
						)


						(if (< Usure 41)
							(gimp-vectors-stroke-new-from-points
								Chemin_Brosse_A
								0
								12
								(vector x1 y1 x1 y1 x1 y1 x2 y2 x2 y2 x2 y2 )
								TRUE
							)
						)


						; nouvelle valeur de ajout_dimension
						(set! ajout_dimension (+ ajout_dimension (+ 1 (random (- 51 Usure)))))
				)

			)
		)



		; BROSSE B

		(if (or (= Brosse_Brush 0) (= Brosse_Brush 2) )
			(begin

				(set! Chemin_Brosse_B (car (gimp-vectors-new nouvelle_image "Chemin_Brosse_B") ) )
				(gimp-image-add-vectors nouvelle_image Chemin_Brosse_B 0)

				; crer une brosse
				(gimp-brush-new "brosse_grunge_stamp_gimp_2_8")
				
				
				; crer et slectionner brosse
				(gimp-context-set-brush "brosse_grunge_stamp_gimp_2_8")	
				(gimp-brush-set-shape "brosse_grunge_stamp_gimp_2_8" 0) ; forme ronde
				(gimp-brush-set-radius "brosse_grunge_stamp_gimp_2_8" (/ Diametre_Brosse_B 2) ) ; rayon
				(gimp-brush-set-spikes "brosse_grunge_stamp_gimp_2_8" 2) ; pointes
				(gimp-brush-set-hardness "brosse_grunge_stamp_gimp_2_8" 0.7) ; duret
				(gimp-brush-set-aspect-ratio "brosse_grunge_stamp_gimp_2_8" 1) ; proportions
				(gimp-brush-set-angle "brosse_grunge_stamp_gimp_2_8" 0) ; angle
				(gimp-brush-set-spacing "brosse_grunge_stamp_gimp_2_8" 10) ; espacement


				; ajout_dimension
				(set! ajout_dimension 1)	

				; boucle pour appliquer pencil
				(while 
					(< ajout_dimension (+ width height)) ;


						(set! x1 (random width))
						(set! y1 (random height))
						(set! x2 (random width))
						(set! y2 (random height))

						; contenu des 4 valeurs de array
						(vector-set! *array_points_brosse* 0 x1)
						(vector-set! *array_points_brosse* 1 y1)
						(vector-set! *array_points_brosse* 2 x2)
						(vector-set! *array_points_brosse* 3 y2)
				
				
						(gimp-pencil 
								masque_de_calque  ; drawable 
								4 ; num-strokes 
								*array_points_brosse* ; strokes
						)

						(gimp-pencil 
								masque_de_calque_2  ; drawable 
								4 ; num-strokes 
								*array_points_brosse* ; strokes
						)

						(if (< Usure 41)
							(gimp-vectors-stroke-new-from-points
								Chemin_Brosse_B
								0
								12
								(vector x1 y1 x1 y1 x1 y1 x2 y2 x2 y2 x2 y2 )
								TRUE
							)
						)


						
						; nouvelle valeur de ajout_dimension
						(set! ajout_dimension (+ ajout_dimension (+ 1 (random (- 51 Usure)))))

				)

				; supprimer la brosse
				(gimp-brush-delete "brosse_grunge_stamp_gimp_2_8")

			)
		)

		; appliquer et supprimer le masque
		(gimp-layer-remove-mask calque_copie 0)

		;;;;(gimp-layer-remove-mask calque_blanc 0)


		; crer le calque_fond
		(set! calque_fond (car (gimp-layer-new nouvelle_image width height 0 "calque_fond" 100 0)))

		(gimp-image-insert-layer nouvelle_image calque_fond 0 1)

		(gimp-context-set-foreground Couleur_fond)

		(gimp-drawable-fill calque_fond 0)







	
		(gimp-undo-push-group-end nouvelle_image)
		(gimp-display-new nouvelle_image)



;******************************************************************************************************

		;; rtablir le mode message
		(gimp-message-set-handler message)

		(gimp-context-set-transform-direction old_context_transform_direction )
		(gimp-context-set-interpolation old_context_interpolation)
		(gimp-context-set-transform-recursion old_context_recursion)
		(gimp-context-set-transform-resize old_context_transform_resize)
		(gimp-context-set-background old-bg)
		(gimp-context-set-foreground old-fg)


		(gimp-context-set-antialias old_context-antialias)
		(gimp-context-set-feather old_context-feather)
		(gimp-context-set-feather-radius old_context-feather-radiusx old_context-feather-radiusy)
		(gimp-context-set-sample-merged old_context-sample-merged)
		(gimp-context-set-sample-criterion old_ontext-sample-criterion)
		(gimp-context-set-sample-threshold old_context-sample-threshold)
		(gimp-context-set-sample-transparent old_context-sample-transparent)

		(gimp-context-set-brush-default-size)
		(gimp-context-set-brush-size old-brush-size)
		(gimp-context-set-brush-aspect-ratio old-brush-aspect-ratio)
		(gimp-context-set-brush-angle old-brush-angle)		
		(gimp-context-set-brush old-brush-name)



		(gimp-undo-push-group-end image)
		(gimp-displays-flush)


	)
)





(script-fu-register "usure_samj"
                    _"<Image>/Filters/Render/Usure - Abrasion ..."
                    "Usure Abrasion Image"
                    "samj"
                    "samj"
                    "20130418"
                    "RGB*"
                    SF-IMAGE    "Image"     0
                    SF-DRAWABLE "Drawable"  0
					SF-OPTION "Brosse(s) / Brush(es) " '("A+B" "A" "B")
					SF-BRUSH "Brosse A / Brush A" '("Grass" 100 5 0) ; Brosse_A
					SF-ADJUSTMENT "Diametre Brosse B / Diameter Brush B" '(0.3 0.3 5 0.1 1 2 2) ; diamtre brosse B
					SF-ADJUSTMENT "Usure / Abrasion" '(12 1 50 1 10 0 1) ; usure du tampon
					SF-COLOR "Couleur fond / Background color" '(255 255 255) ; ffffff






)

;; FIN





