; Script-Fu 1_motif_pattern.scm
; Download : 
;
;	Copyright (C) 2013 samj ( http://aljacom.com/~gmic/ )
;
;	Licence GPL
;		Ce fichier est le Script-Fu "1_motif_pattern.scm" pour Gimp. 
;		Ce Script-Fu "1_motif_pattern.scm" est un logiciel libre ; vous pouvez le redistribuer ou le modifier suivant les termes de la GNU General Public License
;		telle que publie par la Free Software Foundation ; soit la version 3 de la licence, soit ( votre gr) toute version ultrieure.
;		Ce Script-Fu "1_motif_pattern.scm" est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; 
;		pas mme la garantie implicite de COMMERCIABILISABILIT ni d'ADQUATION  UN OBJECTIF PARTICULIER.
;		Consultez la GNU General Public License pour plus de dtails.
;		Vous devez avoir reu une copie de la GNU General Public License en mme temps que GIMP ; si ce n'est pas le cas, consultez <http://www.gnu.org/licenses>
;
;	Ce fichier 1_motif_pattern.scm est dit avec Notepad++    http://notepad-plus-plus.org/
;
;
;	Version 20130406
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;
;	Accs sur l'image par :
;
;	Fichier > Crer > Motifs > 1 Motif Pattern ...
;	File > Create > Patterns > 1 Motif Pattern ...
;
;
;
;
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;

		
(define	
	(
		1_motif_pattern_samj
		couleur
		Turbulence
		relief
		azimuth			; azimuth 
		elevation		; elevation 
		depth			; depth 



		
	)
	(let* 
		(

			(message (car (gimp-message-get-handler)))
			(old_context_transform_direction (car (gimp-context-get-transform-direction)))
			(old_context_interpolation (car (gimp-context-get-interpolation)))
			(old_context_recursion (car (gimp-context-get-transform-recursion)))
			(old_context_transform_resize (car (gimp-context-get-transform-resize)))
			(old-fg (car (gimp-context-get-foreground)))
			(old-bg (car (gimp-context-get-background)))

			(old_context-antialias (car (gimp-context-get-antialias)))
			(old_context-feather (car (gimp-context-get-feather)))
			(old_context-feather-radiusx (car (gimp-context-get-feather-radius)))
			(old_context-feather-radiusy (cadr (gimp-context-get-feather-radius)))
			(old_context-sample-merged (car (gimp-context-get-sample-merged)))
			(old_ontext-sample-criterion (car (gimp-context-get-sample-criterion)))
			(old_context-sample-threshold (car (gimp-context-get-sample-threshold)))
			(old_context-sample-transparent (car (gimp-context-get-sample-transparent)))

			(old-brush-size (car (gimp-context-get-brush-size)))
			(old-brush-aspect-ratio (car (gimp-context-get-brush-aspect-ratio)))
			(old-brush-angle (car (gimp-context-get-brush-angle)))
			(old-brush-name (car (gimp-context-get-brush)))
			
			(old-pattern (car (gimp-context-get-pattern)))

			(width 256)
			(height 256)
			; crer une nouvelle image rgb
			(image (car (gimp-image-new width height 0)))
			
			;calque_fond
			(calque_fond)
			(calque_couleur)


		)


		(gimp-context-set-antialias FALSE)
		(gimp-context-set-feather FALSE)
		(gimp-context-set-feather-radius 0 0)
		(gimp-context-set-sample-merged FALSE)
		(gimp-context-set-sample-criterion 0)
		(gimp-context-set-sample-threshold 0.15)
		(gimp-context-set-sample-transparent FALSE)

		(gimp-context-set-transform-direction TRANSFORM-FORWARD)
		(gimp-context-set-interpolation 2)
		(gimp-context-set-transform-recursion 3)
		(gimp-context-set-transform-resize TRANSFORM-RESIZE-ADJUST)
		
		(gimp-context-set-paint-mode 0) ;


;******************************************************************************************************
; 
;******************************************************************************************************

	;; Start undo group.
	(gimp-image-undo-group-start image)


;******************************************************************************************************
; 
;******************************************************************************************************
	; crer calque_fond
	(set! calque_fond (car (gimp-layer-new image width height 1 "calque_fond" 100 0)))	
	
	; ajouter le calque calque_fond
	(gimp-image-insert-layer image calque_fond 0 -1)

	(plug-in-plasma 1 image calque_fond (round (+ 10 (random 50000))) Turbulence)

	(while
		(> relief 0)
			(begin

				(gimp-image-select-contiguous-color image 0 calque_fond (round (random width)) (round (random height)) )

				(set! relief (- relief 1) )

		)
	)

	(gimp-selection-invert image)

	(gimp-edit-clear calque_fond)

	(gimp-selection-none image)

	(gimp-desaturate-full calque_fond 2)


	; crer calque_couleur
	(set! calque_couleur (car (gimp-layer-new image width height 1 "calque_couleur" 100 0)))	
	
	; ajouter le calque calque_fond
	(gimp-image-insert-layer image calque_couleur 0 -1)

	(gimp-context-set-foreground couleur)

	(gimp-drawable-fill calque_couleur 0)

	(plug-in-bump-map 
		1				; run-mode 
		image			; image 
		calque_couleur	; drawable 
		calque_fond		; bumpmap 
		azimuth			; azimuth 
		elevation		; elevation 
		depth			; depth 
		0				; xofs 
		0				; yofs 
		0				; waterlevel 
		0				; ambient 
		1				; compensate 
		0				; invert 
		0				; type
	)

	(plug-in-make-seamless 1 image calque_couleur)














;******************************************************************************************************
; 
;******************************************************************************************************

		;; rtablir le mode message
		(gimp-message-set-handler message)

		(gimp-context-set-transform-direction old_context_transform_direction )
		(gimp-context-set-interpolation old_context_interpolation)
		(gimp-context-set-transform-recursion old_context_recursion)
		(gimp-context-set-transform-resize old_context_transform_resize)
		(gimp-context-set-background old-bg)
		(gimp-context-set-foreground old-fg)


		(gimp-context-set-antialias old_context-antialias)
		(gimp-context-set-feather old_context-feather)
		(gimp-context-set-feather-radius old_context-feather-radiusx old_context-feather-radiusy)
		(gimp-context-set-sample-merged old_context-sample-merged)
		(gimp-context-set-sample-criterion old_ontext-sample-criterion)
		(gimp-context-set-sample-threshold old_context-sample-threshold)
		(gimp-context-set-sample-transparent old_context-sample-transparent)

		(gimp-context-set-brush-default-size)
		(gimp-context-set-brush-size old-brush-size)
		(gimp-context-set-brush-aspect-ratio old-brush-aspect-ratio)
		(gimp-context-set-brush-angle old-brush-angle)		
		(gimp-context-set-brush old-brush-name)

		(gimp-context-set-pattern old-pattern)



;******************************************************************************************************
; 
;******************************************************************************************************


		; afficher l'image
		(gimp-display-new image)

		; End undo group.
		(gimp-image-undo-group-end image)	





	)
)





(script-fu-register "1_motif_pattern_samj"
                    _"<Image>/File/Create/Patterns/1 Motif Pattern ..."
                    "1 Motif Pattern ..."
                    "samj"
                    "samj"
                    "20130406"
                    ""
					SF-COLOR "Color " '(64 128 192)
					SF-ADJUSTMENT "Turbulence " '(2 1 3 1 2 2 1)
					SF-ADJUSTMENT "Relief *** " '(32 8 192 1 5 0 1)
					SF-ADJUSTMENT "Azimuth " '(135 0 360 1 5 0 1)
					SF-ADJUSTMENT "Elevation " '(45 0.5 90 1 5 2 1)
					SF-ADJUSTMENT "Depth " '(3 1 65 1 5 0 1)

					


)

;; FIN





