; Dbut du script-fu Faire_un_bouton_Web2.0_gimp_2_8.scm
;
; Accs par :   Fichier > Crer > Boutons > Bouton Web 2.0...
;
;
; D'aprs un didacticiel cr par Ishimaru Chiaki : http://ishimaru-design.servhome.org/forum/forum-t720.html
;                                          forum  : http://www.gimp-attitude.org/forum2/viewtopic.php?f=39&t=7082
; 
;
; Licence GNU/GPL
;
; --------------------------------------------------------------------
; version 1.0 par samj (www.aljacom.com/~gimp) 2010/12/02
; version 1.1 par samj (www.aljacom.com/~gimp) 2010/12/03 (ajout contour)
; version 1.2 par samj (www.aljacom.com/~gimp) 2010/12/03 (ajout slections vers chemins pour utilisation ultrieure par l'utilisateur)
; version 1.3 par samj (www.aljacom.com/~gimp) 2010/12/09 modifications pour Gimp 2.7.2 
; version 1.3.1 par samj (www.aljacom.com/~gimp) 2011/05/16 modifications pour Gimp 2.7.3 
; --------------------------------------------------------------------
;
;

(define (faire_un_bouton_web_2_0 width height fg bg largeur_fond_bouton hauteur_fond_bouton arrondi_fond_bouton couleur_fond_bouton decalage_ombre tracer_contour couleur_contour)
	(let*
		(
			; affectation des variables
			
			; mmoriser les couleurs PP et AP
			(old-fg (car (gimp-context-get-foreground)))
			(old-bg (car (gimp-context-get-background)))
			
			; crer une nouvelle image rgb
			(img (car (gimp-image-new width height 0)))
			
			; crer le premier calque
			(calque_1 (car (gimp-layer-new img width height 1 "calque_1" 100 0)))	

			; crer le calque Lueur externe en mode superposer
			(lueur_externe_bouton (car (gimp-layer-new img width height 1 "Lueur externe bouton" 100 5)))

			; crer le calque Fond bouton
			(fond_bouton (car (gimp-layer-new img width height 1 "Fond bouton" 100 0)))
			
			; crer le calque Lueur interneen mode superposer
			(lueur_interne (car (gimp-layer-new img width height 1 "Lueur interne" 100 5)))
			
			(calque_5)			
			
			; crer le calque Reflet aqua bouton opacit 90%
			(reflet_aqua_bouton (car (gimp-layer-new img width height 1 "Reflet aqua bouton" 90 0)))
			

		)

	; ajouter le premier calque
	(gimp-image-insert-layer img calque_1 0 0)
	
	; ajouter le calque Lueur externe
	(gimp-image-insert-layer img lueur_externe_bouton -1 0)
	
	
	; appliquer les nouvelles couleurs PP et AP
	(gimp-context-set-foreground fg)
	(gimp-context-set-background bg)
	
	; appliquer un dgrad
	(gimp-edit-blend calque_1 0 0 0 100 0 0 FALSE FALSE 0 0 FALSE 1 1 1 height)
	
	; ajouter le calque Fond bouton
	(gimp-image-insert-layer img fond_bouton -1 0)

	; crer une slection rectangulaire aux paramtres fond bouton - arrondi centre sur l'image
	;(gimp-round-rect-select image x y width height corner-radius-x corner-radius-y operation antialias feather feather-radius-x feather-radius-y)
	;(gimp-round-rect-select 
	;						img ; image
	;						(- (/ width 2) (/ largeur_fond_bouton 2)) ; x
	;						(- (/ height 2) (/ hauteur_fond_bouton 2)) ; y 
	;						largeur_fond_bouton ; width 
	;						hauteur_fond_bouton ; height 
	;						arrondi_fond_bouton ; corner-radius-x 
	;						arrondi_fond_bouton ; corner-radius-y 
	;						0 ; operation 
	;						TRUE ; antialias 
	;						FALSE ; feather 
	;						0 ; feather-radius-x 
	;						0 ; feather-radius-y
	;)
	; Modifications pour Gimp 2.7.3
	;(gimp-context-set-antialias antialias)
	(gimp-context-set-antialias TRUE)
	;(gimp-image-select-round-rectangle image operation x y width height corner-radius-x corner-radius-y)
	(gimp-image-select-round-rectangle 
							img ; image 
							0 ; operation 
							(- (/ width 2) (/ largeur_fond_bouton 2)) ; x 
							(- (/ height 2) (/ hauteur_fond_bouton 2)) ; y 
							largeur_fond_bouton ; width 
							hauteur_fond_bouton ; height 
							arrondi_fond_bouton ; corner-radius-x 
							arrondi_fond_bouton ; corner-radius-y
	)


	
	
	; couleur_fond_bouton comme couleur de PP
	(gimp-context-set-foreground couleur_fond_bouton)

	; remplir la slection du calque fond bouton avec PP
	(gimp-edit-fill fond_bouton 0)

	
	; slection vers chemin
	(plug-in-sel2path 1 img fond_bouton)
	
	
	; ne rien slectionner
	(gimp-selection-none img)
	
	
	

	; modif samj cration du contour
	(if 
		(= tracer_contour TRUE)
			(begin
					; crer une slection rectangulaire aux paramtres fond bouton - 1px et - arrondi centre sur l'image
					;(gimp-round-rect-select 
					;		img ; image
					;		(- (/ width 2) (/ (- largeur_fond_bouton 2) 2)) ; x
					;		(- (/ height 2) (/ (- hauteur_fond_bouton 2) 2)) ; y 
					;		(- largeur_fond_bouton 2) ; width 
					;		(- hauteur_fond_bouton 2) ; height 
					;		arrondi_fond_bouton ; corner-radius-x 
					;		arrondi_fond_bouton ; corner-radius-y 
					;		0 ; operation 
					;		TRUE ; antialias 
					;		FALSE ; feather 
					;		0 ; feather-radius-x 
					;		0 ; feather-radius-y
					;)
					; Modifications pour Gimp 2.7.3
					;(gimp-context-set-antialias antialias)
					(gimp-context-set-antialias TRUE)
					;(gimp-image-select-round-rectangle image operation x y width height corner-radius-x corner-radius-y)
					(gimp-image-select-round-rectangle 
							img ; image 
							0 ; operation 
							(- (/ width 2) (/ (- largeur_fond_bouton 2) 2)) ; x 
							(- (/ height 2) (/ (- hauteur_fond_bouton 2) 2)) ; y 
							(- largeur_fond_bouton 2) ; width 
							(- hauteur_fond_bouton 2) ; height 
							arrondi_fond_bouton ; corner-radius-x 
							arrondi_fond_bouton ; corner-radius-y
					)					
					
					; crer une slection avec bordure
					(gimp-selection-border img 1)
					
					; couleur_contour comme couleur de PP
					(gimp-context-set-foreground couleur_contour)

					; remplir la slection du calque fond bouton avec PP
					(gimp-edit-fill fond_bouton 0)

					; slection vers chemin
					(plug-in-sel2path 1 img fond_bouton)					
					
					
					; ne rien slectionner
					(gimp-selection-none img)					
					
			)
	)


	

	; crer une slection rectangulaire aux paramtres fond bouton - arrondi centre sur l'image avec feather important
	;(gimp-round-rect-select 
	;						img ; image
	;						(- (/ width 2) (/ largeur_fond_bouton 2)) ; x
	;						(- (/ height 2) (/ hauteur_fond_bouton 2)) ; y 
	;						largeur_fond_bouton ; width 
	;						hauteur_fond_bouton ; height 
	;						arrondi_fond_bouton ; corner-radius-x 
	;						arrondi_fond_bouton ; corner-radius-y 
	;						0 ; operation 
	;						TRUE ; antialias 
	;						TRUE ; feather 
	;						6 ; feather-radius-x 
	;						6 ; feather-radius-y
	;)
	; Modifications pour Gimp 2.7.3
	;(gimp-context-set-antialias antialias)
	(gimp-context-set-antialias TRUE)
	;(gimp-image-select-round-rectangle image operation x y width height corner-radius-x corner-radius-y)
	(gimp-image-select-round-rectangle 
							img ; image 
							0 ; operation 
							(- (/ width 2) (/ largeur_fond_bouton 2)) ; x 
							(- (/ height 2) (/ hauteur_fond_bouton 2)) ; y 
							largeur_fond_bouton ; width 
							hauteur_fond_bouton ; height 
							arrondi_fond_bouton ; corner-radius-x 
							arrondi_fond_bouton ; corner-radius-y
	)	
	
	
	; noir comme couleur de PP
	(gimp-context-set-foreground '(0 0 0))
	
	; remplir la slection du calque Lueur externe bouton avec PP
	(gimp-edit-fill lueur_externe_bouton 0)

	; slection vers chemin
	(plug-in-sel2path 1 img fond_bouton)

	
	; ne rien slectionner
	(gimp-selection-none img)	
	
	
	; ajouter le calque Lueur interne
	(gimp-image-insert-layer img lueur_interne -1 0)	
 
	; crer une slection rectangulaire aux paramtres fond bouton - arrondi centre sur l'image
	;(gimp-round-rect-select 
	;						img ; image
	;						(- (/ width 2) (/ largeur_fond_bouton 2)) ; x
	;						(- (/ height 2) (/ hauteur_fond_bouton 2)) ; y 
	;						largeur_fond_bouton ; width 
	;						hauteur_fond_bouton ; height 
	;						arrondi_fond_bouton ; corner-radius-x 
	;						arrondi_fond_bouton ; corner-radius-y 
	;						0 ; operation 
	;						TRUE ; antialias 
	;						FALSE ; feather 
	;						0 ; feather-radius-x 
	;						0 ; feather-radius-y
	;)
	; Modifications pour Gimp 2.7.3
	;(gimp-context-set-antialias antialias)
	(gimp-context-set-antialias TRUE)
	;(gimp-image-select-round-rectangle image operation x y width height corner-radius-x corner-radius-y)
	(gimp-image-select-round-rectangle 
							img ; image 
							0 ; operation 
							(- (/ width 2) (/ largeur_fond_bouton 2)) ; x 
							(- (/ height 2) (/ hauteur_fond_bouton 2)) ; y 
							largeur_fond_bouton ; width 
							hauteur_fond_bouton ; height 
							arrondi_fond_bouton ; corner-radius-x 
							arrondi_fond_bouton ; corner-radius-y
	)

	
	; blanc comme couleur de PP
	(gimp-context-set-foreground '(255 255 255))	

	; appliquer un dgrad sur lueur_interne
	(gimp-edit-blend 
					lueur_interne 
					2 ; FG-TRANSPARENT-MODE 
					0 
					0 
					100 
					0 
					0 
					FALSE 
					FALSE 
					0 
					0 
					FALSE 
					(/ width 2) ; x1 
					(+ (/ height 2) (/ hauteur_fond_bouton 2)) ; y1 
					(/ width 2) ; x2
					(- (+ (/ height 2) (/ hauteur_fond_bouton 2))  (/ hauteur_fond_bouton 3)) ; y2
	)

	
	; slection vers chemin
	(plug-in-sel2path 1 img lueur_interne)	
	
	
	
	; ne rien slectionner
	(gimp-selection-none img)	
	
	
	
	; dupliquer le calque lueur_interne
	(set! calque_5 (car (gimp-layer-copy lueur_interne TRUE)))	
	
	; ajouter le calque calque_5
	(gimp-image-insert-layer img calque_5 -1 0)		
				
	; donner un nom au calque
	(gimp-item-set-name calque_5 "calque_5")

	; retourner vertical
	(gimp-item-transform-flip-simple calque_5 1 TRUE (/ height 2))
	
	; dplacer le calque
	(gimp-layer-translate calque_5 0 (+ hauteur_fond_bouton decalage_ombre))
	

 	; ajouter le calque reflet_aqua_bouton
	(gimp-image-insert-layer img reflet_aqua_bouton -1 0)

	; crer une slection rectangulaire pour l'effet aqua avec feather faible
	;(gimp-round-rect-select 
	;						img ; image
	;						(- (/ width 2) (/ largeur_fond_bouton 2)) ; x
	;						(- (/ height 2) (/ hauteur_fond_bouton 2)) ; y 
	;						largeur_fond_bouton ; width 
	;						hauteur_fond_bouton ; height 
	;						arrondi_fond_bouton ; corner-radius-x 
	;						arrondi_fond_bouton ; corner-radius-y 
	;						0 ; operation 
	;						TRUE ; antialias 
	;						TRUE ; feather 
	;						0 ; feather-radius-x 
	;						2 ; feather-radius-y
	;)
	; Modifications pour Gimp 2.7.3
	;(gimp-context-set-antialias antialias)
	(gimp-context-set-antialias TRUE)
	;(gimp-context-set-feather feather)
	(gimp-context-set-feather TRUE)
	; (gimp-context-set-feather-radius feather-radius-x feather-radius-y)
	(gimp-context-set-feather-radius 0 2)
	;(gimp-image-select-round-rectangle image operation x y width height corner-radius-x corner-radius-y)
	(gimp-image-select-round-rectangle 
							img ; image 
							0 ; operation 
							(- (/ width 2) (/ largeur_fond_bouton 2)) ; x 
							(- (/ height 2) (/ hauteur_fond_bouton 2)) ; y 
							largeur_fond_bouton ; width 
							hauteur_fond_bouton ; height 
							arrondi_fond_bouton ; corner-radius-x 
							arrondi_fond_bouton ; corner-radius-y
	)
	;(gimp-context-set-feather feather)
	(gimp-context-set-feather FALSE)
	; (gimp-context-set-feather-radius feather-radius-x feather-radius-y)
	(gimp-context-set-feather-radius 0 0)	




	
	; blanc comme couleur de PP
	(gimp-context-set-foreground '(255 255 255))	

	; appliquer un dgrad sur reflet_aqua_bouton
	(gimp-edit-blend 
					reflet_aqua_bouton 
					2 ; FG-TRANSPARENT-MODE 
					0 
					0 
					100 
					0 
					0 
					FALSE 
					FALSE 
					0 
					0 
					FALSE 
					(/ width 2) ; x1 
					(- (/ height 2) (/ hauteur_fond_bouton 2)) ; y1 
					(/ width 2) ; x2
					(+ (- (/ height 2) (/ hauteur_fond_bouton 2))  (* hauteur_fond_bouton 0.75)) ; y2
	)	
	
 
	; slection vers chemin
	(plug-in-sel2path 1 img reflet_aqua_bouton)	

 
	; restaurer PP et AP
	(gimp-context-set-foreground  old-fg)
	(gimp-context-set-background old-bg)
    
	; ne rien slectionner
	(gimp-selection-none img)
	
	; afficher l'image
	(gimp-display-new img)	

	)
		
)

(script-fu-register
	"faire_un_bouton_web_2_0"
	"<Image>/File/Create/Buttons/Bouton Web 2.0..."
	"Faire un bouton Web 2.0 (didacticiel Ishimaru Chiaki)"
	"samj"
	"samj"
	"2010-12-02"
	""
	SF-VALUE "Largeur nouveau document" "400"
	SF-VALUE "Hauteur nouveau document" "200"
	SF-COLOR "Couleur Premier Plan" '(92 138 222)
	SF-COLOR "Couleur Arriere-Plan" '(40 86 172)
	SF-VALUE "Largeur fond bouton" "160"
	SF-VALUE "Hauteur fond bouton" "30"
	SF-VALUE "Arrondi fond bouton" "5"
	SF-COLOR "Couleur fond bouton" '(157 195 38)
	SF-VALUE "Decalage ombre" "4"
	SF-TOGGLE "Tracer un contour sur le bouton" FALSE
	SF-COLOR "Couleur du contour" '(200 248 48)


)

; FIN du script