; Dbut du script-fu Motif_Volute_et_Cadre_Gimp_2_8.scm
;
; Accs par :   Fichier > Crer > Motifs > Motif Volute...
;               File > Create > Patterns > Motif Volute...
;
;                __________________________________________________________
; 
;
;
;
; Licence GNU/GPL
;
; --------------------------------------------------------------------
; dit avec Notepad++    http://notepad-plus-plus.org/
;
; version 1.0 par samj (  http://www.aljacom.com/~gimp       http://samjcreations.blogspot.com  ) 29 juin 2012
;
; --------------------------------------------------------------------
;
; Permer de crer 2 motifs avec des volutes. Ces 2 motifs peuvenr tre enregistrs comme motif de Gimp dans le rpertoire de l'utilisateur.
;





;*************************************************************************************************************************
;*************************************************************************************************************************
;*****************************                                                               *****************************
;*****************************                        CRATION DES MOTIFS                    *****************************
;*****************************                                                               *****************************
;*************************************************************************************************************************
;*************************************************************************************************************************

(define (
				Motif_Volute_et_Cadre
				width
				height
				Appliquer_un_flou
				Valeur_du_flou
				Afficher_les_images_des_motifs
				Sauvegarder_les_motifs
				Appel_de_cadre ; 0=appel pour cration des motifs  1=appel pour crer un cadre

		)
		
	(let*
		(
			; affectation des variables		
	
			; mmoriser les couleurs PP et AP
			(old-fg (car (gimp-context-get-foreground)))
			(old-bg (car (gimp-context-get-background)))
			
			; mmoriser la brosse active
			(old-brush (car (gimp-context-get-brush)))	

			; mmoriser le dgrad actif
			(old_gradient (car (gimp-context-get-gradient)))
			
			; mmoriser le motif actif
			(old_pattern (car (gimp-context-get-pattern)))

			; dterminer les dimensions du motif de base pour crer la spirale	
			(width_origine width)
			(height_origine height)
			
			
			; dterminer les dimensions du motif de base pour crer la spirale	
			(width (round (/ width 2) ) ) 
			(height (round (/ height 2) ) )

			; image qui servira  crer le motif
			(img (car (gimp-image-new width height 0)))	

			; calque_fond
			(calque_fond)
			
			; image img_motif_horizontal
			(img_motif_horizontal (car (gimp-image-new (* 2 width) (* 2 height) 0)))
			
			; calque_fond_H
			(calque_fond_H)

			; image img_motif_vertical
			(img_motif_vertical (car (gimp-image-new (* 2 height) (* 2 width) 0)))	

			; calque_fond_V
			(calque_fond_V)

			; rpertoire + nom de fichier motif
			(path)
			
		)




		

	
	;; Start undo group.
	(gimp-image-undo-group-start img)
	(gimp-image-undo-group-start img_motif_horizontal)		
	(gimp-image-undo-group-start img_motif_vertical)		

	
	
	
	
	
	; scurit pour que le script donne un rsultat
	(if
		(and (= Afficher_les_images_des_motifs FALSE) (= Sauvegarder_les_motifs FALSE)   )
			(set! Afficher_les_images_des_motifs TRUE)
	)	
	
	
	
	
	
	
		
; Message alarme*********************************************************************************


	; indiquer la nouvelle dimension si une des dimensions est impaire
	(if
		(or (= 1 (modulo width_origine 2)) (= 1 (modulo height_origine 2))  )
			(gimp-message (strcat "Nouvelles/New Dimensions : "  (number->string (* width 2)) "|" (number->string (* height 2))  ))
	)		
		
		
		

; calque_fond*********************************************************************************
	

	; crer calque_fond
	(set! calque_fond (car (gimp-layer-new img width height 1 "calque_fond" 100 0)))	
	
	; ajouter le calque calque_fond
	(gimp-image-insert-layer img calque_fond 0 -1)

	; modifier couleur de premier plan
	(gimp-context-set-foreground '(0 0 0))
	
	; modifier couleur d'arrire plan
	(gimp-context-set-background '(255 255 255))

	; remplir de PP	
	(gimp-drawable-fill calque_fond 0)	
	
	; appliquer un dgrad sur calque_gradient
	(gimp-edit-blend 
		calque_fond 
		0 						; MODE
		0 
		9 						; GRADIENT-SPIRAL-CLOCKWISE
		100 
		0 
		0 
		FALSE 
		FALSE 
		0 
		0 
		FALSE 
		(- (/ width 2) 1)		; x1 
		(+ 1 (/ height 2))		; y1 
		(- (/ width 2) 1)		; x2
		height 					; y2
	)	
	
	; copier visible
	(gimp-edit-copy-visible img)

	


; calque_fond image img_motif_horizontal ******************************************************
	

	; crer calque_fond_H
	(set! calque_fond_H (car (gimp-layer-new img_motif_horizontal (* 2 width) (* 2 height) 1 "calque_fond_H" 100 0)))	
	
	; ajouter le calque calque_fond_H
	(gimp-image-insert-layer img_motif_horizontal calque_fond_H 0 -1)

	; crer une slection rectangulaire
	(gimp-image-select-rectangle
		img_motif_horizontal		; image 
		0							; operation 
		0							; x 
		0							; y 
		width						; width 
		height						; height
	)		
	
	; coller et ancrer
	(gimp-floating-sel-anchor (car (gimp-edit-paste calque_fond_H FALSE)))
	
	

	
	
	

; calque_fond*********************************************************************************

	; retourner horizontalement
	(gimp-image-flip img 0)

	; copier visible
	(gimp-edit-copy-visible img)



	
	
	
; calque_fond image img_motif_horizontal ******************************************************
	


	; crer une slection rectangulaire
	(gimp-image-select-rectangle
		img_motif_horizontal		; image 
		0							; operation 
		width						; x 
		0							; y 
		(* 2 width)					; width 
		height						; height
	)		
	
	; coller et ancrer
	(gimp-floating-sel-anchor (car (gimp-edit-paste calque_fond_H FALSE)))


	; crer une slection rectangulaire
	(gimp-image-select-rectangle
		img_motif_horizontal		; image 
		0							; operation 
		0							; x 
		0							; y 
		(* 2 width)					; width 
		height						; height
	)


	; copier visible
	(gimp-edit-copy-visible img_motif_horizontal)

	; ne rien slectionner
	(gimp-selection-none img_motif_horizontal)	
	


	



; calque_fond*********************************************************************************

	; changer la dimension via une mise  l'chelle
	(gimp-image-scale img (* 2 width) height)

	; coller et ancrer
	(gimp-floating-sel-anchor (car (gimp-edit-paste calque_fond FALSE)))

	; retourner verticalement
	(gimp-image-flip img 1)

	; copier visible
	(gimp-edit-copy-visible img)





	
	
	
; calque_fond image img_motif_horizontal ******************************************************
	




	; crer une slection rectangulaire
	(gimp-image-select-rectangle
		img_motif_horizontal		; image 
		0							; operation 
		0							; x 
		height						; y 
		(* 2 width)					; width 
		(* 2 height)				; height
	)


	; coller et ancrer
	(gimp-floating-sel-anchor (car (gimp-edit-paste calque_fond_H FALSE)))

	; ne rien slectionner
	(gimp-selection-none img_motif_horizontal)	

	
	; appliquer un flou
	(if
		(= Appliquer_un_flou TRUE)
			(plug-in-gauss 1 img_motif_horizontal calque_fond_H Valeur_du_flou Valeur_du_flou 1)
	)
	
	; sauvegarde du motif sur le disque dur ou la clef USB
	(if
		(and (= Sauvegarder_les_motifs TRUE) (= Appel_de_cadre 0) )
		
			(begin		
				; dterminer le chemin complet du motif  sauvegarder
				(set! path (string-append gimp-directory "/patterns/" (strcat "Motif_Volute_H_"  (number->string (* width 2)) "_" (number->string (* height 2)) ) ".pat"))
				
				; sauvegarder le motif sous :  Motif_Volute_H_xxx_yyy.pat
				(file-pat-save 1 img_motif_horizontal calque_fond_H path path (strcat "Motif_Volute_H_"  (number->string (* width 2)) "_" (number->string (* height 2)) ) )
				
				; mettre  jour les motifs dans Gimp
				(gimp-patterns-refresh)
				
				; choisir le motif comme motif actif
				(gimp-context-set-pattern (strcat "Motif_Volute_H_"  (number->string (* width 2)) "_" (number->string (* height 2)) ) )
						
			)
	)
	
	
	; sauvegarde du motif pour le cadre sur le disque dur ou la clef USB
	(if
		(= Appel_de_cadre 1)
		
			(begin		
				; dterminer le chemin complet du motif  sauvegarder
				(set! path (string-append gimp-directory "/patterns/Motif_Volute_H_Cadre.pat"))
				
				; sauvegarder le motif sous :  Motif_Volute_H_Cadre.pat
				(file-pat-save 1 img_motif_horizontal calque_fond_H path path "Motif_Volute_H_Cadre.pat"  )
				
				; mettre  jour les motifs dans Gimp
				(gimp-patterns-refresh)
				
				; choisir le motif comme motif actif
				(gimp-context-set-pattern (strcat "Motif_Volute_H_Cadre.pat" ))
						
			)
	)	
	
	
	; copier visible
	(gimp-edit-copy-visible img_motif_horizontal)




	
	
; calque_fond_V image img_motif_vertical ******************************************************
	

	; crer calque_fond_V
	(set! calque_fond_V (car (gimp-layer-new img_motif_vertical (* 2 width) (* 2 height) 1 "calque_fond_V" 100 0)))	
	
	; ajouter le calque calque_fond
	(gimp-image-insert-layer img_motif_vertical calque_fond_V 0 -1)	

	; crer une slection rectangulaire
	(gimp-image-select-rectangle
		img_motif_vertical			; image 
		0							; operation 
		0							; x 
		0							; y 
		(* 2 width)					; width 
		(* 2 height)				; height
	)
	
	; coller et ancrer
	(gimp-floating-sel-anchor (car (gimp-edit-paste calque_fond_V FALSE)))	
	
	; ne rien slectionner
	(gimp-selection-none img_motif_vertical)		
	
	; rotation de -90
	(gimp-image-rotate img_motif_vertical 0)
	
	; ajuster le canevas de l'image au calque
	(gimp-image-resize-to-layers img_motif_vertical)
	
	; sauvegarde du motif sur le disque dur ou la clef USB
	(if
		(and (= Sauvegarder_les_motifs TRUE) (= Appel_de_cadre 0) )
		
			(begin		
				; dterminer le chemin complet du motif  sauvegarder
				(set! path (string-append gimp-directory "/patterns/" (strcat "Motif_Volute_V_"  (number->string (* width 2)) "_" (number->string (* height 2)) ) ".pat"))
				
				; sauvegarder le motif sous :  Motif_Volute_V_xxx_yyy.pat
				(file-pat-save 1 img_motif_vertical calque_fond_V path path (strcat "Motif_Volute_V_"  (number->string (* width 2)) "_" (number->string (* height 2)) ) )
				
				; mettre  jour les motifs dans Gimp
				(gimp-patterns-refresh)
				
				; choisir le motif comme motif actif
				(gimp-context-set-pattern (strcat "Motif_Volute_V_"  (number->string (* width 2)) "_" (number->string (* height 2)) ) )
						
			)
	)


	
	; sauvegarde du motif pour le cadre sur le disque dur ou la clef USB
	(if
		(= Appel_de_cadre 1)
		
			(begin		
				; dterminer le chemin complet du motif  sauvegarder
				(set! path (string-append gimp-directory "/patterns/Motif_Volute_V_Cadre.pat"))
				
				; sauvegarder le motif sous :  Motif_Volute_V_Cadre.pat
				(file-pat-save 1 img_motif_vertical calque_fond_V path path "Motif_Volute_V_Cadre.pat"  )
				
				; mettre  jour les motifs dans Gimp
				(gimp-patterns-refresh)
				
				; choisir le motif comme motif actif
				(gimp-context-set-pattern (strcat "Motif_Volute_V_Cadre.pat" ))
						
			)
	)
	
	; crer une slection rectangulaire
	(gimp-image-select-rectangle
		img_motif_vertical			; image 
		0							; operation 
		0							; x 
		0							; y 
		1							; width 
		1							; height
	)
	
	; copier visible
	(gimp-edit-copy-visible img_motif_vertical)

	; ne rien slectionner
	(gimp-selection-none img_motif_vertical)	








	
; calque_fond*********************************************************************************	
	
	; supprimer l'image
	(gimp-image-delete img)
	
	


; affichage des images des motifs***********************************************************
	

	; test
	(if
		(and (= Afficher_les_images_des_motifs TRUE) (= Appel_de_cadre 0) )
			(begin
				(gimp-display-new img_motif_horizontal)
				(gimp-display-new img_motif_vertical)
				
				(gimp-image-undo-group-end img_motif_horizontal)	
				(gimp-image-undo-group-end img_motif_vertical)			
			)
			; else
			(begin
				(gimp-image-delete img_motif_horizontal)			
				(gimp-image-delete img_motif_vertical)			
			)			
	)
	
	
	
	
;*******************************************************************************************
	
	; restaurer PP et AP
	(gimp-context-set-foreground  old-fg)
	(gimp-context-set-background old-bg)
	
	; restaurer ancien dgrad
	(gimp-context-set-gradient old_gradient)
	
	; restaurer brosse
	(gimp-context-set-brush old-brush)
	
	; restaurer motif
	(gimp-context-set-pattern old_pattern)

	; ne rien slectionner
	;(gimp-selection-none img)
	
	; afficher les images pour tests
	; (gimp-display-new img)
	; (gimp-display-new img_motif_horizontal)
	; (gimp-display-new img_motif_vertical)	
	

	; End undo group pour tests
	; (gimp-image-undo-group-end img)
	; (gimp-image-undo-group-end img_motif_horizontal)	
	; (gimp-image-undo-group-end img_motif_vertical)	

	


	)
		
)




;*************************************************************************************************************************
;*************************************************************************************************************************
;*****************************                                                               *****************************
;*****************************                         CRATION DU CADRE                     *****************************
;*****************************                                                               *****************************
;*************************************************************************************************************************
;*************************************************************************************************************************



(define 
	(
		Cadre_Volute_et_Cadre
		width_cadre
		height_cadre
		Nombre_de_rangees_de_motif
		Couleur_du_cadre
		Dimension_du_motif

	)
	

	
	(let* 
		(

		
			; mmoriser les couleurs PP et AP
			(old-fg_cadre (car (gimp-context-get-foreground)))
			(old-bg_cadre (car (gimp-context-get-background)))
			
			; mmoriser la brosse active
			(old-brush_cadre (car (gimp-context-get-brush)))	

			; mmoriser le dgrad actif
			(old_gradient_cadre (car (gimp-context-get-gradient)))
		
			; mmoriser le motif actif
			(old_pattern_cadre (car (gimp-context-get-pattern)))

			; indiquer les dimensions du motif avec des dimensions paires
			(width_motif_cadre (* 2 (round (* Dimension_du_motif 12)))) ; pour toujours avoir un nombre pair
			(height_motif_cadre (* 2 (round (* Dimension_du_motif 8)))) ; pour toujours avoir un nombre pair
			
			; largeur_cadre_definitif
			(largeur_cadre_definitif (+ width_cadre (* height_motif_cadre (* 2 Nombre_de_rangees_de_motif)))  )
			
			; hauteur_cadre_definitif
			(hauteur_cadre_definitif (+ height_cadre (* height_motif_cadre (* 2 Nombre_de_rangees_de_motif)))   )

			; image qui servira  crer le motif
			(img_cadre (car (gimp-image-new  largeur_cadre_definitif  hauteur_cadre_definitif 0)))

			; calque_fond_cadre
			(calque_fond_cadre)
			
			; array trapze
			(*points* (cons-array 8 'double))
			
			; calque_fond_cadre_2
			(calque_fond_cadre_2)
			
			; calque_fond_cadre_3
			(calque_fond_cadre_3)
			
			; array_points_brosse
			(*array_points_brosse* (cons-array 4 'double))
			
			; calque_couleur_cadre
			(calque_couleur_cadre)
			
			; calque_interieur_cadre
			(calque_interieur_cadre)
			
			; Nombre_total_de_motifs
			(Nombre_total_de_motifs (car (gimp-patterns-get-list "")))
			
			; index
			(index 0)
			
		)
		
		
	; vrifications
	; (gimp-message (strcat "Dim motif : "  (number->string  width_motif_cadre ) "|" (number->string  height_motif_cadre )  )  )
	; (gimp-message (strcat "Nb pattern : "  (number->string  (car (gimp-patterns-get-list ""))  )  )  )
	; (gimp-message (strcat "Nombre_total_de_motifs : "  (number->string  Nombre_total_de_motifs  )  )  )
	; (gimp-message (strcat "gimp-patterns-get-list H : "  (list-ref (cadr (gimp-patterns-get-list "")) 10)  )  ) ; nom du motif 10
	
;ATTENDRE UNE MISE  JOUR DE LA FONCTION (gimp-patterns-refresh)	Qui ne fonctionne pas	
	; boucle pour trouver si des anciens motifs sont prsents
	(while (< index Nombre_total_de_motifs)
	
		; (gimp-message (strcat "gimp-patterns-get-list H : "  (list-ref (cadr (gimp-patterns-get-list "")) index  )  )  ) ; nom du motif index
		
		; le motif Motif_Volute_H_Cadre.pat est-il prsent ?
		(if 
			(string=? "Motif_Volute_H_Cadre.pat" (list-ref (cadr (gimp-patterns-get-list "")) index  ) )
			
				(gimp-message "Concordance Motif_Volute_H_Cadre.pat")
		)
		

		; le motif Motif_Volute_V_Cadre.pat est-il prsent ?	
		(if 
			(string=? "Motif_Volute_V_Cadre.pat" (list-ref (cadr (gimp-patterns-get-list "")) index  ) )
			
				(gimp-message "Concordance Motif_Volute_V_Cadre.pat")
		)
		
		(set! index (+ index 1) )
	)



	

	;; Start undo group.
	(gimp-image-undo-group-start img_cadre)
	
	
	
		
; calque_fond_cadre*********************************************************************************
	

	; crer calque_fond_cadre
	(set! calque_fond_cadre (car (gimp-layer-new img_cadre largeur_cadre_definitif hauteur_cadre_definitif 1 "calque_fond_cadre" 100 0)))	
	
	; ajouter le calque calque_fond_cadre
	(gimp-image-insert-layer img_cadre calque_fond_cadre 0 -1)

	; modifier couleur de premier plan
	(gimp-context-set-foreground '(0 0 0))
	
	; modifier couleur d'arrire plan
	(gimp-context-set-background '(255 255 255))		
	
	; (gimp-message (strcat "Dimensions MC : " (number->string width_motif_cadre) "*"  (number->string height_motif_cadre)  ) )

	; appel cration des motifs
	; (Motif_Volute_et_Cadre width height Appliquer_un_flou Valeur_du_flou Afficher_les_images_des_motifs Sauvegarder_les_motifs Appel_de_cadre)
	(Motif_Volute_et_Cadre width_motif_cadre height_motif_cadre TRUE (round (/ width_motif_cadre 24)) TRUE FALSE 1)

	; dterminer les coordonnes des 4 points du trapze isocle
	(aset *points* 0 0) ; x0
	(aset *points* 1 0) ; y0
	(aset *points* 2 largeur_cadre_definitif) ; x1
	(aset *points* 3 0) ; y1
	(aset *points* 4 (- largeur_cadre_definitif (* Nombre_de_rangees_de_motif height_motif_cadre) )  ) ; x2
	(aset *points* 5 (* Nombre_de_rangees_de_motif height_motif_cadre)  ) ; y2
	(aset *points* 6 (* Nombre_de_rangees_de_motif height_motif_cadre)  ) ; x3
	(aset *points* 7 (* Nombre_de_rangees_de_motif height_motif_cadre)  ) ; y3
	
	; slectionner le haut du cadre selon un trapze isocle
	(gimp-image-select-polygon 
		img_cadre				; image 
		2						; operation 
		8						; num-segs 
		*points*				; segs
	)
	
	; sauvegarder cette slection dans un chemin
	(plug-in-sel2path 1 img_cadre calque_fond_cadre)

	; donner un nom au chemin
	(gimp-item-set-name (car (gimp-image-get-active-vectors img_cadre)) "cadre_haut")

	; mettre  jour les motifs dans Gimp
	(gimp-patterns-refresh)	
	
	; slectionner le motif
	(gimp-patterns-set-pattern "Motif_Volute_H_Cadre.pat")
	
	; remplir du motif
	(gimp-edit-bucket-fill calque_fond_cadre 2 0 100 0 FALSE 0 0)
	
	; ne rien slectionner
	(gimp-selection-none img_cadre)
	
	; dterminer les coordonnes des 4 points du trapze isocle
	(aset *points* 0 largeur_cadre_definitif) ; x0
	(aset *points* 1 0) ; y0
	(aset *points* 2 largeur_cadre_definitif) ; x1
	(aset *points* 3 hauteur_cadre_definitif) ; y1
	(aset *points* 4 (- largeur_cadre_definitif (* Nombre_de_rangees_de_motif height_motif_cadre) )  ) ; x2
	(aset *points* 5 (- hauteur_cadre_definitif (* Nombre_de_rangees_de_motif height_motif_cadre) )  ) ; y2
	(aset *points* 6 (- largeur_cadre_definitif (* Nombre_de_rangees_de_motif height_motif_cadre) )  ) ; x3
	(aset *points* 7 (* Nombre_de_rangees_de_motif height_motif_cadre)  ) ; y3
	
	; slectionner le haut du cadre selon un trapze isocle
	(gimp-image-select-polygon 
		img_cadre				; image 
		2						; operation 
		8						; num-segs 
		*points*				; segs
	)
	
	; sauvegarder cette slection dans un chemin
	(plug-in-sel2path 1 img_cadre calque_fond_cadre)

	; donner un nom au chemin
	(gimp-item-set-name (car (gimp-image-get-active-vectors img_cadre)) "cadre_droite")

	; ne rien slectionner
	(gimp-selection-none img_cadre)

	; dterminer les coordonnes des 4 points du trapze isocle
	(aset *points* 0 largeur_cadre_definitif) ; x0
	(aset *points* 1 hauteur_cadre_definitif) ; y0
	(aset *points* 2 0) ; x1
	(aset *points* 3 hauteur_cadre_definitif) ; y1
	(aset *points* 4 (* Nombre_de_rangees_de_motif height_motif_cadre)  ) ; x2
	(aset *points* 5 (- hauteur_cadre_definitif (* Nombre_de_rangees_de_motif height_motif_cadre) )  ) ; y2
	(aset *points* 6 (- largeur_cadre_definitif (* Nombre_de_rangees_de_motif height_motif_cadre) )  ) ; x3
	(aset *points* 7 (- hauteur_cadre_definitif (* Nombre_de_rangees_de_motif height_motif_cadre) )  ) ; y3
	
	; slectionner le haut du cadre selon un trapze isocle
	(gimp-image-select-polygon 
		img_cadre				; image 
		2						; operation 
		8						; num-segs 
		*points*				; segs
	)
	
	; sauvegarder cette slection dans un chemin
	(plug-in-sel2path 1 img_cadre calque_fond_cadre)

	; donner un nom au chemin
	(gimp-item-set-name (car (gimp-image-get-active-vectors img_cadre)) "cadre_bas")

	; ne rien slectionner
	(gimp-selection-none img_cadre)


	; dterminer les coordonnes des 4 points du trapze isocle
	(aset *points* 0 0) ; x0
	(aset *points* 1 hauteur_cadre_definitif) ; y0
	(aset *points* 2 0) ; x1
	(aset *points* 3 0) ; y1
	(aset *points* 4 (* Nombre_de_rangees_de_motif height_motif_cadre)  ) ; x2
	(aset *points* 5 (* Nombre_de_rangees_de_motif height_motif_cadre)  ) ; y2
	(aset *points* 6 (* Nombre_de_rangees_de_motif height_motif_cadre)  ) ; x3
	(aset *points* 7 (- hauteur_cadre_definitif (* Nombre_de_rangees_de_motif height_motif_cadre) )  ) ; y3
	
	; slectionner le haut du cadre selon un trapze isocle
	(gimp-image-select-polygon 
		img_cadre				; image 
		2						; operation 
		8						; num-segs 
		*points*				; segs
	)
	
	; sauvegarder cette slection dans un chemin
	(plug-in-sel2path 1 img_cadre calque_fond_cadre)

	; donner un nom au chemin
	(gimp-item-set-name (car (gimp-image-get-active-vectors img_cadre)) "cadre_gauche")

	; mettre  jour les motifs dans Gimp
	(gimp-patterns-refresh)	
	
	; slectionner le motif
	(gimp-patterns-set-pattern "Motif_Volute_V_Cadre.pat")
	
	; remplir du motif
	(gimp-edit-bucket-fill calque_fond_cadre 2 0 100 0 FALSE 0 0)
	
	; ne rien slectionner
	(gimp-selection-none img_cadre)
	


; calque_fond_cadre_2*********************************************************************************
	

	; crer calque_fond_cadre_2
	(set! calque_fond_cadre_2 (car (gimp-layer-new img_cadre largeur_cadre_definitif hauteur_cadre_definitif 1 "calque_fond_cadre_2" 100 0)))	
	
	; ajouter le calque calque_fond_cadre_2
	(gimp-image-insert-layer img_cadre calque_fond_cadre_2 0 -1)

	; copier visible
	(gimp-edit-copy-visible img_cadre)

	; coller et ancrer
	(gimp-floating-sel-anchor (car (gimp-edit-paste calque_fond_cadre_2 TRUE)))

	; retourner H et V
	(gimp-flip calque_fond_cadre_2 0)
	(gimp-flip calque_fond_cadre_2 1)


	
	
	


; calque_fond_cadre_3*********************************************************************************
	

	; crer calque_fond_cadre_3
	(set! calque_fond_cadre_3 (car (gimp-layer-new img_cadre largeur_cadre_definitif hauteur_cadre_definitif 1 "calque_fond_cadre_3" 100 0)))	
	
	; ajouter le calque calque_fond_cadre_3
	(gimp-image-insert-layer img_cadre calque_fond_cadre_3 0 -1)

	; modifier couleur de premier plan
	(gimp-context-set-foreground '(0 0 0))				

	; modifier couleur d'arrire plan
	(gimp-context-set-background '(0 0 0))

	; crer une brosse
	(gimp-brush-new "brosse_cadre_volute")				
	
	; crer et slectionner brosse
	(gimp-context-set-brush "brosse_cadre_volute")	
	(gimp-brush-set-shape "brosse_cadre_volute" 0) ; forme ronde
	(gimp-brush-set-radius "brosse_cadre_volute" 1) ; rayon
	(gimp-brush-set-spikes "brosse_cadre_volute" 2) ; pointes
	(gimp-brush-set-hardness "brosse_cadre_volute" 1) ; duret 
	(gimp-brush-set-aspect-ratio "brosse_cadre_volute" 1) ; proportions
	(gimp-brush-set-angle "brosse_cadre_volute" 0) ; angle
	(gimp-brush-set-spacing "brosse_cadre_volute" 1) ; espacement

	; slectionner brosse
	(gimp-context-set-brush "brosse_cadre_volute")
	
	; contenu des 4 valeurs de array
	(aset *array_points_brosse* 0 0)
	(aset *array_points_brosse* 1 0)
	(aset *array_points_brosse* 2 (* Nombre_de_rangees_de_motif height_motif_cadre)  )
	(aset *array_points_brosse* 3 (* Nombre_de_rangees_de_motif height_motif_cadre)  )

	; appliquer pinceau
	(gimp-paintbrush 
			calque_fond_cadre_3			; drawable
			2 							; fade-out
			4 							; num-strokes 
			*array_points_brosse* 		; strokes 
			1 							; method 
			0				 			; gradient-length
	)	
	
	; contenu des 4 valeurs de array
	(aset *array_points_brosse* 0 largeur_cadre_definitif)
	(aset *array_points_brosse* 1 0)
	(aset *array_points_brosse* 2 (- largeur_cadre_definitif (* Nombre_de_rangees_de_motif height_motif_cadre) )  )
	(aset *array_points_brosse* 3 (* Nombre_de_rangees_de_motif height_motif_cadre)  )

	; appliquer pinceau
	(gimp-paintbrush 
			calque_fond_cadre_3			; drawable
			2 							; fade-out
			4 							; num-strokes 
			*array_points_brosse* 		; strokes 
			1 							; method 
			0				 			; gradient-length
	)	
	
	; contenu des 4 valeurs de array
	(aset *array_points_brosse* 0 largeur_cadre_definitif)
	(aset *array_points_brosse* 1 hauteur_cadre_definitif)
	(aset *array_points_brosse* 2 (- largeur_cadre_definitif (* Nombre_de_rangees_de_motif height_motif_cadre) )  )
	(aset *array_points_brosse* 3 (- hauteur_cadre_definitif (* Nombre_de_rangees_de_motif height_motif_cadre) )  )

	; appliquer pinceau
	(gimp-paintbrush 
			calque_fond_cadre_3			; drawable
			2 							; fade-out
			4 							; num-strokes 
			*array_points_brosse* 		; strokes 
			1 							; method 
			0				 			; gradient-length
	)

	; contenu des 4 valeurs de array
	(aset *array_points_brosse* 0 0)
	(aset *array_points_brosse* 1 hauteur_cadre_definitif)
	(aset *array_points_brosse* 2 (* Nombre_de_rangees_de_motif height_motif_cadre)  )
	(aset *array_points_brosse* 3 (- hauteur_cadre_definitif (* Nombre_de_rangees_de_motif height_motif_cadre) )  )

	; appliquer pinceau
	(gimp-paintbrush 
			calque_fond_cadre_3			; drawable
			2 							; fade-out
			4 							; num-strokes 
			*array_points_brosse* 		; strokes 
			1 							; method 
			0				 			; gradient-length
	)
	
	; supprimer la brosse
	(gimp-brush-delete "brosse_cadre_volute")	
	
	; opacit du calque  40%
	(gimp-layer-set-opacity calque_fond_cadre_3	40)
	



	
; calque_couleur_cadre*********************************************************************************
	

	; crer calque_couleur_cadre
	(set! calque_couleur_cadre (car (gimp-layer-new img_cadre largeur_cadre_definitif hauteur_cadre_definitif 1 "calque_couleur_cadre" 100 0)))	
	
	; ajouter le calque calque_couleur_cadre
	(gimp-image-insert-layer img_cadre calque_couleur_cadre 0 -1)

	; modifier couleur de premier plan
	(gimp-context-set-foreground Couleur_du_cadre)				

	; modifier couleur d'arrire plan
	(gimp-context-set-background Couleur_du_cadre)	
	
	; remplir de PP	
	(gimp-drawable-fill calque_couleur_cadre 0)	
	
	; opacit du calque  60%
	(gimp-layer-set-opacity calque_couleur_cadre 60)	
	
	; mettre en mode couleur	
	(gimp-layer-set-mode calque_couleur_cadre 13)	
	
	; crer une slection rectangulaire
	(gimp-image-select-rectangle
		img_cadre					; image 
		0							; operation 
		0							; x 
		0							; y 
		1							; width 
		1							; height
	)
	
	; copier visible
	(gimp-edit-copy-visible img_cadre)

	; ne rien slectionner
	(gimp-selection-none img_cadre)	





	
	
	
	
; calque_interieur_cadre*********************************************************************************
	

	; crer calque_interieur_cadre
	(set! calque_interieur_cadre (car (gimp-layer-new img_cadre width_cadre height_cadre 1 "calque_interieur_cadre" 100 0)))	
	
	; ajouter le calque calque_interieur_cadre
	(gimp-image-insert-layer img_cadre calque_interieur_cadre 0 -1)	
	
	; dplacer le calque
	(gimp-layer-translate calque_interieur_cadre (* Nombre_de_rangees_de_motif height_motif_cadre) (* Nombre_de_rangees_de_motif height_motif_cadre) )
	
	; crer une slection rectangulaire
	(gimp-image-select-rectangle
		img_cadre											; image 
		0													; operation 
		(* Nombre_de_rangees_de_motif height_motif_cadre)	; x 
		(* Nombre_de_rangees_de_motif height_motif_cadre)	; y 
		width_cadre											; width 
		height_cadre										; height
	)	
	
	; sauvegarder cette slection dans un chemin
	(plug-in-sel2path 1 img_cadre calque_interieur_cadre)

	; donner un nom au chemin
	(gimp-item-set-name (car (gimp-image-get-active-vectors img_cadre)) "interieur_cadre")	

	
	
	

	
	

;*******************************************************************************************
	
	; restaurer PP et AP
	(gimp-context-set-foreground  old-fg_cadre)
	(gimp-context-set-background old-bg_cadre)
	
	; restaurer ancien dgrad
	(gimp-context-set-gradient old_gradient_cadre)
	
	; restaurer brosse
	(gimp-context-set-brush old-brush_cadre)

	; restaurer motif
	(gimp-context-set-pattern old_pattern_cadre)


	; afficher l'image
	(gimp-display-new img_cadre)

	; End undo group
	(gimp-image-undo-group-end img_cadre)	

	)
)













(script-fu-register
	"Motif_Volute_et_Cadre"
	"<Image>/File/Create/Patterns/Motif Volute..."
	"Motif avec volutes"
	"samj"
	"samj"
	"2012-06-29"
	""
	SF-ADJUSTMENT "Largeur motif paire / Width Pattern Value Pair (pixels)"  '(24 16 64 2 4 0 1) ; pixels
	SF-ADJUSTMENT "Hauteur motif paire / Height Pattern Value Pair (pixels)"  '(16 16 64 2 4 0 1) ; pixels
	SF-TOGGLE "Appliquer un flou / Blurring" TRUE
	SF-ADJUSTMENT "Valeur du flou / Blur value"  '(1 1 6 1 2 0 1) ; pixels
	SF-TOGGLE "Afficher les images des motifs / Show pictures of the patterns" TRUE
	SF-TOGGLE "Sauvegarder les motifs / Save the patterns" FALSE
	SF-ADJUSTMENT "Reserve / Reserved"  '(0 0 0 1 1 0 1) ; 1 appel via cration de motif
)


(script-fu-register
	"Cadre_Volute_et_Cadre"
	"<Image>/File/Create/Decor/Cadre avec volutes..."
	"Cadre avec volutes"
	"samj"
	"samj"
	"2012-06-29"
	""
	SF-ADJUSTMENT "Largeur interieure du cadre / Inner Width of the frame (pixels)"  '(240 240 4800 1 10 0 1) ; pixels
	SF-ADJUSTMENT "Hauteur interieure du cadre / Inner Height of the frame (pixels)"  '(160 160 3200 1 10 0 1) ; pixels
	SF-ADJUSTMENT "Nombre de rangees de motif / Number of Rows of the pattern "  '(2 1 10 1 2 0 1) ; pixels
	SF-COLOR "Couleur du cadre" '(164 133 48) ; a48530
	SF-ADJUSTMENT "Dimension du motif / Size of the pattern"  '(1 1 10 1 2 2 2) ; coeff

)



; FIN du script
