; Script-Fu Papier_Embosse.scm
; Download : 
;
;	Copyright (C) 2013 samj ( http://aljacom.com/~gmic/ )
;
;	Licence GPL
;		Ce fichier est le Script-Fu "Papier_Embosse.scm" pour Gimp. 
;		Ce Script-Fu "Papier_Embosse.scm" est un logiciel libre ; vous pouvez le redistribuer ou le modifier suivant les termes de la GNU General Public License
;		telle que publie par la Free Software Foundation ; soit la version 3 de la licence, soit ( votre gr) toute version ultrieure.
;		Ce Script-Fu "Papier_Embosse.scm" est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; 
;		pas mme la garantie implicite de COMMERCIABILISABILIT ni d'ADQUATION  UN OBJECTIF PARTICULIER.
;		Consultez la GNU General Public License pour plus de dtails.
;		Vous devez avoir reu une copie de la GNU General Public License en mme temps que GIMP ; si ce n'est pas le cas, consultez <http://www.gnu.org/licenses>
;
;	Ce fichier Papier_Embosse.scm est dit avec Notepad++    http://notepad-plus-plus.org/
;
;
;
;
;	Version 20130405 Origine.  voir si intressant
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;
;	Accs sur l'image par :
;
;	Couleurs > Embossed Paper ...
;	Colors > Embossed Paper ...
;
;
;	Filtres > Mappage > Embossed Image ...
;	Filters > Map > Embossed Image ...
;
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;


;******************************************************************************************************
; FONCTION fonction_embosse_samj
;******************************************************************************************************


(define	
	(
		fonction_embosse_samj
		image
		drawable
		Invert_the_relief
		Contrasts
		Blur


		
	)

	(let* 
		(
			(matrix 0)
			(matrix-list 0)
			(channels 0)
		)

		(if (= Contrasts 0)
			(begin

				(set! matrix-list
					'(
						0		0		0		0		0
						0		2		2		-2		0
						0		0		-2		0		0
						0		4		-2		-2		0
						0		0		0		0		0
					 )
				)

			)
			;else
			(begin

				(set! matrix-list
					'(
						0		0		0		0		0
						0		3		3		-3		0
						0		0		-2		0		0
						0		5		-3		-3		0
						0		0		0		0		0
					 )
				)

			)
		)

		(set! channels (make-vector 5 'long ))

		(vector-set! channels 0 1 )
		(vector-set! channels 1 1 )
		(vector-set! channels 2 1 )
		(vector-set! channels 3 1 )
		(vector-set! channels 4 1 )

		; Convert maxtrix list (25) into matrix array (5x5)
		(define (get-matrix matrix-list)
		  (let* (
				(n 0)
				)
		  (set! n 25 )
		  (define (list-ref l n) (nth n l))
			(let* ((count 0)
				   (matrix (cons-array 25 'double)))
			  (while (< count 25 )
			  (aset matrix count (list-ref matrix-list count))
			  (set! count (+ count 1)))
			  matrix ; Return the matrix array
			)
		  )
		)

		; (plug-in-convmatrix run-mode image drawable argc-matrix matrix alpha-alg divisor offset argc-channels channels bmode)
		(plug-in-convmatrix 1 image drawable 25 (set! matrix (get-matrix matrix-list)) 1 1 128 5 channels 0)

		(gimp-item-set-visible drawable TRUE)

		(gimp-desaturate-full drawable 2)

		(if (= Invert_the_relief 1)  (gimp-invert drawable) )

		(if (> Blur 0) 
			(plug-in-gauss 1 image drawable Blur  Blur   1)
		)


	)
)





;******************************************************************************************************
; FIN FONCTION fonction_embosse_samj
;******************************************************************************************************




;******************************************************************************************************
; DBUT papier_embosse_samj
;******************************************************************************************************


		
(define	
	(
		papier_embosse_samj
		image
		drawable
		Invert_the_relief
		Contrasts
		Blur
		color
		Boost


		
	)
	(let* 
		(

			(message (car (gimp-message-get-handler)))
			(old_context_transform_direction (car (gimp-context-get-transform-direction)))
			(old_context_interpolation (car (gimp-context-get-interpolation)))
			(old_context_recursion (car (gimp-context-get-transform-recursion)))
			(old_context_transform_resize (car (gimp-context-get-transform-resize)))
			(old-fg (car (gimp-context-get-foreground)))
			(old-bg (car (gimp-context-get-background)))

			(old_context-antialias (car (gimp-context-get-antialias)))
			(old_context-feather (car (gimp-context-get-feather)))
			(old_context-feather-radiusx (car (gimp-context-get-feather-radius)))
			(old_context-feather-radiusy (cadr (gimp-context-get-feather-radius)))
			(old_context-sample-merged (car (gimp-context-get-sample-merged)))
			(old_ontext-sample-criterion (car (gimp-context-get-sample-criterion)))
			(old_context-sample-threshold (car (gimp-context-get-sample-threshold)))
			(old_context-sample-transparent (car (gimp-context-get-sample-transparent)))

			(old-brush-size (car (gimp-context-get-brush-size)))
			(old-brush-aspect-ratio (car (gimp-context-get-brush-aspect-ratio)))
			(old-brush-angle (car (gimp-context-get-brush-angle)))
			(old-brush-name (car (gimp-context-get-brush)))
			
			(old-pattern (car (gimp-context-get-pattern)))

			(width (car (gimp-image-width image)))
			(height (car (gimp-image-height image)))

			(transparence (car (gimp-drawable-has-alpha drawable)))

			(selection_en_cours)
			(nouvelle_image)
			(calque_copie)
			(copier_visible)
			(buffer-name "copier_visible")





		)


		(gimp-context-set-antialias FALSE)
		(gimp-context-set-feather FALSE)
		(gimp-context-set-feather-radius 0 0)
		(gimp-context-set-sample-merged FALSE)
		(gimp-context-set-sample-criterion 0)
		(gimp-context-set-sample-threshold 0)
		(gimp-context-set-sample-transparent FALSE)

		(gimp-context-set-transform-direction TRANSFORM-FORWARD)
		(gimp-context-set-interpolation 2)
		(gimp-context-set-transform-recursion 3)
		(gimp-context-set-transform-resize TRANSFORM-RESIZE-ADJUST)
		
		(gimp-context-set-paint-mode 0) ;

		
		(gimp-undo-push-group-start image)

		(gimp-selection-none image)





;******************************************************************************************************
; 
;******************************************************************************************************


		(set! copier_visible (car (gimp-edit-named-copy-visible image buffer-name)))

		; crer une nouvelle image rgb
		(set! nouvelle_image (car (gimp-image-new width height 0)))

		(gimp-undo-push-group-start nouvelle_image)

		; crer le premier calque
		(set! calque_copie (car (gimp-layer-new nouvelle_image width height 0 "calque_copie" 100 0)))

		(gimp-image-insert-layer nouvelle_image calque_copie -1 0)

		(gimp-image-select-rectangle nouvelle_image 0  width height 0 0 )

		(set! selection_en_cours (car (gimp-edit-named-paste calque_copie copier_visible 0)))

		(gimp-floating-sel-anchor selection_en_cours)

		(gimp-selection-none nouvelle_image)

		; ajuster taille image  la taille des calques
		(gimp-image-resize-to-layers nouvelle_image)

		(set! calque_copie (car (gimp-image-get-active-layer nouvelle_image)))

		(gimp-layer-flatten calque_copie)

		(if (= Boost 1) (fonction_embosse_samj nouvelle_image calque_copie Invert_the_relief Contrasts Blur) )

		(fonction_embosse_samj nouvelle_image calque_copie Invert_the_relief Contrasts Blur)



		(plug-in-colorify 1 nouvelle_image calque_copie color)







		(gimp-selection-none nouvelle_image)

		(gimp-undo-push-group-end nouvelle_image)
		(gimp-display-new nouvelle_image)



;******************************************************************************************************
; 
;******************************************************************************************************







;******************************************************************************************************

		;; rtablir le mode message
		(gimp-message-set-handler message)

		(gimp-context-set-transform-direction old_context_transform_direction )
		(gimp-context-set-interpolation old_context_interpolation)
		(gimp-context-set-transform-recursion old_context_recursion)
		(gimp-context-set-transform-resize old_context_transform_resize)
		(gimp-context-set-background old-bg)
		(gimp-context-set-foreground old-fg)


		(gimp-context-set-antialias old_context-antialias)
		(gimp-context-set-feather old_context-feather)
		(gimp-context-set-feather-radius old_context-feather-radiusx old_context-feather-radiusy)
		(gimp-context-set-sample-merged old_context-sample-merged)
		(gimp-context-set-sample-criterion old_ontext-sample-criterion)
		(gimp-context-set-sample-threshold old_context-sample-threshold)
		(gimp-context-set-sample-transparent old_context-sample-transparent)

		(gimp-context-set-brush-default-size)
		(gimp-context-set-brush-size old-brush-size)
		(gimp-context-set-brush-aspect-ratio old-brush-aspect-ratio)
		(gimp-context-set-brush-angle old-brush-angle)		
		(gimp-context-set-brush old-brush-name)

		(gimp-context-set-pattern old-pattern)

		(gimp-undo-push-group-end image)
		(gimp-displays-flush)


	)
)





(script-fu-register "papier_embosse_samj"
                    _"<Image>/Colors/Embossed Paper ..."
                    "Embossed Paper ..."
                    "samj"
                    "samj"
                    "20130407"
                    "*"
                    SF-IMAGE    "Image"     0
                    SF-DRAWABLE "Drawable"  0
					SF-TOGGLE "Invert the relief " FALSE
					SF-TOGGLE "Contrasts " FALSE
					SF-ADJUSTMENT "Blur " '(4 0 20 1 5 0 1)
					SF-COLOR "Color " '(255 194 248)
					SF-TOGGLE "Boost " FALSE

)


;******************************************************************************************************
; FIN papier_embosse_samj
;******************************************************************************************************




;******************************************************************************************************
; DBUT image_embossee
;******************************************************************************************************


(define	
	(
		image_embossee_samj
		image
		drawable
		Invert_the_relief
		Contrasts
		Blur
		azimuth			; azimuth 
		elevation		; elevation 
		depth			; depth 
		xofs			; xofs 
		yofs			; yofs 
		Boost

		
	)
	(let* 
		(

			(message (car (gimp-message-get-handler)))
			(old_context_transform_direction (car (gimp-context-get-transform-direction)))
			(old_context_interpolation (car (gimp-context-get-interpolation)))
			(old_context_recursion (car (gimp-context-get-transform-recursion)))
			(old_context_transform_resize (car (gimp-context-get-transform-resize)))
			(old-fg (car (gimp-context-get-foreground)))
			(old-bg (car (gimp-context-get-background)))

			(old_context-antialias (car (gimp-context-get-antialias)))
			(old_context-feather (car (gimp-context-get-feather)))
			(old_context-feather-radiusx (car (gimp-context-get-feather-radius)))
			(old_context-feather-radiusy (cadr (gimp-context-get-feather-radius)))
			(old_context-sample-merged (car (gimp-context-get-sample-merged)))
			(old_ontext-sample-criterion (car (gimp-context-get-sample-criterion)))
			(old_context-sample-threshold (car (gimp-context-get-sample-threshold)))
			(old_context-sample-transparent (car (gimp-context-get-sample-transparent)))

			(old-brush-size (car (gimp-context-get-brush-size)))
			(old-brush-aspect-ratio (car (gimp-context-get-brush-aspect-ratio)))
			(old-brush-angle (car (gimp-context-get-brush-angle)))
			(old-brush-name (car (gimp-context-get-brush)))
			
			(old-pattern (car (gimp-context-get-pattern)))

			(width (car (gimp-image-width image)))
			(height (car (gimp-image-height image)))

			(transparence (car (gimp-drawable-has-alpha drawable)))

			(selection_en_cours)
			(nouvelle_image)
			(calque_copie)
			(copier_visible)
			(buffer-name "copier_visible")

			(calque_image_embossee)



		)


		(gimp-context-set-antialias FALSE)
		(gimp-context-set-feather FALSE)
		(gimp-context-set-feather-radius 0 0)
		(gimp-context-set-sample-merged FALSE)
		(gimp-context-set-sample-criterion 0)
		(gimp-context-set-sample-threshold 0)
		(gimp-context-set-sample-transparent FALSE)

		(gimp-context-set-transform-direction TRANSFORM-FORWARD)
		(gimp-context-set-interpolation 2)
		(gimp-context-set-transform-recursion 3)
		(gimp-context-set-transform-resize TRANSFORM-RESIZE-ADJUST)
		
		(gimp-context-set-paint-mode 0) ;

		
		(gimp-undo-push-group-start image)

		(gimp-selection-none image)





;******************************************************************************************************
; 
;******************************************************************************************************


		(set! copier_visible (car (gimp-edit-named-copy-visible image buffer-name)))

		; crer une nouvelle image rgb
		(set! nouvelle_image (car (gimp-image-new width height 0)))

		(gimp-undo-push-group-start nouvelle_image)

		; crer le premier calque
		(set! calque_copie (car (gimp-layer-new nouvelle_image width height 0 "calque_copie" 100 0)))

		(gimp-image-insert-layer nouvelle_image calque_copie -1 0)

		(gimp-image-select-rectangle nouvelle_image 0  width height 0 0 )

		(set! selection_en_cours (car (gimp-edit-named-paste calque_copie copier_visible 0)))

		(gimp-floating-sel-anchor selection_en_cours)

		(gimp-selection-none nouvelle_image)

		; ajuster taille image  la taille des calques
		(gimp-image-resize-to-layers nouvelle_image)

		(set! calque_copie (car (gimp-image-get-active-layer nouvelle_image)))

		(gimp-layer-flatten calque_copie)

		(if (= Boost 1) (fonction_embosse_samj nouvelle_image calque_copie Invert_the_relief Contrasts Blur) )

		(fonction_embosse_samj nouvelle_image calque_copie Invert_the_relief Contrasts Blur)


		; calque calque_image_embossee
		(set! calque_image_embossee (car (gimp-layer-new nouvelle_image width height 0 "calque_image_embossee" 100 0)))

		(gimp-image-insert-layer nouvelle_image calque_image_embossee -1 0)

		(gimp-image-select-rectangle nouvelle_image 0  width height 0 0 )

		(set! selection_en_cours (car (gimp-edit-named-paste calque_image_embossee copier_visible 0)))

		(gimp-floating-sel-anchor selection_en_cours)

		(gimp-selection-none nouvelle_image)

		(plug-in-bump-map 
			1				; run-mode 
			nouvelle_image	; image 
			calque_image_embossee	; drawable 
			calque_copie	; bumpmap 
			azimuth			; azimuth 
			elevation		; elevation 
			depth			; depth 
			xofs			; xofs 
			yofs			; yofs 
			0				; waterlevel 
			0				; ambient 
			1				; compensate 
			0				; invert 
			0				; type
		)





		(gimp-undo-push-group-end nouvelle_image)
		(gimp-display-new nouvelle_image)



;******************************************************************************************************
; 
;******************************************************************************************************







;******************************************************************************************************

		;; rtablir le mode message
		(gimp-message-set-handler message)

		(gimp-context-set-transform-direction old_context_transform_direction )
		(gimp-context-set-interpolation old_context_interpolation)
		(gimp-context-set-transform-recursion old_context_recursion)
		(gimp-context-set-transform-resize old_context_transform_resize)
		(gimp-context-set-background old-bg)
		(gimp-context-set-foreground old-fg)


		(gimp-context-set-antialias old_context-antialias)
		(gimp-context-set-feather old_context-feather)
		(gimp-context-set-feather-radius old_context-feather-radiusx old_context-feather-radiusy)
		(gimp-context-set-sample-merged old_context-sample-merged)
		(gimp-context-set-sample-criterion old_ontext-sample-criterion)
		(gimp-context-set-sample-threshold old_context-sample-threshold)
		(gimp-context-set-sample-transparent old_context-sample-transparent)

		(gimp-context-set-brush-default-size)
		(gimp-context-set-brush-size old-brush-size)
		(gimp-context-set-brush-aspect-ratio old-brush-aspect-ratio)
		(gimp-context-set-brush-angle old-brush-angle)		
		(gimp-context-set-brush old-brush-name)

		(gimp-context-set-pattern old-pattern)

		(gimp-undo-push-group-end image)
		(gimp-displays-flush)


	)
)





(script-fu-register "image_embossee_samj"
                    _"<Image>/Filters/Map/Embossed Image ..."
                    "Embossed Image ..."
                    "samj"
                    "samj"
                    "20130407"
                    "*"
                    SF-IMAGE    "Image"     0
                    SF-DRAWABLE "Drawable"  0
					SF-TOGGLE "Invert the relief " FALSE
					SF-TOGGLE "Contrasts " FALSE
					SF-ADJUSTMENT "Blur " '(4 0 20 1 5 0 1)
					SF-ADJUSTMENT "Azimuth " '(135 0 360 1 5 0 1)
					SF-ADJUSTMENT "Elevation " '(45 0.5 90 1 5 2 1)
					SF-ADJUSTMENT "Depth " '(12 1 65 1 5 0 1)
					SF-ADJUSTMENT "X Offset " '(1 -10 10 1 5 0 1)
					SF-ADJUSTMENT "Y offset " '(1 -10 10 1 5 0 1)
					SF-TOGGLE "Boost " FALSE

)


;******************************************************************************************************
; FIN image_embossee
;******************************************************************************************************







;; FIN





