; Script-Fu  Selection_Paths_Iterative_Reduction_1.scm
; Download : http://gimpchat.com/viewtopic.php?f=9&t=7678
;
;	Copyright (C) 2013 samj ( http://www.aljacom.com/ )
;
;	Licence GPL
;		Ce fichier est le Script-Fu "Selection_Paths_Iterative_Reduction_1.scm" pour Gimp. 
;		Ce Script-Fu "Selection_Paths_Iterative_Reduction_1.scm" est un logiciel libre ; vous pouvez le redistribuer ou le modifier suivant les termes de la GNU General Public License
;		telle que publie par la Free Software Foundation ; soit la version 3 de la licence, soit ( votre gr) toute version ultrieure.
;		Ce Script-Fu "Selection_Paths_Iterative_Reduction_1.scm" est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; 
;		pas mme la garantie implicite de COMMERCIABILISABILIT ni d'ADQUATION  UN OBJECTIF PARTICULIER.
;		Consultez la GNU General Public License pour plus de dtails.
;		Vous devez avoir reu une copie de la GNU General Public License en mme temps que GIMP ; si ce n'est pas le cas, consultez <http://www.gnu.org/licenses>
;
;	Ce fichier Selection_Paths_Iterative_Reduction_1.scm est dit avec Notepad++    http://notepad-plus-plus.org/
;
;
;
;
;
;
;
;	Version 0.1 du 20130626
;	Version 2 du 20130626 ajout option visibilit des chemins "Set the visibility of the paths (for merging ... manually ... ) " et modification accs : Paths Iterative Reduction/Increase (Isohypse) ...
;	Version 3 du 20130626 ajout augmentation (Increase) sur une ide de Mario Bross, merci :o) avec 3 modes o le remplissage varie.
;	Version 4 du 20130628 ajout d'une possibilit de faire varier l'espace entre les chemins : Variation Of Distance Between The Paths et paramtrage distance pour "Variation +" "Variation -"
;	Version 5 du 20130628 ajout slectionner le calque d'origine automatiquement
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;	Les slections sont rduites selon le paramtre de rduction et sauvegardes en chemins.
;
;	The selections are reduced by the reduction parameter and saved as paths.
;
;
;
;
;	Accs sur l'image avec une slection active par :
;	Selection > Paths Iterative Reduction/Increase (Isohypse) ...
;
;	Access on the image with an active selection by :
;	Select > Paths Iterative Reduction/Increase (Isohypse) ...
;
;
;
;
;
;
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;
;
;
;
;
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;


(define	
	(
		Selection_Paths_Iterative_Reduction_1_samj
		image
		drawable
		Reduction_VS_Increase
		Reduction_en_pixels
		Current_Selection_AND_Reverse_Selection
		Set_the_visibility_of_the_paths
		Choix_Utilisateur_Variation_Of_Distance_Between_The_Paths
		Coefficient_Of_Variation



	)
	(let* 
		(

			(message (car (gimp-message-get-handler)))



			(width (car (gimp-image-width image)))
			(height (car (gimp-image-height image)))

			(transparence (car (gimp-drawable-has-alpha drawable)))

			(Carateristiques_Selection (gimp-selection-bounds image))
			(Selection_Existe (car Carateristiques_Selection))
			(Selection_X1 (cadr Carateristiques_Selection))
			(Selection_Y1 (caddr Carateristiques_Selection))
			(Selection_X2 (cadr (cddr Carateristiques_Selection)))
			(Selection_Y2 (caddr (cddr Carateristiques_Selection)))


			(Canal_Selection_Origine)
			(Nom_du_chemin)
			(sortie_boucle 0)
			(Nb_boucles 0)
			(Variation_Espacement_Entre_Chemins 0)


		)





		; pour image existante
		(gimp-undo-push-group-start image) 

		;; Start undo. Recommand par Saulgoode pour nouvelle image http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		; (gimp-image-undo-disable image)

		; sauvegard le contexte.  Recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		(gimp-context-push)

		;; slectionner la console erreurs pour envoyer un message
		(gimp-message-set-handler 2)		


;******************************************************************************************************
; 
;******************************************************************************************************

		; (gimp-message (string-append "Selection_Existe : " (number->string Selection_Existe) " X1-Y1/X2-Y2 : " (number->string Selection_X1)   "-"    (number->string Selection_Y1)  "/"  (number->string Selection_X2) "-"   (number->string Selection_Y2)                ) )	
		; (gimp-message (string-append " eX-eY : " (number->string Centre_Ellipse_X)   "-"    (number->string Centre_Ellipse_Y) ) )

		(if (= Selection_Existe 0)
			(begin
				(gimp-message "No selection! / Aucune selection!")
			)
			;else , une slection est active
			(begin

				; sauvegarde de la slection dans un canal
				(set! Canal_Selection_Origine (car (gimp-selection-save image) ) )

				; sauvegarde de la selection dans un chemin
				(plug-in-sel2path 1 image drawable)

				; donner un nom au chemin
				(set! Nom_du_chemin "origine" )
				(gimp-item-set-name (car (gimp-image-get-active-vectors image)) Nom_du_chemin )
				(if (= Set_the_visibility_of_the_paths 1) (gimp-item-set-visible (car (gimp-image-get-active-vectors image)) 1) )



				;******************************************************************************************************
				; boucle pour les slections rduites  partir de l'origine
				;******************************************************************************************************
				(set! sortie_boucle 0)
				(set! Nb_boucles 0)

				(while
					(= sortie_boucle 0)
						(begin

							(set! Nb_boucles (+ Nb_boucles 1) )

							(if (= Choix_Utilisateur_Variation_Of_Distance_Between_The_Paths 0) (set! Variation_Espacement_Entre_Chemins (* Reduction_en_pixels Nb_boucles) )     )
							(if (= Choix_Utilisateur_Variation_Of_Distance_Between_The_Paths 1) (set! Variation_Espacement_Entre_Chemins (+  (* Coefficient_Of_Variation Nb_boucles (- Nb_boucles 1)) (* Reduction_en_pixels Nb_boucles) ) )     )
							(if (= Choix_Utilisateur_Variation_Of_Distance_Between_The_Paths 2)
								(begin
									; (gimp-message (number->string (* Coefficient_Of_Variation Nb_boucles (- Nb_boucles 1)) ) )
									(if (>  (* Coefficient_Of_Variation Nb_boucles (- Nb_boucles 1))   Reduction_en_pixels  )
										; minimum atteint
										(set! sortie_boucle 1 )
									;else
										(set! Variation_Espacement_Entre_Chemins (-  (* Reduction_en_pixels Nb_boucles) (* Coefficient_Of_Variation Nb_boucles (- Nb_boucles 1))  ) )
									)
								)
							)
							
							(if (= Choix_Utilisateur_Variation_Of_Distance_Between_The_Paths 3) (set! Variation_Espacement_Entre_Chemins   (+ 1 (* Reduction_en_pixels Nb_boucles) (- (rand Reduction_en_pixels) Reduction_en_pixels))     )     )

							; (gimp-message (strcat (number->string Choix_Utilisateur_Variation_Of_Distance_Between_The_Paths ) "-" (number->string Nb_boucles ) "-" (number->string Variation_Espacement_Entre_Chemins ) ) )

							(if (= Reduction_VS_Increase 0)
								(gimp-selection-shrink image Variation_Espacement_Entre_Chemins )
								;else
								(gimp-selection-grow image Variation_Espacement_Entre_Chemins )
							)

							(set! Carateristiques_Selection (gimp-selection-bounds image))
							(set! Selection_Existe (car Carateristiques_Selection))
							(set! Selection_X1 (cadr Carateristiques_Selection))
							(set! Selection_Y1 (caddr Carateristiques_Selection))
							(set! Selection_X2 (cadr (cddr Carateristiques_Selection)))
							(set! Selection_Y2 (caddr (cddr Carateristiques_Selection)))
							; (gimp-message (strcat (number->string Selection_Existe) "-" (number->string Selection_X1) "-" (number->string Selection_Y1) "-" (number->string Selection_X2) "-" (number->string Selection_Y2) )  )

							(if  (and (= Reduction_VS_Increase 1) (or (= Selection_X1 0) (= Selection_Y1 0) (= Selection_X2 width) (= Selection_Y2 height) ) ) (set! Selection_Existe 0) )
							(if  (and (= Reduction_VS_Increase 2) (= Selection_X1 0) (= Selection_Y1 0) (= Selection_X2 width) (= Selection_Y2 height) ) (set! Selection_Existe 0) )
							(if (= Reduction_VS_Increase 3)
								(begin
									; (gimp-message (strcat (number->string (car (gimp-selection-value image 0 0))) "-" (number->string (car (gimp-selection-value image (- width 1) 0))) "-" (number->string (car (gimp-selection-value image (- width 1) (- height 1)))) "-" (number->string (car (gimp-selection-value image 0 (- height 1)))) )  )
									(if (and (> (car (gimp-selection-value image 0 0)) 0)  (> (car (gimp-selection-value image (- width 1) 0)) 0)  (> (car (gimp-selection-value image (- width 1) (- height 1))) 0)  (> (car (gimp-selection-value image 0 (- height 1))) 0)  ) (set! Selection_Existe 0) )
								)
							)
			

							(if (= Selection_Existe 0)
								(begin
									(set! sortie_boucle 1 )
								)
								;else
								(begin

									; sauvegarde slection vers chemin
									(plug-in-sel2path 1 image drawable)

									; donner un nom au chemin
									(if (= Reduction_VS_Increase 0)
										(set! Nom_du_chemin (string-append "Reduction_"  (number->string Nb_boucles) ) )
										;else
										(set! Nom_du_chemin (string-append "Increase_"  (number->string Nb_boucles) ) )
									)
									(gimp-item-set-name (car (gimp-image-get-active-vectors image)) Nom_du_chemin )
									(if (= Set_the_visibility_of_the_paths 1) (gimp-item-set-visible (car (gimp-image-get-active-vectors image)) 1) )

									(gimp-selection-none image)

									(gimp-selection-load Canal_Selection_Origine)


								)
							)

						)
				)



				;******************************************************************************************************
				; boucle pour les slections inverses rduites  partir de l'origine
				;******************************************************************************************************
				(if (and (= Reduction_VS_Increase 0) (= Current_Selection_AND_Reverse_Selection 1) )
					(begin

						(set! sortie_boucle 0)
						(set! Nb_boucles 0)
						(gimp-selection-none image)

						(while
							(= sortie_boucle 0)
								(begin

									(set! Nb_boucles (+ Nb_boucles 1) )

									(gimp-selection-load Canal_Selection_Origine)

									(gimp-selection-invert image)

									(if (= Choix_Utilisateur_Variation_Of_Distance_Between_The_Paths 0) (set! Variation_Espacement_Entre_Chemins (* Reduction_en_pixels Nb_boucles) )     )
									(if (= Choix_Utilisateur_Variation_Of_Distance_Between_The_Paths 1) (set! Variation_Espacement_Entre_Chemins (+  (* Coefficient_Of_Variation Nb_boucles (- Nb_boucles 1)) (* Reduction_en_pixels Nb_boucles) ) )     )
									(if (= Choix_Utilisateur_Variation_Of_Distance_Between_The_Paths 2)
										(begin
											; (gimp-message (number->string (* Coefficient_Of_Variation Nb_boucles (- Nb_boucles 1)) ) )
											(if (>  (* Coefficient_Of_Variation Nb_boucles (- Nb_boucles 1))   Reduction_en_pixels  )
												; minimum atteint
												(set! sortie_boucle 1 )
											;else
												(set! Variation_Espacement_Entre_Chemins (-  (* Reduction_en_pixels Nb_boucles) (* Coefficient_Of_Variation Nb_boucles (- Nb_boucles 1))  ) )
											)
										)
									)
									(if (= Choix_Utilisateur_Variation_Of_Distance_Between_The_Paths 3) (set! Variation_Espacement_Entre_Chemins   (+ 1 (* Reduction_en_pixels Nb_boucles) (- (rand Reduction_en_pixels) Reduction_en_pixels))     )     )

									; (gimp-message (strcat (number->string Choix_Utilisateur_Variation_Of_Distance_Between_The_Paths ) "|" (number->string Nb_boucles ) "|" (number->string Variation_Espacement_Entre_Chemins ) ) )

									(if (< Variation_Espacement_Entre_Chemins 2) (set! Variation_Espacement_Entre_Chemins 2) )
									(gimp-selection-shrink image Variation_Espacement_Entre_Chemins )

									(set! Carateristiques_Selection (gimp-selection-bounds image))
									(set! Selection_Existe (car Carateristiques_Selection))
									; (set! Selection_X1 (cadr Carateristiques_Selection))
									; (set! Selection_Y1 (caddr Carateristiques_Selection))
									; (set! Selection_X2 (cadr (cddr Carateristiques_Selection)))
									; (set! Selection_Y2 (caddr (cddr Carateristiques_Selection)))
									; (gimp-message (strcat (number->string Selection_Existe) "-" (number->string Selection_X1) "-" (number->string Selection_Y1) "-" (number->string Selection_X2) "-" (number->string Selection_Y2) )  )

									(if (= Selection_Existe 0)
										(begin
											(set! sortie_boucle 1 )
										)
										;else
										(begin

											; sauvegarde slection vers chemin
											(plug-in-sel2path 1 image drawable)

											; donner un nom au chemin
											(set! Nom_du_chemin (string-append "Reverse_"  (number->string Nb_boucles) ) )
											(gimp-item-set-name (car (gimp-image-get-active-vectors image)) Nom_du_chemin )
											(if (= Set_the_visibility_of_the_paths 1) (gimp-item-set-visible (car (gimp-image-get-active-vectors image)) 1) )

											(gimp-selection-none image)


										)
									)

								)
						)


					)
				)




				(gimp-selection-none image)

				(gimp-selection-load Canal_Selection_Origine)
				
				(gimp-image-set-active-layer image drawable)

			)
		)


;******************************************************************************************************
; 
;******************************************************************************************************

		;; rtablir le mode message
		(gimp-message-set-handler message)

		; restituer l'ancien contexte.  Recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		(gimp-context-pop)

		; End undo. Recommand par Saulgoode pour nouvelle image http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		;(gimp-image-undo-enable image)

		; pour image existante
		(gimp-undo-push-group-end image)

		(gimp-displays-flush)

	)
)





; Nouvelle mthode recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
(script-fu-register "Selection_Paths_Iterative_Reduction_1_samj"
                    _"Paths Iterative Reduction/Increase (Isohypse) ..."
                    "Paths Iterative Reduction/Increase (Isohypse) ..."
                    "samj"
                    "samj"
                    "20130626"
                    "*"
                    SF-IMAGE    "Image"     0
                    SF-DRAWABLE "Drawable"  0
					SF-OPTION "Reduction VS Increase " '("Reduction" "Increase Mode 1" "Increase Mode 2" "Increase Mode 3")
					SF-ADJUSTMENT "Reduction/Increase (pixels) " '(10 2 50 1 5 2 1)
					SF-TOGGLE "Current Selection AND Reverse Selection (mode Reduction) " FALSE
					SF-TOGGLE "Set The Visibility Of The Paths (for merging ... manually ... ) " FALSE
					SF-OPTION "Variation Of Distance Between The Paths " '("No variation" "Variation +" "Variation -" "Random Spacing"  )
					SF-ADJUSTMENT "Coefficient Of Variation Of Distance (Variation + , Variation -) " '(1 0.5 8 1 5 2 1)
					





)

; Nouvelle mthode recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
(script-fu-menu-register "Selection_Paths_Iterative_Reduction_1_samj"
					_"<Image>/Select"
)




;; FIN





