; Dbut du script-fu Wallpaper_Abstract_Glass_Art_gimp_2_8.scm
;
; Accs par :   Fichier > Crer > Wallpaper > Abstract Glass Art......
;               File > Create > Wallpaper > Abstract Glass Art......
;
;                __________________________________________________________
; 
;
; Script-fu cr  partir d'une adaptation du didacticiel : Abstract Glass Art (mygimptutorial.com)
;                                                           http://mygimptutorial.com/abstract-glass-art
;
;
;
;
;
;
; Licence GNU/GPL
;
; --------------------------------------------------------------------
; version 1.0 par samj (www.aljacom.com/~gimp) 2010/12/26
; version 2.0 par samj (www.aljacom.com/~gimp) 2010/12/26 pour gimp 2.7.2
;
; --------------------------------------------------------------------
;
;

(define (
				Wallpaper_Abstract_Glass_Art
				Largeur_fond
				Hauteur_fond
				Couleur_du_fond
				degrade
				Surechantillonnage_adaptatif
				Mode_2
				Aire_luninosite_contraste
				Colorisation
				2_vs_3_calques
		)

		
	(let*
		(
			; affectation des variables			

			(message (car (gimp-message-get-handler)))
			
			; mmoriser les couleurs PP et AP
			(old-fg (car (gimp-context-get-foreground)))
			(old-bg (car (gimp-context-get-background)))
			
			; mmoriser le dgrad actif
			(old_gradient (car (gimp-context-get-gradient)))
			
			; crer une nouvelle image rgb
			(img (car (gimp-image-new Largeur_fond Hauteur_fond 0)))
			
			; calque_fond
			(calque_fond)
			
			; calcul dimensions aire
			(diametre_luninosite_contraste (* Hauteur_fond (/ (* 2 Aire_luninosite_contraste) 100)))			

			; calque_2
			(calque_2)
			
			; calque_Colorisation
			(calque_Colorisation)

			
		)

	;; Start undo group.
	(gimp-image-undo-group-start img)		

	;; slectionner la console erreurs pour envoyer un message
	(gimp-message-set-handler 2)	
	

	

; calque_fond********************************************************************************
	
	; crer calque_fond
	(set! calque_fond (car (gimp-layer-new img Largeur_fond Hauteur_fond 1 "calque_fond" 100 0)))	
	
	; ajouter le calque calque_fond
	(gimp-image-insert-layer img calque_fond -1 0)

	; choisir Couleur_du_fond pp
	(gimp-context-set-foreground Couleur_du_fond)
	
	; remplir de blanc
	(gimp-drawable-fill calque_fond 0)

	; slectionner le dgrad choisi
	(gimp-context-set-gradient degrade)	
	
;****
	
	; appliquer un dgrad sur calque calque_fond
	(gimp-edit-blend 
					calque_fond ; drawable
					3 ; blend-mode		CUSTOM-MODE (3) 
					6 ; paint-mode		DIFFERENCE-MODE (6)
					2 ; gradient-type   GRADIENT-RADIAL (2)
					100 ; opacity
					0 ; offset
					0 ; repeat
					FALSE ; reverse
					Surechantillonnage_adaptatif ; supersample
					3 ; max-depth
					0.2 ; threshold
					TRUE ; dither
					0 ; x1 
					0 ; y1 
					Largeur_fond ; x2
					Hauteur_fond ; y2
	)	
	
	
	; appliquer un dgrad sur calque calque_fond
	(gimp-edit-blend 
					calque_fond ; drawable
					3 ; blend-mode		CUSTOM-MODE (3) 
					6 ; paint-mode		DIFFERENCE-MODE (6)
					2 ; gradient-type   GRADIENT-RADIAL (2)
					100 ; opacity
					0 ; offset
					0 ; repeat
					FALSE ; reverse
					Surechantillonnage_adaptatif ; supersample
					3 ; max-depth
					0.2 ; threshold
					TRUE ; dither
					Largeur_fond ; x1 
					Hauteur_fond ; y1 
					0 ; x2
					0 ; y2
	)	
	

	; appliquer un dgrad sur calque calque_fond
	(gimp-edit-blend 
					calque_fond ; drawable
					3 ; blend-mode		CUSTOM-MODE (3) 
					6 ; paint-mode		DIFFERENCE-MODE (6)
					2 ; gradient-type   GRADIENT-RADIAL (2)
					100 ; opacity
					0 ; offset
					0 ; repeat
					FALSE ; reverse
					Surechantillonnage_adaptatif ; supersample
					3 ; max-depth
					0.2 ; threshold
					TRUE ; dither
					Largeur_fond ; x1 
					0 ; y1 
					0 ; x2
					Hauteur_fond ; y2
	)


	; appliquer un dgrad sur calque calque_fond
	(gimp-edit-blend 
					calque_fond ; drawable
					3 ; blend-mode		CUSTOM-MODE (3) 
					6 ; paint-mode		DIFFERENCE-MODE (6)
					2 ; gradient-type   GRADIENT-RADIAL (2)
					100 ; opacity
					0 ; offset
					0 ; repeat
					FALSE ; reverse
					Surechantillonnage_adaptatif ; supersample
					3 ; max-depth
					0.2 ; threshold
					TRUE ; dither
					0 ; x1 
					Hauteur_fond ; y1 
					Largeur_fond ; x2
					0 ; y2
	)

;****

	; mode de centrage Mode_2
	(if 
		(= Mode_2 FALSE)
			(begin

				; appliquer un dgrad sur calque calque_fond
					(gimp-edit-blend 
									calque_fond ; drawable
									3 ; blend-mode		CUSTOM-MODE (3) 
									6 ; paint-mode		DIFFERENCE-MODE (6)
									2 ; gradient-type   GRADIENT-RADIAL (2)
									100 ; opacity
									0 ; offset
									0 ; repeat
									FALSE ; reverse
									Surechantillonnage_adaptatif ; supersample
									3 ; max-depth
									0.2 ; threshold
									TRUE ; dither
									0 ; x1
									Hauteur_fond ; y1
									(/ Largeur_fond 2); x2 
									(/ Hauteur_fond 2) ; y2 
					)

	
					; appliquer un dgrad sur calque calque_fond
					(gimp-edit-blend 
									calque_fond ; drawable
									3 ; blend-mode		CUSTOM-MODE (3) 
									6 ; paint-mode		DIFFERENCE-MODE (6)
									2 ; gradient-type   GRADIENT-RADIAL (2)
									100 ; opacity
									0 ; offset
									0 ; repeat
									FALSE ; reverse
									Surechantillonnage_adaptatif ; supersample
									3 ; max-depth
									0.2 ; threshold
									TRUE ; dither
									0 ; x1
									0 ; y1
									(/ Largeur_fond 2); x2 
									(/ Hauteur_fond 2) ; y2
					)
	
	
					; appliquer un dgrad sur calque calque_fond
					(gimp-edit-blend 
									calque_fond ; drawable
									3 ; blend-mode		CUSTOM-MODE (3) 
									6 ; paint-mode		DIFFERENCE-MODE (6)
									2 ; gradient-type   GRADIENT-RADIAL (2)
									100 ; opacity
									0 ; offset
									0 ; repeat
									FALSE ; reverse
									Surechantillonnage_adaptatif ; supersample
									3 ; max-depth
									0.2 ; threshold
									TRUE ; dither
									Largeur_fond ; x1
									0 ; y1
									(/ Largeur_fond 2); x2 
									(/ Hauteur_fond 2) ; y2 
					)

					; appliquer un dgrad sur calque calque_fond
					(gimp-edit-blend 
									calque_fond ; drawable
									3 ; blend-mode		CUSTOM-MODE (3) 
									6 ; paint-mode		DIFFERENCE-MODE (6)
									2 ; gradient-type   GRADIENT-RADIAL (2)
									100 ; opacity
									0 ; offset
									0 ; repeat
									FALSE ; reverse
									Surechantillonnage_adaptatif ; supersample
									3 ; max-depth
									0.2 ; threshold
									TRUE ; dither
									Largeur_fond ; x1
									Hauteur_fond ; y1
									(/ Largeur_fond 2); x2 
									(/ Hauteur_fond 2) ; y2 
					)
					
					; selection circulaire partie + claire
					(gimp-ellipse-select 
									img ; image 
									(- Largeur_fond (/ diametre_luninosite_contraste 2)) ; (* -1 (/ diametre_luninosite_contraste 2)) ; x 
									(- Hauteur_fond (/ diametre_luninosite_contraste 2)) ; (* -1 (/ diametre_luninosite_contraste 2))  ; y 
									diametre_luninosite_contraste ; width 
									diametre_luninosite_contraste ; height 
									0 ; operation 
									TRUE ; antialias 
									TRUE ; feather 
									5 ; feather-radius
					)
					
					; modifier luminosit contrastes
					(gimp-brightness-contrast calque_fond -60 20)
					
					; ne rien slectionner
					(gimp-selection-none img)

					; selection circulaire partie + fonce
					(gimp-ellipse-select 
									img ; image 
									(* -1 (/ diametre_luninosite_contraste 2)) ; (- Largeur_fond (/ diametre_luninosite_contraste 2)) ;  ; x 
									(- Hauteur_fond (/ diametre_luninosite_contraste 2)) ; (* -1 (/ diametre_luninosite_contraste 2))  ; y 
									diametre_luninosite_contraste ; width 
									diametre_luninosite_contraste ; height 
									0 ; operation 
									TRUE ; antialias 
									TRUE ; feather 
									5 ; feather-radius
					)
					
					; modifier luminosit contrastes
					(gimp-brightness-contrast calque_fond 70 45)
					
					; ne rien slectionner
					(gimp-selection-none img)					
			
			)
			; else
			(begin

				; appliquer un dgrad sur calque calque_fond
					(gimp-edit-blend 
									calque_fond ; drawable
									3 ; blend-mode		CUSTOM-MODE (3) 
									6 ; paint-mode		DIFFERENCE-MODE (6)
									2 ; gradient-type   GRADIENT-RADIAL (2)
									100 ; opacity
									0 ; offset
									0 ; repeat
									FALSE ; reverse
									Surechantillonnage_adaptatif ; supersample
									3 ; max-depth
									0.2 ; threshold
									TRUE ; dither
									(/ Largeur_fond 2); x1 
									(/ Hauteur_fond 2) ; y1 
									0 ; x2
									Hauteur_fond ; y2
					)

	
					; appliquer un dgrad sur calque calque_fond
					(gimp-edit-blend 
									calque_fond ; drawable
									3 ; blend-mode		CUSTOM-MODE (3) 
									6 ; paint-mode		DIFFERENCE-MODE (6)
									2 ; gradient-type   GRADIENT-RADIAL (2)
									100 ; opacity
									0 ; offset
									0 ; repeat
									FALSE ; reverse
									Surechantillonnage_adaptatif ; supersample
									3 ; max-depth
									0.2 ; threshold
									TRUE ; dither
									(/ Largeur_fond 2); x1 
									(/ Hauteur_fond 2) ; y1 
									0 ; x2
									0 ; y2
					)
	
	
					; appliquer un dgrad sur calque calque_fond
					(gimp-edit-blend 
									calque_fond ; drawable
									3 ; blend-mode		CUSTOM-MODE (3) 
									6 ; paint-mode		DIFFERENCE-MODE (6)
									2 ; gradient-type   GRADIENT-RADIAL (2)
									100 ; opacity
									0 ; offset
									0 ; repeat
									FALSE ; reverse
									Surechantillonnage_adaptatif ; supersample
									3 ; max-depth
									0.2 ; threshold
									TRUE ; dither
									(/ Largeur_fond 2); x1 
									(/ Hauteur_fond 2) ; y1 
									Largeur_fond ; x2
									0 ; y2
					)

					; appliquer un dgrad sur calque calque_fond
					(gimp-edit-blend 
									calque_fond ; drawable
									3 ; blend-mode		CUSTOM-MODE (3) 
									6 ; paint-mode		DIFFERENCE-MODE (6)
									2 ; gradient-type   GRADIENT-RADIAL (2)
									100 ; opacity
									0 ; offset
									0 ; repeat
									FALSE ; reverse
									Surechantillonnage_adaptatif ; supersample
									3 ; max-depth
									0.2 ; threshold
									TRUE ; dither
									(/ Largeur_fond 2); x1 
									(/ Hauteur_fond 2) ; y1 
									Largeur_fond ; x2
									Hauteur_fond ; y2
					)

					; selection circulaire partie centrale
					(gimp-ellipse-select 
									img ; image 
									(- (/ Largeur_fond 2) (/ diametre_luninosite_contraste 2)) ; (- Largeur_fond (/ diametre_luninosite_contraste 2)) ; (* -1 (/ diametre_luninosite_contraste 2)) ; x 
									(- (/ Hauteur_fond 2) (/ diametre_luninosite_contraste 2)) ; (- Hauteur_fond (/ diametre_luninosite_contraste 2)) ; (* -1 (/ diametre_luninosite_contraste 2))  ; y 
									diametre_luninosite_contraste ; width 
									diametre_luninosite_contraste ; height 
									0 ; operation 
									TRUE ; antialias 
									TRUE ; feather 
									5 ; feather-radius
					)
					
					; modifier luminosit contrastes
					(gimp-brightness-contrast calque_fond -100 25)
					
					; ne rien slectionner
					(gimp-selection-none img)	
			)
	)


	; appliquer flou
	;(plug-in-gauss run-mode image drawable horizontal vertical method)
	(plug-in-gauss 1 img calque_fond 2 2 1)


; calque_2**********************************************************************************

	; copier le calque de fond
	(set! calque_2 (car (gimp-layer-copy calque_fond TRUE)))

	; Add a layer
	(gimp-image-insert-layer img calque_2 -1 0)
	
	; donner un nom 
	(gimp-item-set-name calque_2 "calque_2")
	
	; dsaturer
	(gimp-desaturate-full calque_2 0)
	

	


; calque_Colorisation************************************************************************

	; crer calque
	(set! calque_Colorisation (car (gimp-layer-copy calque_2 TRUE)))

	; Add a layer
	(gimp-image-insert-layer img calque_Colorisation -1 0)
	
	; donner un nom 
	(gimp-item-set-name calque_Colorisation "calque_Colorisation")

	; choisir la couleur Colorisation
	(gimp-context-set-foreground  Colorisation)
	
	; remplir de couleur Colorisation
	(gimp-drawable-fill calque_Colorisation 0)
	
	; passer le calque en mode color
	(gimp-layer-set-mode calque_Colorisation 13)
	

; 2_vs_3_calques****************************************************************************
	
	; passer  2 calques
	(if 
		(= 2_vs_3_calques TRUE)
			(begin
			
				; merge down
				(set! calque_2 (car (gimp-image-merge-down img calque_Colorisation 0)))


			)
		;else
			(begin
			
				; passer le calque en mode overlay
				(gimp-layer-set-mode calque_Colorisation 5)


			)
		
	)
	


	; mettre opacit  75
	(gimp-layer-set-opacity calque_2 75)

	
	
;********************************************************************************************


	
	;; rtablir le mode message
	(gimp-message-set-handler message)
	
	; restaurer PP et AP
	(gimp-context-set-foreground  old-fg)
	(gimp-context-set-background old-bg)

	; restaurer ancien dgrad
	(gimp-context-set-gradient old_gradient)

	
	; ne rien slectionner
	(gimp-selection-none img)
	
	; afficher l'image
	(gimp-display-new img)

	;; End undo group.
	(gimp-image-undo-group-end img)	

	)
		
)

(script-fu-register
	"Wallpaper_Abstract_Glass_Art"
	"<Image>/File/Create/Wallpaper/Abstract Glass Art..."
	"Fond d'ecran / Wallpaper... "
	"samj"
	"samj"
	"2010-12-26"
	""
	SF-ADJUSTMENT "Largeur fond / Background width [pixels] "  '(1024 100 4000 1 10 0 0)
	SF-ADJUSTMENT "Hauteur fond / Background height [pixels] "  '(768 100 4000 1 10 0 0)
	SF-COLOR "Couleur du fond / Background color " '(255 255 255) 
	SF-GRADIENT "Degrade / Gradient " "Land 1"
	SF-TOGGLE "Surechantillonnage adaptatif / Adaptive supersampling "    FALSE
	SF-TOGGLE "Mode 2 "    FALSE
	SF-ADJUSTMENT "Rayon aire luninosite-contraste / Brightness-contrast area [% height] "  '(45 0 100 1 10 0 0)
	SF-COLOR "Colorisation / Colorize " '(170 226 144) 
	SF-TOGGLE "2 vs 3 calques / 2 vs 3 layers "    TRUE
	
)

; FIN du script